#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "rtp_api.h"

/* Define the magic number */
#define AUDIO_FILE_MAGIC                ((u_32)0x2e736e64)
#define MAX_PACKET_SIZE 8000

/* Define the encoding fields */
#define AUDIO_FILE_ENCODING_MULAW_8     (1)     /* 8-bit ISDN u-law */
#define AUDIO_FILE_ENCODING_LINEAR_8    (2)     /* 8-bit linear PCM */
#define AUDIO_FILE_ENCODING_LINEAR_16   (3)     /* 16-bit linear PCM */
#define AUDIO_FILE_ENCODING_LINEAR_24   (4)     /* 24-bit linear PCM */
#define AUDIO_FILE_ENCODING_LINEAR_32   (5)     /* 32-bit linear PCM */
#define AUDIO_FILE_ENCODING_FLOAT       (6)     /* 32-bit IEEE floating point */
#define AUDIO_FILE_ENCODING_DOUBLE      (7)     /* 64-bit IEEE floating point */
#define AUDIO_FILE_ENCODING_ADPCM_G721  (23)    /* 4-bit CCITT g.721 ADPCM */
#define AUDIO_FILE_ENCODING_ADPCM_G722  (24)    /* CCITT g.722 ADPCM */
#define AUDIO_FILE_ENCODING_ADPCM_G723_3 (25)   /* CCITT g.723 3-bit ADPCM */
#define AUDIO_FILE_ENCODING_ADPCM_G723_5 (26)   /* CCITT g.723 5-bit ADPCM */
#define AUDIO_FILE_ENCODING_ALAW_8      (27)    /* 8-bit ISDN A-law */

typedef unsigned long int u_32;

typedef struct {
        u_32            magic;          /* magic number */
        u_32            hdr_size;       /* size of this header */
        u_32            data_size;      /* length of data (optional) */
        u_32            encoding;       /* data encoding format */
        u_32            sample_rate;    /* samples per second */
        u_32            channels;       /* number of interleaved channels */
} Audio_filehdr;

