#include <malloc.h>
#include "dstring.h"

/*
* Add elements to dynamically growing string buffer.
*/
char *DStringAppend(DString *d, char *string, int length)
{
  if (d->length + length + 1 >= d->spaceAvl) {
    if (!d->spaceAvl) {
      d->string = malloc(length + 1);  
      d->spaceAvl = length + 1;
    }
    d->spaceAvl *= 1.5;
    if (d->spaceAvl < d->length + length + 1) {
      d->spaceAvl += length + 1;
    }
    d->string = realloc(d->string, d->spaceAvl);
  }
  strncpy(d->string[d->length], string, length);
  d->length += length;
  d->string[d->length] = '\0';
  return d->string;
} /* DStringAppend */


void DStringInit(DString *d)
{
  d->length   = 0;
  d->spaceAvl = 0;
  d->string   = 0;
} /* DStringInit */


char *DStringValue(DString *d)
{
  return d->string;
} /* */
