#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <pthread.h> /* pthread_cond_signal(pthread_cond_t *cond) */
#include <sys/uio.h>
#include <sys/timeb.h>
#include <winsock2.h> /* struct timeval */
#include <io.h>
#include <direct.h> /* _getcwd() */
#include <lmaccess.h>

#include "sysdep.h"


//#define PTHREAD_DEBUG
int enable_log = 1;

/* Debug-Trace functions */
void pthread_log_print(int type);
void pthread_log_entered(int type,
                         char *file,int line, char *m_name,void *m,
                         char *c_name, void *c);
void pthread_log_exiting(int type,
                         void *m,
                         void *c);
void pthread_log_created(int type, char *name, void *th);

int condnum = 0;


/* returns 1 if c exists in string 
* else returns 0 */ 
int match(char c, char *str, int size)
{
  int i;
  for (i=0; i<size; i++) {
    if ( c == *(str+i)) 
      return 1;
  }
  return 0;
}

char *strtok_r(char *s1, char *s2, char **lasts) 
{

  /* Win32 strtok() is not reentrant !.
   * We use our own implementation, which is
   * not very efficient.
   */

  char *ret = NULL;
  int i, size;

  if ( s1 ) {
    ret = s1;
  }
  else if ( lasts && *lasts ) {
    ret = *lasts;
  }
  else {
    /* No s1 and no memory in lasts */
    return NULL;
  }

  /* Return the whole string if s2 is empty */
  size = strlen(s2);
  if ( size <= 0 ) {
    if ( lasts ) {
      *lasts = NULL;
    }
    return ret;
  }

  /* Loop through */
  for ( i=0; *(ret+i); i++) {
    if ( match( *(ret+i), s2, size) )  {
      /* Match found */
      break;
    }
  }

  if ( *(ret+i) == '\0' ) {
    /* End of stream */
    if ( lasts ) {
      *lasts = NULL;
      return ret;
    }
  }
  else {
    /* Update *lasts */
    if ( lasts ) {
      *lasts = (ret+i);
      while ( *lasts && match(**lasts, s2, size) ) {
        (*lasts) ++;
      }
      if ( !(**lasts) ) {
        *lasts = NULL;
      }
    }
    /* This should be after the loop */
    *(ret+i) = '\0';
  }

  return ret;
}

double drand48() {

	srand( (unsigned)time( NULL ) );

	return (double)rand()/RAND_MAX;

}

int writev(int fildes, const struct iovec *iov, int iovcnt) {
	int relnum=0;	/* The real number of bytes written to fildes */
	int i;

	for (i=0; i<iovcnt; i++)
		relnum += write(fildes, iov[i].iov_base, iov[i].iov_len);

	return relnum;
}

int gettimeofday(struct timeval *tp, void *t) {
  struct _timeb tv;

  _ftime(&tv);
  tp->tv_sec = tv.time;
  tp->tv_usec = tv.millitm*1000;

  return 1;
} 

void openlog(const char *ident, int logopt, int facility) {
}

void syslog(int priority, const char *message, ... /* arguments */) {
}

void closelog(void) {
}

struct group *getgrnam(const char *name) {
  struct group *ent;

  ent = malloc(sizeof(struct group));
  ent->gr_gid = 0;
  ent->gr_name = strdup(" ");
  ent->gr_passwd = strdup(" ");
  ent->gr_mem = NULL;

  return ent;
}

int uname(struct utsname *name) {
  strcpy(name->uname, "WindowsNT");
  return 1;
}

long gethostid(void) {
  LARGE_INTEGER lg;

  QueryPerformanceCounter(&lg);
  return (lg.LowPart & 0x000000000000FFFF);
}

long getuid(void) {
  return GetDoubleClickTime(); /* What is this ??? */
}

int setuid(uid_t uid) {
  return 0;
}

long getgid(void) {
  long gid;
  char cwd[128], *c;

  gid = 0;
  _getcwd(cwd, 128);
  c = cwd;
  if (c != NULL) {
    while(*c != '\0') {
      gid += *c;
      c++;
	}
  }
  return gid;
}

int setgid(gid_t gid) {
  return 0;
}

uid_t geteuid(void) {
  return 1;
}



/* ------------ Release Version of pthread_functions -------------- */

pthread_t pthread_self(void)
{
  return GetCurrentThreadId();
}

int pthread_create_r(pthread_t *th, const void *attr, 
                     void * (*start_func)(void *), void *arg) {
  DWORD  th_id;

  if ((*th = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)start_func, 
      (LPVOID)(arg), 0, (LPDWORD)(&(th_id)))) == NULL)
    return 1;
  else
	return 0;
}

void pthread_cancel_r(pthread_t th) {
  DWORD  dwExitCode = 0;

  if(!TerminateThread(th, dwExitCode)) 
    debug("pthread_cancel", "Warning: TerminateThread did not succeed...\n");
  
	return;
}


void pthread_cancel_d(pthread_t th) {
  DWORD  dwExitCode = 0;

  if(!TerminateThread(th, dwExitCode)) 
    debug("pthread_cancel", "Warning: TerminateThread did not succeed...\n");
  
	return;
}

int pthread_exit_r(void *status)
{
  ExitThread((DWORD) status);
  return 0;
}

int pthread_join_r(pthread_t th, void ** value_ptr) 
{
  WaitForSingleObject(th, INFINITE);
  return 0;
}

int pthread_mutex_init_r(pthread_mutex_t *m, const void *attr) 
{
  *m = CreateMutex (NULL, FALSE, NULL);
  return 0;
}

int pthread_mutex_destroy_r(pthread_mutex_t *m) 
{
  if ( *m != NULL ) {
    CloseHandle(*m);
  }
  return 0;
}

int pthread_mutex_lock_r(pthread_mutex_t *m)
{
  if (!(*m)) 
    *m = CreateMutex(NULL, FALSE, NULL); 

  WaitForSingleObject(*m, INFINITE );

  return 0;
}

int pthread_mutex_unlock_r(pthread_mutex_t *m) 
{
  if ( *m != NULL ) {
    ReleaseMutex(*m);
  }
  return 0;
}

int pthread_cond_init_r(pthread_cond_t *cond, const pthread_condattr_t *attr) {
  char name[10];

  sprintf(name, "cond%d", condnum);
  condnum++;
  *cond = CreateSemaphore(NULL, 0, 1, name);
  return 0; 
}

int pthread_cond_destroy_r(pthread_cond_t *cond) 
{
  if (*cond != NULL) {
    CloseHandle(*cond);
  }
  return 0;
}

int pthread_cond_signal_r(pthread_cond_t *cond) 
{
  if (*cond == NULL) {
    pthread_cond_init_r(cond,NULL);
  }

  ReleaseSemaphore(*cond, 1, NULL);
  return 0;
}

int pthread_cond_broadcast_r(pthread_cond_t *cond) 
{
  if (*cond == NULL) {
    pthread_cond_init_r(cond,NULL);
  }

  while (1) 
  {
    LONG prevcount = 1;
    ReleaseSemaphore(*cond, 1, &prevcount);
    if ( prevcount != 0 ) 
    {
      break;
    }
  }
  return 0;
}

int pthread_cond_timedwait_r(pthread_cond_t *cond,
          pthread_mutex_t *mutex,
          const struct timespec *abstime) 
{
  DWORD dwStatus;
  struct timeval tp;
  DWORD dwInterval;

  if (*cond == NULL) {
    pthread_cond_init_r(cond,NULL);
  }

  gettimeofday(&tp, NULL);

  dwInterval = (DWORD) (abstime->tv_sec > tp.tv_sec) ? (abstime->tv_sec - tp.tv_sec)* 1000 : 0;
  dwInterval += (DWORD) ((abstime->tv_nsec - tp.tv_usec * 1000) / 1e6);

  ReleaseMutex(*mutex);  /* Release the mutex */
  if ( ((int) dwInterval) > 0 ) { 
    dwStatus = WaitForSingleObject(*cond, dwInterval); /* Wait for cond */
  }
  else {
    dwStatus = WAIT_TIMEOUT;
  }

  WaitForSingleObject(*mutex, INFINITE); /* Regain the mutex */

  if (dwStatus == WAIT_TIMEOUT)
	  return ETIMEDOUT;
  return 0;
}

int pthread_cond_wait_r(pthread_cond_t *cond,
          pthread_mutex_t *mutex) 
{
  DWORD dwStatus;

  if (*cond == NULL) {
    pthread_cond_init_r(cond,NULL);
  }

  ReleaseMutex(*mutex);  /* Release the mutex */
  dwStatus = WaitForSingleObject(*cond, INFINITE); /* Wait for cond */
  WaitForSingleObject(*mutex, INFINITE); /* Regain the mutex */

  return 0;
}

/* ------------ Debug Version of pthread_functions -------------- */
int pthread_create_d(pthread_t *th, const void *attr, 
                     void * (*start_func)(void *), void *arg,
                     char *th_name, char* file, int line) {
  DWORD  th_id;
  int oReturn;

  if ((*th = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)start_func, 
      (LPVOID)(arg), 0, (LPDWORD)(&(th_id)))) == NULL)
    oReturn = 1;
  else
	  oReturn = 0;

#ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_create(%s) = %p (%s)\n",
    file,line, th_name, *th, (!oReturn ? "Successful" : "Failed" ));
#endif

  //pthread_log_created(0,th_name, *th); commented out because 
  // there is no way to remote the thread information from the list.

  return oReturn;
}

int pthread_exit_d(void *status)
{
  pthread_log_exiting(0, GetCurrentThread(), 0);
  ExitThread((DWORD)status);
  return 0;
}

int pthread_join_d(pthread_t th, void ** value_ptr,
                   char *th_name, char *file, int line) 
{
#ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_join(%s) (%s)\n",
    file,line, th_name, "Entered" );
#endif

  WaitForSingleObject(th, INFINITE);
  
  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_join(%s) (%s)\n",
    file,line, th_name, "Exiting" );
  #endif

  return 0;
}

int pthread_mutex_init_d(pthread_mutex_t *m, const void *attr,
                         char *m_name, char *file, int line) 
{
  *m = CreateMutex (NULL, FALSE, NULL);

  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_mutex_init(%s) = %p\n",
    file,line, m_name, *m);
  #endif

  return 0;
}

int pthread_mutex_destroy_d(pthread_mutex_t *m,
                            char *m_name, char *file, int line) 
{
  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_mutex_destroy(%s = %p)\n",
    file,line, m_name, *m);
  #endif

  if ( *m != NULL ) {
    pthread_log_exiting(1,*m, NULL);
    CloseHandle(*m);
  }
  return 0;
}

int pthread_mutex_lock_d(pthread_mutex_t *m,
                         char *m_name, char *file, int line)
{
  if (!(*m)) 
  {
    #ifdef PTHREAD_DEBUG
    debug(NULL,
      "%s:%d\n\tCreating since it is NULL\n",
      file,line);
    #endif

    *m = CreateMutex(NULL, FALSE, NULL); 
  }

  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_mutex_lock(%s = %p) %s by %p\n",
    file,line, m_name, *m, "Entered", GetCurrentThread());
  #endif

  WaitForSingleObject(*m, INFINITE );

  pthread_log_entered(1,file,line,m_name,*m, NULL, 0);

  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_mutex_lock(%s = %p) %s by %p\n",
    file,line, m_name, *m, "Exiting", GetCurrentThread());
  #endif

  return 0;
}

int pthread_mutex_unlock_d(pthread_mutex_t *m,
                           char *m_name, char *file, int line) 
{
  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_mutex_unlock(%s = %p) by %p\n",
    file,line, m_name, *m, GetCurrentThread());
  #endif

  if (*m != NULL) {
    pthread_log_exiting(1,*m, NULL);
    ReleaseMutex(*m);
  }
  return 0;
}

int pthread_cond_init_d(pthread_cond_t *c, const pthread_condattr_t *attr,
                        char *c_name, char *file, int line) 
{
  char name[10];

  sprintf(name, "cond%d", condnum);
  condnum++;
  *c = CreateSemaphore(NULL, 0, 1, name);

  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_cond_init(%s) = %p\n",
    file,line, c_name, *c);
  #endif

  return 0; 
}

int pthread_cond_destroy_d(pthread_cond_t *c,
                           char *c_name, char *file, int line) 
{
  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_cond_destroy(%s = %p)\n",
    file,line, c_name, *c);
  #endif

  if (*c != NULL) {
    pthread_log_exiting(2,0, *c);
    CloseHandle(*c);
  }
  return 0;
}

int pthread_cond_signal_d(pthread_cond_t *c,
                          char *c_name, char *file, int line) 
{
  if (*c == NULL) {
    pthread_cond_init_d(c,NULL,c_name,file,line);
  }

  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_cond_signal(%s = %p) by %p\n",
    file,line, c_name, *c, GetCurrentThread());
  #endif

  ReleaseSemaphore(*c, 1, NULL);
  return 0;
}

int pthread_cond_broadcast_d(pthread_cond_t *cond,
                             char *c_name, char *file, int line) 
{
  if (*cond == NULL) {
    pthread_cond_init_d(cond,NULL,c_name,file,line);
  }

  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_cond_broadcast(%s = %p) %s by %p\n",
    file,line, c_name, *cond, "Entered", GetCurrentThread());
  #endif
  
  pthread_log_exiting(2,0, *cond);

  //do {  /* How do we implement broadcast */
  while (1) 
  {
    LONG prevcount = 1;
    ReleaseSemaphore(*cond, 1, &prevcount);
    if ( prevcount != 0 )
    {
      break;
    }
  }
  //} while ((dwStatus = WaitForSingleObject(*cond, 10)) == WAIT_TIMEOUT);

  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_cond_broadcast(%s = %p) %s by %p\n",
    file,line, c_name, *cond, "Exiting", GetCurrentThread());
  #endif
    
  return 0;
}

int pthread_cond_timedwait_d(pthread_cond_t *cond,
          pthread_mutex_t *mutex,
          const struct timespec *abstime,
          char *c_name, char *m_name, char *file, int line) 
{
  DWORD dwStatus;
  struct timeval tp;
  DWORD dwInterval;
  int oReturn;

  if (*cond == NULL) {
    pthread_cond_init_d(cond,NULL,c_name,file,line);
  }

  pthread_log_entered(2,file,line,m_name,*mutex, c_name, *cond);

  gettimeofday(&tp, NULL);

  dwInterval = (DWORD) (abstime->tv_sec > tp.tv_sec) ? (abstime->tv_sec - tp.tv_sec)* 1000 : 0;
  dwInterval += (DWORD) ((abstime->tv_nsec - tp.tv_usec * 1000) / 1e6);


  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_cond_timedwait(%s = %p, %s = %p) %s by %p for %d millisec\n",
    file,line, c_name, *cond, m_name, *mutex,
    "Entered", GetCurrentThread(), dwInterval);
  #endif
    
  pthread_log_exiting(1,*mutex, 0);
  ReleaseMutex(*mutex);  /* Release the mutex */

  if ( ((int) dwInterval) > 0 ) { 

    dwStatus = WaitForSingleObject(*cond, dwInterval); /* Wait for cond */
  }
  else
  {
    dwStatus = WAIT_TIMEOUT;
  }
  WaitForSingleObject(*mutex, INFINITE); /* Regain the mutex */
  pthread_log_entered(1,file,line,m_name,*mutex, NULL, 0);

  if (dwStatus == WAIT_TIMEOUT)
  {
	  oReturn = ETIMEDOUT;
  }
  else 
  {
    oReturn = 0;
  }

  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_cond_timedwait(%s = %p, %s = %p) %s by %p (%s)\n",
    file,line, c_name, *cond, m_name, *mutex,
    "Exiting", GetCurrentThread(), (oReturn == ETIMEDOUT ? "Timeout" : "not a timeout"));
  #endif

  pthread_log_exiting(2,0, *cond);

  return oReturn;
}

int pthread_cond_wait_d(pthread_cond_t *cond,
          pthread_mutex_t *mutex,
          char *c_name, char *m_name, char *file, int line) 
{
  DWORD dwStatus;

  if (*cond == NULL) {
    pthread_cond_init_d(cond,NULL,c_name,file,line);
  }

  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_cond_wait(%s = %p, %s = %p) %s by %p\n",
    file,line, c_name, *cond, m_name, *mutex,
    "Entered", GetCurrentThread());
  #endif
    
  pthread_log_entered(2,file,line,m_name,*mutex, c_name, *cond);

  pthread_log_exiting(1,*mutex, 0);

  ReleaseMutex(*mutex);  /* Release the mutex */
  dwStatus = WaitForSingleObject(*cond, INFINITE); /* Wait for cond */
  WaitForSingleObject(*mutex, INFINITE); /* Regain the mutex */

  pthread_log_entered(1,file,line,m_name,*mutex, NULL, 0);


  #ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_cond_wait(%s = %p, %s = %p) %s by %p\n",
    file,line, c_name, *cond, m_name, *mutex,
    "Exiting", GetCurrentThread());
  #endif
    
  pthread_log_exiting(2,0, *cond);

  return 0;
}

/* ------------------ End of debug version of pthread_functions ------ */

static char name[] = "unknown";

struct passwd *getpwnam(const char *name) {
//  LPBYTE *usri3buf;
//  USER_INFO_3 *usri3;
  struct passwd *pwd3;

//  NetUserGetInfo(NULL, name, 3, usri3buf);
//  usri3 = (USER_INFO_3 *)usri3buf;
  pwd3 = calloc(1, sizeof(struct passwd));
  pwd3->pw_name = name;

//  pwd3->pw_uid = usri3->usri3_user_id;
  return pwd3;
}

struct passwd *getpwuid(uid_t uid) {
//  LPBYTE *usri3buf;
//  USER_INFO_3 *usri3;
  struct passwd *pwd3;

//  NetUserGetInfo(NULL, name, 3, usri3buf);
//  usri3 = (USER_INFO_3 *)usri3buf;
  pwd3 = calloc(1, sizeof(struct passwd));
  pwd3->pw_name = name;
//  pwd3->pw_uid = usri3->usri3_user_id;
  return pwd3;
}

int kill(int pid, int flag) {
  HANDLE hProcess;

  hProcess = OpenProcess( PROCESS_ALL_ACCESS, FALSE, pid);
  if (hProcess) {
    hProcess = OpenProcess( PROCESS_ALL_ACCESS, FALSE, pid);
    if (hProcess == NULL) {
      return FALSE;
    }
    
    if (!TerminateProcess( hProcess, 1 )) {
      CloseHandle( hProcess );
      return FALSE;
    }
    
    CloseHandle( hProcess );
    return TRUE;
  }
  
  return 0;
}

/* changed the prototype to return int 
 and changed the logic to return EOF */
int getc_socket(FILE_SOCKET *f) {
  char c;
  if ( recv(*f, &c, 1, 0) > 0 )
  {
    return c;
  }
  else
  {
    return EOF;
  }
}

ssize_t write_socket(int fildes, const void *buf, size_t nbyte) {
	return send(fildes, buf, nbyte, 0);
}

struct tm *gmtime_r(const time_t *clock, struct tm *res) {
  struct tm *s;

  /* XXX lock the mutex for gmtime and mktime */
  s = gmtime(clock);
  if ( s != NULL ) {
    *res = *s;
  }
  else {
    memset(res, 0, sizeof(struct tm));
  }
  /* Unlock the mutex */
  return res;
}

char *getlogin()
{
  return "unknown";
}

char *cuserid(char *s)
{
  strcpy(s,"unknown");
  return s;
}


/** For debugging of Pthread_functiosn **********************/

#define DEBUG_NAME_SIZE   80

typedef struct pthread_mutex_debug_t {
  char file[PATH_MAX];
  int  line;
  char m_name[DEBUG_NAME_SIZE];
  void *m;
  void *th;
  struct pthread_mutex_debug_t *next;
} pthread_mutex_debug_t;

typedef struct pthread_cond_debug_t  {
  char file[PATH_MAX];
  int  line;
  char m_name[DEBUG_NAME_SIZE];
  char c_name[DEBUG_NAME_SIZE];
  void *m;
  void *c;
  void *th;
  struct pthread_cond_debug_t *next;
} pthread_cond_debug_t;

typedef struct pthread_debug_t {
  char th_name[DEBUG_NAME_SIZE];
  void *th;
  struct pthread_debug_t *next;
} pthread_debug_t;

static pthread_debug_t *t_list = NULL;
static pthread_mutex_debug_t *m_list = NULL;
static pthread_cond_debug_t *c_list = NULL;

static HANDLE mymutex;
static BOOL   initialized = FALSE;

#define MY_ENTER()                             \
  if ( enable_log == 0 ) return;               \
  if ( initialized == FALSE ) {                \
    mymutex = CreateMutex(NULL, FALSE, NULL);  \
    initialized = TRUE;                        \
  }                                            \
  WaitForSingleObject(mymutex,INFINITE)

#define MY_EXIT()   ReleaseMutex(mymutex)
#define MY_LIST_ADD(head,type,st) {            \
  type *ptr = (type *)malloc(sizeof(type));    \
  ptr->next = head;                            \
  head = ptr;                                  \
  st;                                          \
}
#define MY_LIST_DELETE(head,type,cond) {        \
  type *ptr,*prev;                              \
  ptr = head;                                   \
  if ( head ) {                                 \
    if ( cond ) {                               \
      head = head->next;                        \
      free(ptr);                                \
    }                                           \
    else {                                      \
    for ( prev=head;prev->next;prev = prev->next) { \
        ptr = prev->next;                       \
        if ( cond ) {                           \
          prev->next  = prev->next->next;       \
          free(ptr);                            \
          if ( prev->next == NULL ) break;      \
        }                                       \
      }                                         \
    }                                           \
  }                                             \
}

#define MY_LIST_PRINT(head,type,ty) {              \
type *ptr;                                    \
pthread_debug_t *t;pthread_mutex_debug_t *m;pthread_cond_debug_t *c; \
  for ( ptr=head;ptr;ptr = ptr->next) {               \
  if ( ty == 0 )                                      \
  {                                                   \
     t = (pthread_debug_t *)ptr;                      \
     fprintf(stderr,"%p: %s", t->th, t->th_name);     \
  }                                                   \
  else if ( ty == 1 )                                 \
  {                                                   \
    m = (pthread_mutex_debug_t *)ptr;                 \
    fprintf(stderr,"%p: %s by %p from %s:%d",         \
    m->m, m->m_name, m->th,                           \
    m->file, m->line);                                \
  }                                                   \
  else if ( ty == 2 )                                 \
  {                                                   \
    c = (pthread_cond_debug_t *) ptr;                 \
    fprintf(stderr,"%p: %s by %p (%p,%s) from %s:%d", \
    c->c, c->c_name, c->th, c->m,                     \
    c->m_name, c->file, c->line);                     \
  }                                                   \
  else                                                \
    fprintf(stderr,"Unknown type %d", ty);            \
  fprintf(stderr,"\n");                               \
  }                                                   \
}
       
void pthread_log_created(int type, char *name, void *th)
{
  MY_ENTER();

  switch(type) 
  {
  case 0:
    MY_LIST_ADD(t_list, pthread_debug_t, 
    { 
      strcpy(ptr->th_name,name); 
      ptr->th = th;
    } );
    break;
  case 1:
    break;
  case 2:
    break;
  }
  MY_EXIT();
}

void pthread_log_print(int type)
{
  MY_ENTER();
  switch(type)
  {
  case 0:
    MY_LIST_PRINT(t_list,pthread_debug_t,type);
    break;
  case 1: /* mutex */
    MY_LIST_PRINT(m_list,pthread_mutex_debug_t,type);
    break;
  case 2: /* condition */
    MY_LIST_PRINT(c_list,pthread_cond_debug_t,type);
    break;
  }
  MY_EXIT();
}

void pthread_log_entered(int type,
                         char *file,int line, char *m_name,void *m,
                         char *c_name, void *c)
{
  MY_ENTER();

  switch(type) 
  {
  case 0:
    break;
  case 1: /* mutex */
    MY_LIST_ADD(m_list, pthread_mutex_debug_t,
    { 
      strcpy(ptr->file,file); 
      ptr->line = line;
      strcpy(ptr->m_name,m_name);
      ptr->m = m;
      ptr->th = GetCurrentThread();
    } );
    break;
  case 2: /* condition */
    MY_LIST_ADD(c_list, pthread_cond_debug_t,
    { 
      strcpy(ptr->file,file); 
      ptr->line = line;
      strcpy(ptr->m_name,m_name);
      ptr->m = m;
      strcpy(ptr->c_name,c_name);
      ptr->c = c;
      ptr->th = GetCurrentThread();
    } );
    break;
  }

  MY_EXIT();
}

void pthread_log_exiting(int type,
                         void *m,
                         void *c)
{
  MY_ENTER();

  switch(type) 
  {
  case 0:
    MY_LIST_DELETE(t_list, pthread_debug_t, (ptr->th == m));
    break;
  case 1: /* mutex */
    MY_LIST_DELETE(m_list, pthread_mutex_debug_t, (ptr->m == m));
    break;
  case 2: /* condition */
    MY_LIST_DELETE(c_list, pthread_cond_debug_t, (ptr->c == c));
    break;
  }

  MY_EXIT();
}

int  pthread_equal_r(pthread_t t, pthread_t t1) {

  return (t == t1);

}

int  pthread_equal_d(pthread_t t, pthread_t t1) {

  return (t == t1);

}



#ifdef SIPLIB_EXTENSIONS

#define MAXTHREADS 1024

typedef struct {
  int active;     
  pthread_t myid;
} thread_id;

static thread_id thread_table[MAXTHREADS];
static pthread_mutex_t thread_mutex = PTHREAD_MUTEX_INITIALIZER;


typedef void* (*DFN)(void*);

typedef struct {
  DFN actual_function;
  void *param;
} thread_data;

static void add_thread(pthread_t t) {
  
  int i = 0;

  pthread_mutex_lock(&thread_mutex);

  for (i=0; i<MAXTHREADS; i++) {
    if (!thread_table[i].active) {
      thread_table[i].active = 1;
      thread_table[i].myid = t;
      break;
    }
  }

  if (i == MAXTHREADS) 
    debug("add_thread", "Warning: Too many active threads...\n");
    
  pthread_mutex_unlock(&thread_mutex);

  return;

} /* add_thread */


static void del_thread(pthread_t t) {

  int i = 0;

  pthread_mutex_lock(&thread_mutex);

  for (i = 0; i<MAXTHREADS; i++) {
    if (thread_table[i].active && 
    	pthread_equal(thread_table[i].myid, t)) {
      thread_table[i].active = 0;
      break;
    }
  }

  pthread_mutex_unlock(&thread_mutex);

  return;

} /* del_thread */


/*
 * instead of using cancellation handler's which cause
 * compatibility problems in Windows, simply use the "one
 * level indirection" approach to keep track of what functions
 * are executing.
 */
static void* dummyhandler(void *param) {
  
  thread_data* tdata = (thread_data*) param;

  add_thread(pthread_self());

  (*(tdata->actual_function))(tdata->param);

  del_thread(pthread_self());

  free(tdata);
  
  return NULL;
  
} /* dummyhandler */

int pthread_create_detached_r(pthread_t *th, const void *attr, 
                     void * (*start_func)(void *), void *arg) {
  DWORD  th_id;
  thread_data *tdata;

  tdata = (thread_data*) calloc(1, sizeof(thread_data));
 
  if (tdata) {
    tdata->actual_function = start_func;
    tdata->param = arg;
   
    /* tdata will be freed by dummyhandler...*/
   
    if ((*th = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)dummyhandler, 
      (LPVOID)(tdata), 0, (LPDWORD)(&(th_id)))) == NULL)
      return 1;
    else
	    return 0;
  }
  
  return 1;
}

/*
 * pthread_create_detached() for libsip++
 */
int pthread_create_detached_d(pthread_t *th, const void *attr, 
                     void * (*start_func)(void *), void *arg,
                     char *th_name, char* file, int line) {
  DWORD  th_id;
  int oReturn;

  thread_data *tdata;

  tdata = (thread_data*) calloc(1, sizeof(thread_data));
 
  if (tdata) {
    tdata->actual_function = start_func;
    tdata->param = arg;
   
    /* tdata will be freed by dummyhandler...*/
   
    if ((*th = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)dummyhandler, 
      (LPVOID)(tdata), 0, (LPDWORD)(&(th_id)))) == NULL)
      oReturn = 1;
    else
	    oReturn = 0;
  }

      
#ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_create_detached(%s) = %p (%s)\n",
    file,line, th_name, *th, (!oReturn ? "Successful" : "Failed" ));
#endif

  //pthread_log_created(0,th_name, *th); commented out because 
  // there is no way to remote the thread information from the list.

  return oReturn;
}


void KillDetachedThreads() {
  
  int i = 0;

  pthread_mutex_lock(&thread_mutex);
  
  for (i = 0; i<MAXTHREADS; i++) {
    if (thread_table[i].active) { 
      pthread_cancel(thread_table[i].myid);
      thread_table[i].active = 0;
    }
  }

  pthread_mutex_unlock(&thread_mutex);
  
  return;

} /* KillDetachedThreads */


#else /* for sipd */

int pthread_create_detached_r(pthread_t *th, const void *attr, 
                     void * (*start_func)(void *), void *arg) {
  DWORD  th_id;

  if ((*th = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)start_func, 
      (LPVOID)(arg), 0, (LPDWORD)(&(th_id)))) == NULL)
    return 1;
  else
	return 0;
}

/*
 * pthread_create_detached() for libsip++
 * -see the pthread_create_detached comment in the else part.
 *
 * In addition, if the SIPLIB macro is defined, pushes
 * a cancellation cleanup handler. This cancellation cleanup
 * handler is needed to ensure that all detached threads are 
 * killed by the KillDetachedThreads function.
 */
int pthread_create_detached_d(pthread_t *th, const void *attr, 
                     void * (*start_func)(void *), void *arg,
                     char *th_name, char* file, int line) {
  DWORD  th_id;
  int oReturn;

  if ((*th = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)start_func, 
      (LPVOID)(arg), 0, (LPDWORD)(&(th_id)))) == NULL)
    oReturn = 1;
  else
	  oReturn = 0;

#ifdef PTHREAD_DEBUG
  debug(NULL,
    "%s:%d\n\tpthread_create_detached(%s) = %p (%s)\n",
    file,line, th_name, *th, (!oReturn ? "Successful" : "Failed" ));
#endif

  //pthread_log_created(0,th_name, *th); commented out because 
  // there is no way to remote the thread information from the list.

  return oReturn;
}


/*
 * KillDetachedThreads
 *
 * Not implemented for sipd or rtspd etc;
 */
void KillDetachedThreads() {

  return;  
  
} /* KillDetachedThreads */

#endif