#! /bin/sh
# dist_win32.sh: Build a distribution file
# usage: dist_win32.sh topsrcdir distname files...

# Copyright (c)1999-2000 by Columbia University; 
# All rights reserved 

# This is similar to dist.sh except that zip is used 
# instead of tar and gzip.

if test $# -lt 3; then
    echo usage: $0 topsrcdir distname files... >&2
    exit 1
fi

TOPSRCDIR=$1
shift

DISTNAME=$1
shift

echo Building ${DISTNAME}.tar.gz...
rm -f ${DISTNAME}.tar ${DISTNAME}.tar.gz
rm -rf ${DISTNAME}
mkdir ${DISTNAME}

echo Creating directories...
dirs=`for f in $@; do dirname $f; done | sort | uniq`
for dir in $dirs; do
	echo $dir ;
	mkdir -p "${DISTNAME}/$dir" 2>/dev/null
done

echo Copying files...
for file in $@; do
    echo $file
    if test -d "${TOPSRCDIR}/$file"; then 
        cp -pr "${TOPSRCDIR}/$file" "${DISTNAME}/$file";
    else
        cp -p "${TOPSRCDIR}/$file" "${DISTNAME}/$file" 2>/dev/null \
            || cp -p "$file" "${DISTNAME}/$file";
    fi
done

echo Creating zip file...
rm -rf ${DISTNAME}.zip
zip -r -y -9 ${DISTNAME}.zip ${DISTNAME}

# tar cvf ${DISTNAME}.tar ${DISTNAME}
# gzip -9 ${DISTNAME}.tar
rm -rf ${DISTNAME}
