# Makefile fragment for cpl checker
# Copyright 1998-2001 by Columbia University; all rights reserved 

# DUMMY: fragment pending CPL re-write

cpl_check_dir := $(cpl_dir)/check


CPL_CHECK_BIN := \
	$(cpl_check_dir)/cpl-check


CPL_CHECK_SRC := \
	$(cpl_check_dir)/cpl-check.cpp


CPL_CHECK_HEADERS := 

CPL_CHECK_MISC := \
	$(cpl_check_dir)/module.mk

CPL_CHECK_MISCDIST := 
#	$(cpl_check_dir)/cpl_check.html


CPL_CHECK_OBJ := \
	$(patsubst %.cpp,%.o,$(filter %.cpp,$(CPL_CHECK_SRC)))

CPL_CHECK_DEP := \
	$(CPL_CHECK_OBJ:.o=.d)

CPL_CHECK_LIBS := $(LIBCPL_LIB) $(LIBCPLRECUR_LIB) $(LIBCINE_LIB) \
	$(XERCES_CLIBS)
CPL_CHECK_INCS := $(LIBCPL_INC) $(LIBCINE_INC)
CPL_CHECK_DEPENDENCIES := $(LIBCINE) $(LIBCPL) $(LIBCPLRECUR)

$(CPL_CHECK_OBJ): %.o: %.cpp
	@echo "compiling $<..."
	$(CXX) $(CPL_CHECK_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(CPL_CHECK_DEP): %.d: %.cpp
	@echo "dependencies for $<..."
	$(DEPEND) -d $(cpl_check_dir) -o $@ $(CPL_CHECK_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<

$(cpl_check_dir)/cpl-check: $(CPL_CHECK_OBJ) $(CPL_CHECK_DEPENDENCIES)
	@echo "linking $@..."
	$(CXX) -o $@ $(CPL_CHECK_OBJ) $(LDFLAGS) $(CPL_CHECK_LIBS)

.PHONY: cpl-check
cpl-check: $(CPL_CHECK_BIN)
cpl: cpl-check

BIN	  += $(CPL_CHECK_BIN)
SRC       += $(CPL_CHECK_SRC)
HEADERS   += $(CPL_CHECK_HEADERS)
MISCCLEAN += $(CPL_CHECK_MISCCLEAN)

CPL_CHECK_DIST := $(CPL_CHECK_SRC) $(CPL_CHECK_HEADERS) $(CPL_CHECK_MISC) \
	$(CPL_CHECK_MISCDIST)

CPL_CHECK_BINDIST := $(CPL_CHECK_BIN) $(CPL_CHECK_MISCDIST)
