/* cpl-utils.cpp: useful utility functions for CPL. */
/* Copyright 2001 Columbia University.  All rights reserved. */

#include <util/XMLString.hpp>

#include "cpl-utils.h"

using namespace std;

/*
 * cpl_utils::transcode(XMLCh*)
 * Transcode an XMLCh* string to a std::string.
 */
string cpl_utils::transcode(const XMLCh* const toTranscode)
{
  if (toTranscode == NULL) {
    return string();
  }

  char *tmp_str;

  tmp_str = XMLString::transcode(toTranscode);

  if (tmp_str == NULL) {
    // Not sure why this happens
    return string();
  }

  string ret(tmp_str);

  delete[] tmp_str;

  return ret;
}
