# Columbia SIP server makefile fragment for cpl recurrence rules
# Copyright 1998-2001 by Columbia University; all rights reserved 

cpl_recur_dir := $(cpl_dir)/recur

CPL_RECUR_MODULES := test

CPL_RECUR_SRC := \
  $(cpl_recur_dir)/recur.cpp \
  $(cpl_recur_dir)/calendar.cpp \
  $(cpl_recur_dir)/dayandposition.cpp \
  $(cpl_recur_dir)/duration.cpp \
  $(cpl_recur_dir)/timezone.cpp \
  $(cpl_recur_dir)/localtime.c \
  $(cpl_recur_dir)/strftime.c \
  $(cpl_recur_dir)/tzthread-posix.c

CPL_RECUR_HEADERS := \
  $(cpl_recur_dir)/recur.h \
  $(cpl_recur_dir)/calendar.h \
  $(cpl_recur_dir)/dayandposition.h \
  $(cpl_recur_dir)/duration.h \
  $(cpl_recur_dir)/timezone.h \
  $(cpl_recur_dir)/private.h \
  $(cpl_recur_dir)/struct_tzinfo.h \
  $(cpl_recur_dir)/tzfile.h \
  $(cpl_recur_dir)/tztimeext.h
 
CPL_RECUR_MISC := \
  $(cpl_dir)/module.mk \
  $(cpl_dir)/cpl_recur.dsp

CPL_RECUR_MISCCLEAN := \
  $(cpl_recur_dir)/libcplrecur.a

CPL_RECUR_OBJ_C := \
  $(patsubst %.c,%.o,$(filter %.c,$(CPL_RECUR_SRC)))
CPL_RECUR_OBJ_CPP := \
  $(patsubst %.cpp,%.o,$(filter %.cpp,$(CPL_RECUR_SRC)))
CPL_RECUR_OBJ := $(CPL_RECUR_OBJ_C) $(CPL_RECUR_OBJ_CPP)

CPL_RECUR_DEP_C := \
  $(CPL_RECUR_OBJ_C:.o=.d)
CPL_RECUR_DEP_CPP := \
  $(CPL_RECUR_OBJ_CPP:.o=.d)
CPL_RECUR_DEP := \
  $(CPL_RECUR_DEP_C) $(CPL_RECUR_DEP_CPP)

# How other parts of the build find us:
# Target for make:
LIBCPLRECUR := $(cpl_recur_dir)/libcplrecur.a

# Incantations for compile and build:
LIBCPLRECUR_INC := -I$(topsrcdir)/$(cpl_recur_dir)
LIBCPLRECUR_LIB := -L$(cpl_recur_dir) -lcplrecur

# Include files required locally.
CPL_RECUR_INCS := $(LIBCINE_INC)

$(CPL_RECUR_OBJ_C): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(CPL_RECUR_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(CPL_RECUR_DEP_C): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(cpl_recur_dir) -o $@ $(CPL_RECUR_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<

$(CPL_RECUR_OBJ_CPP): %.o: %.cpp
	@echo "compiling $<..."
	$(CXX) $(CPL_RECUR_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(CPL_RECUR_DEP_CPP): %.d: %.cpp
	@echo "dependencies for $<..."
	$(DEPEND) -d $(cpl_recur_dir) -o $@ $(CPL_RECUR_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<

$(LIBCPLRECUR): $(CPL_RECUR_OBJ)
	@echo "creating library $@..."
	$(AR) rc $@ $^
	$(RANLIB) $@

.PHONY: cpl
cpl: $(CPL_REQS) $(LIBCPLRECUR)

SRC       += $(CPL_RECUR_SRC)
HEADERS   += $(CPL_RECUR_HEADERS)
MISCCLEAN += $(CPL_RECUR_MISCCLEAN)

# Include the description for sub-modules
include $(patsubst %,$(topsrcdir)/$(cpl_recur_dir)/%/module.mk,$(CPL_RECUR_MODULES))

# XXX TODO Distfiles
