#include "calendar.h"

#include <iostream>

using namespace std;

int main() {
  try {
    for (int i = 1; i < 14; i++) {
      Calendar cal;
    
      cal.setMinimalDaysInFirstWeek(4);
      cal.setFirstDayOfWeek(Calendar::MONDAY);

      cal.set(Calendar::YEAR, 1999);
      cal.set(Calendar::MONTH, Calendar::JANUARY);
      cal.set(Calendar::DATE, i);
      cal.set(Calendar::HOUR_OF_DAY, 9);
      cal.set(Calendar::MINUTE, 0);
      cal.set(Calendar::SECOND, 0);
      
      int WOY1 = cal.get(Calendar::WEEK_OF_YEAR);
      cout << "January " << cal.get(Calendar::DATE) << ", " <<
        cal.get(Calendar::YEAR) << ": Week " << WOY1 << endl;
    }

    for (int i = 20; i <= 31; i++) {
      Calendar cal;
    
      cal.setMinimalDaysInFirstWeek(4);
      cal.setFirstDayOfWeek(Calendar::MONDAY);

      cal.set(Calendar::YEAR, 1997);
      cal.set(Calendar::MONTH, Calendar::DECEMBER);
      cal.set(Calendar::DATE, i);
      cal.set(Calendar::HOUR_OF_DAY, 9);
      cal.set(Calendar::MINUTE, 0);
      cal.set(Calendar::SECOND, 0);
      
      int WOY1 = cal.get(Calendar::WEEK_OF_YEAR);
      cout << "December " << cal.get(Calendar::DATE) << ", " <<
        cal.get(Calendar::YEAR) << ": Week " << WOY1 << endl;
    }

    Calendar cal;
    
    cal.setMinimalDaysInFirstWeek(1);
    cal.setFirstDayOfWeek(Calendar::SUNDAY);

    cal.set(Calendar::YEAR, 1999);
    cal.set(Calendar::MONTH, Calendar::MAY);
    cal.set(Calendar::DATE, 10);
    cal.set(Calendar::HOUR_OF_DAY, 9);
    cal.set(Calendar::MINUTE, 0);
    cal.set(Calendar::SECOND, 0);
    
    int WOY1 = cal.get(Calendar::WEEK_OF_YEAR);

    cal.setMinimalDaysInFirstWeek(4);
    cal.setFirstDayOfWeek(Calendar::MONDAY);
    
    int WOY2 = cal.get(Calendar::WEEK_OF_YEAR);
    
    cal.clear(Calendar::WEEK_OF_YEAR);
    
    int WOY3 = cal.get(Calendar::WEEK_OF_YEAR);
    
    cout << "WOY1 = " << WOY1 << endl;
    cout << "WOY2 = " << WOY2 << endl;
    cout << "WOY3 = " << WOY3 << endl;
  } catch (calendar_exception& e) {
    cerr << e.what() << endl;
  }
}
