#ifndef TZTIMEEXT_H
#define TZTIMEEXT_H

/*
** This file is in the public domain.  Contributed by Jonathan Lennox
** <lennox@cs.columbia.edu>
*/

/*
** This is an extended version of <time.h> which provides function definitions
** for the public functions defined by tzcode.
*/

#include <time.h>

#ifdef __cplusplus
extern "C" {
#endif

#if __STDC_VERSION__ < 199901
#undef  restrict
#define restrict
#endif

struct tzinfo;

#if defined(__STDC__)

extern void		tzsetwall(void);
extern struct tm *	offtime(const time_t *, const long);
extern time_t		timelocal(struct tm * const);
extern time_t		timegm(struct tm * const);
extern time_t		timeoff(struct tm * const, const long);

extern time_t		time2posix(time_t);
extern time_t		posix2time(time_t);

extern int		tz_prep(struct tzinfo**, const char *);
extern void		tz_free(struct tzinfo*);

extern int		time_make(time_t *, struct tm *,
					const struct tzinfo *);
extern int		time_breakup(struct tm *, const time_t *,
					const struct tzinfo *);
extern size_t		strftime_z(char * restrict, size_t,
					const char * restrict,
					const struct tm * restrict,
					const struct tzinfo * restrict);

extern int		pthread_settz(const struct tzinfo *);

#else /* !defined(__STDC__) */

extern void		tzsetwall();
extern struct tm *	offtime();
extern time_t		timelocal();
extern time_t		timegm();
extern time_t		timeoff();

extern time_t		time2posix();
extern time_t		posix2time();

extern int		tz_prep();
extern void		tz_free();

extern int		time_make();
extern int		time_breakup();
extern size_t		strftime_z();

extern int		pthread_settz();

#endif /* defined(__STDC__) */


#if __STDC_VERSION__ < 199901
#undef restrict
#endif

#ifdef __cplusplus
}
#endif

#endif /* TZTIMEEXT_H */
