
#include "ssl_common.h"
#include "ssl_client.h"
#include "read_write.h"

SSL_LINK *tcp_connect(char *host, int port);

/*
int main(int argc,char **argv)
  {

    SSL_LINK *slink; 
    int port = 4433; //sprintf("%d", argv[2]);

    // make ssl connection
    slink = tcp_connect(argv[1], port);

    // read and write 
    read_write(slink->ssl, slink->sock);

  }
*/

SSL_LINK *tcp_connect(char *host, int port)
 {
    struct hostent *hp;
    struct sockaddr_in addr;
    SSL_CTX *ctx;
    BIO *sbio;
    SSL_LINK *slink = malloc(sizeof(SSL_LINK));
    SSL *ssl;
    int sock;
    
    /* Build our SSL context*/
    ctx=initialize_ctx(KEYFILE,PASSWORD);

    /* Connect the TCP socket*/
    if(!(hp=gethostbyname(host)))
      berr_exit("Couldn't resolve host");
    memset(&addr,0,sizeof(addr));
    addr.sin_addr=*(struct in_addr*)hp->h_addr_list[0];
    addr.sin_family=AF_INET;
    addr.sin_port=htons(port);

    if((sock=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP))<0)
      err_exit("Couldn't create socket");
    if(connect(sock,(struct sockaddr *)&addr,sizeof(addr))<0)
      err_exit("Couldn't connect socket");
    
    /* Connect the SSL socket */
    ssl=SSL_new(ctx);
    sbio=BIO_new_socket(sock,BIO_NOCLOSE);
    SSL_set_bio(ssl,sbio,sbio);
    if(SSL_connect(ssl)<=0)
      berr_exit("SSL connect error");
    check_cert_chain(ssl,host);


    slink->ssl = ssl;
    slink->sock = sock;
    return slink;

  }

/* Check that the common name matches the host name*/
void check_cert_chain(ssl,host)
  SSL *ssl;
  char *host;
  {
    X509 *peer;
    char peer_CN[256];
    BIO *out; //liao
    
    if(SSL_get_verify_result(ssl)!=X509_V_OK)
      berr_exit("Certificate doesn't verify");

    /*Check the cert chain. The chain length
      is automatically checked by OpenSSL when we
      set the verify depth in the ctx */

    /*Check the common name*/
    peer=SSL_get_peer_certificate(ssl);

    X509_NAME_get_text_by_NID(X509_get_subject_name(peer),
      NID_commonName, peer_CN, 256);
    // added by li liao
    printf("The host's name in the certificate is: %s\n", peer_CN);
    out = BIO_new(BIO_s_file());
    BIO_set_fp(out, stdout, BIO_NOCLOSE);
    PEM_write_bio_X509(out, peer);
    X509_print(out, peer);
    // addition ends

    if(strcasecmp(peer_CN,host))
    err_exit("Common name doesn't match host name");
  }

