#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include "sysdep.h"
#include "error.h"

/*
* Put process into daemon mode.
*/
void do_daemon(void)
{
#ifndef WIN32
  switch (fork()) {
    case -1: 
      exit (-1);
    case 0:
      break;
    default:
      exit(0);
  }
  /* child continues */
  setsid();    /* release controlling terminal */
#else
  debug("do_daemon", "Minimizing the window\n");
  //ShowWindow(GetForegroundWindow(), SW_HIDE);
#endif
  umask(0);    /* clear out file mode creation mask */
} /* do_daemon */
