#ifndef ERROR_H
#define ERROR_H
#ifdef __GNUC__
/* This function uses printf-style formats, so tell GNUC to do printf
 * format checking. */
#define ATTRIBUTE_PRINTF(fmt, args) \
   __attribute__ ((format (printf, fmt, args)))
#else
#define ATTRIBUTE_PRINTF(fmt, args)
#endif
extern void debug(char *function_name, char *format, ...)
     ATTRIBUTE_PRINTF(2, 3);
extern void fatal(char *function_name, char *format, ...)
     ATTRIBUTE_PRINTF(2, 3);
extern void error(char *function_name, char *format, ...)
     ATTRIBUTE_PRINTF(2, 3);
extern void ErrorInit(char *file);
extern void ErrorClose(void);
#undef ATTRIBUTE_PRINTF
#endif
