/*
 * gethostbyname_r.h
 *
 */

#if PACKETSZ > 1024
#define MAXPACKET	PACKETSZ
#else
#define MAXPACKET	1024
#endif

#define RES_DEBUG2 RES_DEBUG

#define  SUCCESS		0
#define  TIME_OUT		-1
#define  NO_INFO		-2
#define  ERROR			-3
#define  NONAUTH		-4
#define  NO_RESPONSE		-5

#ifndef FD_SET
#define	NFDBITS		32
#define	FD_SETSIZE	32
#define	FD_SET(n, p)	((p)->fds_bits[(n)/NFDBITS] |= (1 << ((n) % NFDBITS)))
#define	FD_CLR(n, p)	((p)->fds_bits[(n)/NFDBITS] &= ~(1 << ((n) % NFDBITS)))
#define	FD_ISSET(n, p)	((p)->fds_bits[(n)/NFDBITS] & (1 << ((n) % NFDBITS)))
#define FD_ZERO(p)	memset((p), 0, sizeof(*(p)))
#endif


#define TRUE 1
#define FALSE 0
#define MAXALIASES 35
#define MAXADDRS   35
#define MAXDOMAINS 35

#define GetShort(cp)  ns_get16(cp); cp += INT16SZ;

#ifndef dn_skipname
/* 
 * Skip over a compressed domain name. Return the size or -1.
 */
int dn_skipname(const u_char *ptr, const u_char *eom) { 
  const u_char *saveptr = ptr;
  if (ns_name_skip(&ptr, eom) == -1)
    return (-1); 
  return (ptr - saveptr);
}
#endif

extern int sendquery(const u_char *buf, int buflen,u_char **answer, u_int *anslen, int **trueLenPtr);
extern int decode(u_char *answer, u_int anslen, int length, struct hostent *hostinfo);
extern struct hostent *gethostbyname_r (const char *name, struct hostent *result,char *buffer, int buflen, int *h_errnop);

