/*
* Return offset from GMT, measured in seconds.  If locale is ahead of
* GMT, offset is positive. Borrowed from Apache util.c.
*/
#include <time.h>

int gmtoff(void) {
  time_t tt = time(NULL);
  struct tm gmt;   
  struct tm *t;
  int days, hours, minutes;
 
  /* Assume we are never more than 24 hours away. */
  gmt = *gmtime(&tt); /* remember gmtime/localtime return ptr to static */
  t = localtime(&tt); /* buffer... so be careful */
  days = t->tm_yday - gmt.tm_yday;
  hours = ((days < -1 ? 24 : 1 < days ? -24 : days * 24)
         + t->tm_hour - gmt.tm_hour);
  minutes = hours * 60 + t->tm_min - gmt.tm_min;
  return minutes;
} /* gmtoff */
