# Columbia SIP server makefile fragment for sipd
# Copyright 1998-1999 by Columbia University; all rights reserved 

libcine_dir := $(topdir)/libcine

LIBCINE_SRC := \
  $(libcine_dir)/base64.c \
  $(libcine_dir)/bidipipe.c \
  $(libcine_dir)/daemon.c \
  $(libcine_dir)/dstring.c \
  $(libcine_dir)/error.c \
  $(libcine_dir)/exitthread.c \
  $(libcine_dir)/fullpath.c \
  $(libcine_dir)/gettimeofdayf.c \
  $(libcine_dir)/glob2regex.c \
  $(libcine_dir)/gmatch.c \
  $(libcine_dir)/gmtoff.c \
  $(libcine_dir)/gname2id.c \
  $(libcine_dir)/headers.c \
  $(libcine_dir)/host2ip.c \
  $(libcine_dir)/http.c \
  $(libcine_dir)/md5-util.c \
  $(libcine_dir)/md5c.c \
  $(libcine_dir)/parser.c \
  $(libcine_dir)/pattern.c \
  $(libcine_dir)/pthread-util.c \
  $(libcine_dir)/raise-rlimits.c \
  $(libcine_dir)/random32.c \
  $(libcine_dir)/servers.c \
  $(libcine_dir)/setusergroup.c \
  $(libcine_dir)/shortform.c \
  $(libcine_dir)/strdupn.c \
  $(libcine_dir)/timespec.c \
  $(libcine_dir)/tcp.c \
  $(libcine_dir)/ssl_tcp.c \
  $(libcine_dir)/ssl_common.c \
  $(libcine_dir)/ssl_client.c \
  $(libcine_dir)/udp.c \
  $(libcine_dir)/uname2id.c \
  $(libcine_dir)/uri.c \
  $(libcine_dir)/msgflow.c \
  $(libcine_dir)/stack_lock.cpp \
  $(libcine_dir)/thread_pool.c


ifeq ($(HAVE_GETHOSTBYNAME_R),no)
LIBCINE_SRC += \
  $(libcine_dir)/gethostbyname_r.c
endif

ifeq ($(HAVE_GETUTENT),no)
LIBCINE_SRC += \
  $(libcine_dir)/getutent.c
endif

ifeq ($(HAVE_STRTOK_R),no)
LIBCINE_SRC += \
  $(libcine_dir)/strtok_r.c
endif

ifeq ($(HAVE_TIMEGM),no)
LIBCINE_SRC += \
  $(libcine_dir)/timegm.c
endif

LIBCINE_MAYBESRC := \
  $(libcine_dir)/gethostbyname_r.c \
  $(libcine_dir)/getutent.c \
  $(libcine_dir)/strtok_r.c \
  $(libcine_dir)/strptime.c \
  $(libcine_dir)/timegm.c

LIBCINE_HEADERS := \
  $(libcine_dir)/base64.h \
  $(libcine_dir)/bidipipe.h \
  $(libcine_dir)/bitmap.h \
  $(libcine_dir)/dstring.h \
  $(libcine_dir)/error.h \
  $(libcine_dir)/fullpath.h \
  $(libcine_dir)/gethostbyname_r.h \
  $(libcine_dir)/getutent.h \
  $(libcine_dir)/global.h \
  $(libcine_dir)/glob2regex.h \
  $(libcine_dir)/gmatch.h \
  $(libcine_dir)/headers.h \
  $(libcine_dir)/host2ip.h \
  $(libcine_dir)/http.h \
  $(libcine_dir)/log_string.h \
  $(libcine_dir)/md5.h \
  $(libcine_dir)/pattern.h \
  $(libcine_dir)/pthread-util.h \
  $(libcine_dir)/raise-rlimits.h \
  $(libcine_dir)/request-common.h \
  $(libcine_dir)/rfc822.h \
  $(libcine_dir)/rr.h \
  $(libcine_dir)/servers.h \
  $(libcine_dir)/shortform.h \
  $(libcine_dir)/strdupn.h \
  $(libcine_dir)/sysdep.h \
  $(libcine_dir)/tcp.h \
  $(libcine_dir)/ssl_common.h \
  $(libcine_dir)/ssl_client.h \
  $(libcine_dir)/ssl_tcp.h \
  $(libcine_dir)/timegm.h \
  $(libcine_dir)/timespec.h \
  $(libcine_dir)/types.h \
  $(libcine_dir)/udp.h \
  $(libcine_dir)/uri.h \
  $(libcine_dir)/msgflow.h \
  $(libcine_dir)/stack_lock.h \
  $(libcine_dir)/thread_pool.h \
  $(libcine_dir)/boost/config.hpp \
  $(libcine_dir)/boost/utility.hpp \
  $(libcine_dir)/boost/smart_ptr.hpp


LIBCINE_MISC := \
  $(libcine_dir)/module.mk \
  $(libcine_dir)/libcine.dsp

LIBCINE_MISCCLEAN := \
  $(libcine_dir)/libcine.a



LIBCINE_OBJ_C := \
	$(patsubst %.c,%.o,$(filter %.c,$(LIBCINE_SRC)))

LIBCINE_OBJ_CPP := \
	$(patsubst %.cpp,%.o,$(filter %.cpp,$(LIBCINE_SRC)))

LIBCINE_OBJ := $(LIBCINE_OBJ_C) $(LIBCINE_OBJ_CPP)


# How other parts of the build find us:
# Target for make:
LIBCINE := $(libcine_dir)/libcine.a

# Incantations for compile and build:
LIBCINE_INC := -I$(topsrcdir)/$(libcine_dir)
LIBCINE_LIB := -L$(libcine_dir) -lcine

$(LIBCINE): $(LIBCINE_OBJ)
	@echo "creating library $@..."
	$(AR) rc $@ $^
	$(RANLIB) $@

SRC       += $(LIBCINE_SRC) $(LIBCINE_OTHER_SRC)
HEADERS   += $(LIBCINE_HEADERS)
MISCCLEAN += $(LIBCINE_MISCCLEAN)

LIBCINE_MODULES := test

# Include the description for each sub-module
include $(patsubst %,$(topsrcdir)/$(libcine_dir)/%/module.mk,$(LIBCINE_MODULES))

# Files for distributions:
LIBCINE_DIST := $(LIBCINE_SRC) $(LIBCINE_MAYBESRC) $(LIBCINE_HEADERS) \
	$(LIBCINE_MISC) $(CINE_TEST_DIST)

LIBCINE_BINDIST := $(LIBCINE_TEST_BINDIST)
