/*
pthread_util.c - utility wrappers for pthread functions

Copyright 2000 by Columbia University; all rights reserved 
*/

#ifndef WIN32

/* External function for Unix */
extern int pthread_create_detached(pthread_t *,
                                   const pthread_attr_t *,
                                   void *(*)(void *),
                                   void *);

#else

/*
* pthread_create_detached is already defined in
* windows portability pthread.h file.
*/

#endif

/* KillDetachedThreads
 * 
 * kill all detached threads. implemented only when SIPLIB
 * macro is defined (not needed for sipd, and using this
 * reduces performance - for libsip++ it should be ok).
 */
extern void KillDetachedThreads(); 

 
