/*
setusergroup.c

If running as root, switch user and group to those given as
arguments.
*/

#include <unistd.h>
#include <sys/types.h>
#include "error.h"
#include "sysdep.h"

void setusergroup(uid_t uid, gid_t gid)
{
  if (!geteuid()) {
    if (setuid(uid) == -1) {
      error("daemon", "unable to change uid to %ld", (long)uid);
    }
    if (setgid(gid) == -1) {
      error("daemon", "unable to set group id %ld", (long)gid);
    }
  }
} /* setusergroup */
