#ifndef ssl_common_h
#define ssl_common_h

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <fcntl.h>
#include <signal.h>

/*
#include <openssl/ssl.h>
*/

#include "/n/ober/u/class/ll272/openssl/openssl-0.9.6a/include/openssl/ssl.h"

#define CA_LIST "root.pem"
#define RANDOM  "random.pem"
#define BUFSIZZ 1024

#define KEYFILE "server.pem"
#define PASSWORD "password"
#define DHFILE "dh1024.pem"


typedef struct ssl_link {
  SSL *ssl;
  int sock;
} SSL_LINK;


extern BIO *bio_err;
int berr_exit (char *string);
int err_exit(char *string);

SSL_CTX *initialize_ctx(char *keyfile, char *password);
void destroy_ctx(SSL_CTX *ctx);

void load_dh_params(SSL_CTX *ctx,char *file);
void generate_eph_rsa_key(SSL_CTX *ctx);

#endif


