# Makefile fragment for dbapi tests
# Copyright 1998-1999 by Columbia University; all rights reserved 

dbapi_test_dir := $(dbapi_dir)/test

DIRS += $(dbapi_test_dir)


DBAPI_TEST_BIN := \
	$(dbapi_test_dir)/dbaccess-test \
	$(dbapi_test_dir)/dbaccess-test-c


DBAPI_TEST_SRC := \
	$(dbapi_test_dir)/dbaccess-test.cpp \
	$(dbapi_test_dir)/dbaccess-test-c.c


DBAPI_TEST_MISC := \
	$(dbapi_test_dir)/module.mk


DBAPI_TEST_OBJ_C := \
	$(patsubst %.c,%.o,$(filter %.c,$(DBAPI_TEST_SRC)))
DBAPI_TEST_OBJ_CPP := \
	$(patsubst %.cpp,%.o,$(filter %.cpp,$(DBAPI_TEST_SRC)))
DBAPI_TEST_OBJ := \
	$(DBAPI_TEST_OBJ_C) $(DBAPI_TEST_OBJ_CPP)

DBAPI_TEST_DEP_C := \
        $(DBAPI_TEST_OBJ_C:.o=.d)
DBAPI_TEST_DEP_CPP := \
        $(DBAPI_TEST_OBJ_CPP:.o=.d)
DBAPI_TEST_DEP := \
        $(DBAPI_TEST_DEP_C) $(DBAPI_TEST_DEP_CPP)


DBACCESS_TEST_OBJS := \
	$(dbapi_test_dir)/dbaccess-test.o

DBACCESS_TEST_C_OBJS := \
	$(dbapi_test_dir)/dbaccess-test-c.o

DBACCESS_TEST_LIBS := $(DBAPI_LIB) $(MYSQLLIBS) $(ZLIBLIBS) \
	$(LIBDICT_LIB) $(LIBCINE_LIB) $(SOCKLIBS) $(MATHLIBS)

DBAPI_TEST_INCS := $(DBAPI_INC) $(LIBCINE_INC)

$(DBAPI_TEST_OBJ_C): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(DBAPI_TEST_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(DBAPI_TEST_DEP_C): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(dbapi_test_dir) -o $@ $(DBAPI_TEST_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<

# Order of -c and -o matters.
$(DBAPI_TEST_OBJ_CPP): %.o: %.cpp
	@echo "compiling $<..."
	$(CXX) $(DBAPI_TEST_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -o $@ -c $<

$(DBAPI_TEST_DEP_CPP): %.d: %.cpp
	@echo "dependencies for $<..."
	$(DEPEND) -d $(dbapi_test_dir) -o $@ $(DBAPI_TEST_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<


test: $(dbapi_test_dir)/dbaccess-test $(dbapi_test_dir)/dbaccess-test-c

$(dbapi_test_dir)/dbaccess-test: $(dbapi_test_dir)/dbaccess-test.o $(DBAPI) $(LIBCINE) $(LIBDICT)
	@echo "linking $@..."
	$(CXX) -o $@ $(LDFLAGS) $(DBACCESS_TEST_OBJS) $(DBACCESS_TEST_LIBS) $(LIBS)

$(dbapi_test_dir)/dbaccess-test-c: $(dbapi_test_dir)/dbaccess-test-c.o $(DBAPI) $(LIBCINE) $(LIBDICT)
	@echo "linking $@..."
	$(CXX) -o $@ $(LDFLAGS) $(DBACCESS_TEST_C_OBJS) $(DBACCESS_TEST_LIBS) $(LIBS)

BIN += $(DBAPI_TEST_BIN)
SRC += $(DBAPI_TEST_SRC)
HEADERS += $(DBAPI_TEST_HEADERS)

DBAPI_TEST_DIST := $(DBAPI_TEST_SRC) $(DBAPI_TEST_HEADERS) $(DBAPI_TEST_MISC) \
	$(DBAPI_TEST_MISCDIST)

# These test binaries don't need to go in the bindist
DBAPI_TEST_BINDIST := $(DBAPI_TEST_MISCDIST)
