# Columbia CINEMA servers makefile fragment for libh323
# Copyright 1999-2000 by Columbia University; all rights reserved 


libh323_dir := $(topdir)/libh323

LIBH323_SRC := \
	$(libh323_dir)/h323api.cxx \
	$(libh323_dir)/precompile.cxx

LIBH323_HEADERS := \
	$(libh323_dir)/h323api.h \
	$(libh323_dir)/main.h \
	$(libh323_dir)/version.h

LIBH323_MISC := \
	$(libh323_dir)/module.mk \
	$(libh323_dir)/Makefile \
	$(libh323_dir)/libh323.dsp \
	$(libh323_dir)/README

LIBH323     := $(libh323_dir)/libh323.a
LIBH323_INC := -I$(topsrcdir)/libh323
LIBH323_LIB := -L$(libh323_dir) -lh323
LIBH323_REQS := need-pwlib need-openh323

libh323 :: $(LIBH323_REQS) $(LIBH323)

# Target to build h323 api.

$(LIBH323) ::
	@echo "Using PWLIBDIR=$(PWLIBDIR)"
	@echo "Compiling libh323 using OPENH323DIR=$(OPENH323DIR)"
	mkdir -p libh323; TOPDIR=`pwd`/libh323; export TOPDIR; \
	cd $(topsrcdir); \
	IPTELAPI_INC="-I`pwd`/libsip++/"; export IPTELAPI_INC; \
	$(MAKE) -C ./libh323 opt;

cleanh323 ::
	$(MAKE) -C $(topsrcdir)/libh323 clean;


LIBH323_DIST :=  $(LIBH323_SRC) $(LIBH323_HEADERS) $(LIBH323_MISC)

