/***************************** FILE HEADER *****************************
#               Copyright (c) 2000 by Columbia University              *
#                        All Rights Reserved                           *
#***********************************************************************
#***********************************************************************
#
#  File Name    : data.h
#
#  Module       : Audio/video Conference Server
#
#  Author(s)    : Kundan Singh (kns10@cs.columbia.edu)
#
#  Description  : Video switching logic.
#                
#  Notes        : 
#
#***********************************************************************
#                Modification History (Reverse Order)
#-----------------------------------------------------------------------
#   Date         Author              Description
#-----------------------------------------------------------------------
#              |             | 
#              |             | 
#-----------------------------------------------------------------------
*/

#ifndef RTPM_DATA_H

#define RTPM_DATA_H 1

int RTPMDataCreateSocket(rtpm_call_leg_t *leg,
                         media_line_t   *media);
int RTPMDataDeleteSocket(rtpm_call_leg_t *leg);

int RTPMDataCanSend(rtpm_call_leg_t *sender,
                    rtpm_call_leg_t *receiver,
                    char *buffer,
                     int length);
void * RTPMDataThread(void *param);

#endif

/************************** END OF FILE ********************************
*/

