# Columbia make file fragment for RTP based audio mixer.
# Copyright 2000 by Columbia University; all rights reserved 

libmixer_dir := $(topdir)/libmixer

LIBMIXER_SRC := \
  $(libmixer_dir)/rtpmapi.c \
  $(libmixer_dir)/buffer.c \
  $(libmixer_dir)/sched.c \
  $(libmixer_dir)/sdp.c \
  $(libmixer_dir)/sendrecv.c \
  $(libmixer_dir)/list.c \
  $(libmixer_dir)/transcode.c \
  $(libmixer_dir)/video.c \
  $(libmixer_dir)/data.c \
  $(libmixer_dir)/g711.c \
  $(libmixer_dir)/g721.c \
  $(libmixer_dir)/g72x.c \
  $(libmixer_dir)/dvi_adpcm.c \
  $(libmixer_dir)/pcmu_l16.c \
  $(libmixer_dir)/pcmu_l14.c

LIBMIXER_MAYBESRC := 

LIBMIXER_HEADERS := \
  $(libmixer_dir)/rtpmapi.h \
  $(libmixer_dir)/buffer.h \
  $(libmixer_dir)/sched.h \
  $(libmixer_dir)/sdp.h \
  $(libmixer_dir)/sendrecv.h \
  $(libmixer_dir)/list.h \
  $(libmixer_dir)/transcode.h \
  $(libmixer_dir)/video.h \
  $(libmixer_dir)/data.h \
  $(libmixer_dir)/g711.h \
  $(libmixer_dir)/g72x.h \
  $(libmixer_dir)/dvi_adpcm.h \
  $(libmixer_dir)/pcmu_l.h \
  $(libmixer_dir)/audio_descr.h \
  $(libmixer_dir)/stdtypes.h 

LIBMIXER_MISC := \
  $(libmixer_dir)/module.mk \
  $(libmixer_dir)/libmixer.dsp

LIBMIXER_MISCCLEAN := \
  $(libmixer_dir)/libmixer.a

LIBMIXER_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(LIBMIXER_SRC)))

LIBMIXER_DEP := \
	$(LIBMIXER_OBJ:.o=.d)


# How other parts of the build find us:
# Target for make:
LIBMIXER := $(libmixer_dir)/libmixer.a

# Incantations for compile and build:
LIBMIXER_INC := -I$(topsrcdir)/libmixer -I$(RTP_DIR)/include -I$(GSM_DIR)/inc
LIBMIXER_LIB := -L$(libmixer_dir) -lmixer -L$(RTP_DIR)/lib -lrtp -lrtpunix -L$(GSM_DIR)/lib -lgsm -lm 
LIBMIXER_REQS := need-rtp need-gsm

# Include files required locally.
LIBMIXER_INCS := -I$(RTP_DIR)/include $(LIBCINE_INC) $(LIBDICT_INC) -I$(GSM_DIR)/inc

$(LIBMIXER_OBJ): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(LIBMIXER_INCS) -DINCLUDE_SSRC $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(LIBMIXER_DEP): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(libmixer_dir) -o $@ $(LIBMIXER_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<

libmixer: $(LIBMIXER) $(LIBMIXER_REQS)

$(LIBMIXER): $(LIBMIXER_OBJ) $(LIBMIXER_DEP)
	@echo "creating library $@..."
	$(AR) rc $@ $^
	$(RANLIB) $@

SRC       += $(LIBMIXER_SRC) $(LIBMIXER_OTHER_SRC)
HEADERS   += $(LIBMIXER_HEADERS)
MISCCLEAN += $(LIBMIXER_MISCCLEAN)

LIBMIXER_MODULES := test

# Include the description for each sub-module
include $(patsubst %,$(topsrcdir)/$(libmixer_dir)/%/module.mk,$(LIBMIXER_MODULES))

# Files for distributions:
LIBMIXER_DIST := $(LIBMIXER_SRC) $(LIBMIXER_MAYBESRC) $(LIBMIXER_HEADERS) \
	$(LIBMIXER_MISC) $(MIXER_TEST_DIST)

LIBMIXER_BINDIST := $(LIBMIXER_TEST_BINDIST)
