# Makefile fragment for libmixer tests
# Copyright 2000 by Columbia University; all rights reserved 

mixer_test_dir := $(libmixer_dir)/test

DIRS += $(mixer_test_dir)


MIXER_TEST_BIN := \
	$(mixer_test_dir)/mixer


MIXER_TEST_SRC := \
	$(mixer_test_dir)/mixer.c

MIXER_TEST_HEADERS := 

#	$(mixer_test_dir)/copyright.h

MIXER_TEST_MISC := \
	$(mixer_test_dir)/module.mk

MIXER_TEST_MISCDIST := 

#	$(mixer_test_dir)/mixer_test.html

MIXER_TEST_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(MIXER_TEST_SRC)))

MIXER_TEST_DEP := \
	$(MIXER_TEST_OBJ:.o=.d)


MIXER_TEST_INCS :=  -I$(topsrcdir)/rtplib $(LIBMIXER_INC) $(LIBCINE_INC)

MIXER_TEST_LIBS := $(LIBMIXER_LIB) $(LIBCINE_LIB) \
	-L$(topdir)/rtplib -lrtp -lrtpunix $(NISLIBS) $(SOCKLIBS)

$(MIXER_TEST_OBJ): %.o: %.c
	$(CC) $(MIXER_TEST_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(MIXER_TEST_DEP): %.d: %.c
	$(DEPEND) -d $(mixer_test_dir) -o $@ $(MIXER_TEST_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<

mixer: $(mixer_test_dir)/mixer 

$(mixer_test_dir)/mixer: $(MIXER_TEST_OBJ) $(LIBMIXER)
	$(CC) -o $@ $(MIXER_TEST_OBJ) $(LDFLAGS) $(MIXER_TEST_LIBS) $(LIBS)

BIN += $(MIXER_TEST_BIN)
SRC += $(MIXER_TEST_SRC)
HEADERS += $(MIXER_TEST_HEADERS)

MIXER_TEST_DIST := $(MIXER_TEST_SRC) $(MIXER_TEST_HEADERS) $(MIXER_TEST_MISC) \
	$(MIXER_TEST_MISCDIST)

# These test binaries don't need to go in the bindist
MIXER_TEST_BINDIST := $(MIXER_TEST_MISCDIST)

