/***************************** FILE HEADER *****************************
#               Copyright (c) 2000 by Columbia University              *
#                        All Rights Reserved                           *
#***********************************************************************
#***********************************************************************
#
#  File Name    : video.h
#
#  Module       : Audio/video Conference Server
#
#  Author(s)    : Kundan Singh (kns10@cs.columbia.edu)
#
#  Description  : Video switching logic.
#                
#  Notes        : 
#
#***********************************************************************
#                Modification History (Reverse Order)
#-----------------------------------------------------------------------
#   Date         Author              Description
#-----------------------------------------------------------------------
#              |             | 
#              |             | 
#-----------------------------------------------------------------------
*/

#ifndef RTPM_VIDEO_H

#define RTPM_VIDEO_H 1

int RTPMVideoCreateSocket(rtpm_call_leg_t *leg,
                          media_line_t   *media);
int RTPMVideoDeleteSocket(rtpm_call_leg_t *leg);

int RTPMVideoCanSend(rtpm_call_leg_t *sender,
                     rtpm_call_leg_t *receiver,
                     char *buffer,
                     int length);
void * RTPMVideoThread(void *param);

#endif

/************************** END OF FILE ********************************
*/

