#ifndef SIPENTITY_UADS_H__
#define SIPENTITY_UADS_H__

/*
 *
 * Sip ua objects - not supported rightnow, as putting them in sipd 
 * does not seem to make a lot of sense.
 *
 */
typedef struct sip_uacfg_timer_entry {
  
  u_int sipUACfgTimerTrying;
  int (*setSipUACfgTimerTrying)(struct sip_uacfg_timer_entry*, u_int msecs);

  u_int sipUACfgTimerProv;
  int (*setSipUACfgTimerProv)(struct sip_uacfg_timer_entry*, u_int msecs);

  u_int sipUACfgTimerAck;
  int (*setSipUACfgTimerAck)(struct sip_uacfg_timer_entry*, u_int msecs);

  u_int sipUACfgTimerDisconnect;
  int (*setSipUACfgTimerDisconnect)(struct sip_uacfg_timer_entry*, u_int msecs);

  u_int sipUACfgTimerReRegisterSecs;
  int (*setSipUACfgTimerReRegisterSecs)(struct sip_uacfg_timer_entry*, u_int);

} SipUACfgTimerEntry;

typedef struct sip_uacfg_retry_entry {
  
  u_int sipUACfgRetryInviteTimes;
  int (*setSipUACfgRetryInviteTimes)(struct sip_uacfg_retry_entry*, u_int);

  u_int sipUACfgRetryByeTimes;
  int (*setSipUACfgRetryByeTimes)(struct sip_uacfg_retry_entry*, u_int);

  u_int sipUACfgRetryCancelTimes;
  int (*setSipUACfgRetryCancelTimes)(struct sip_uacfg_retry_entry*, u_int);

  u_int sipUACfgRetryRegisterTimes;
  int (*setSipUACfgRetryRegisterTimes)(struct sip_uacfg_retry_entry*, u_int);

  u_int sipUACfgRetryResponseTimes;
  int (*setSipUACfgRetryResponseTimes)(struct sip_uacfg_retry_entry*, u_int);

} SipUACfgRetryEntry;

typedef struct sip_ua_stats_entry {
  
  u_int sipUAStatsRetryInvites;
  u_int sipUAStatsRetryByes;
  u_int sipUAStatsRetryCancels;
  u_int sipUAStatsRetryRegisters;
  u_int sipUAStatsRetryResponses;

} SipUAStatsEntry;

typedef struct sip_uas {
  
  SipUACfgTimerEntry  sipUACfgTimerEntry;
  SipUACfgRetryEntry  sipUACfgRetryEntry;
  SipUAStatsEntry     sipUAStatsEntry;

} SipUAS;

#endif          /*sipentity_uads.h*/
