# Columbia SNMP support provider, for sipd, fragment makefile
# Copyright 2001 by Columbia University; all rights reserved 
# Adapted from other module.mk files in the cinema system.

libsipsnmp_dir := $(topdir)/libsipsnmp

LIBSIPSNMP_SRC := \
  $(libsipsnmp_dir)/sipsnmp_main.c \
  $(libsipsnmp_dir)/sipsnmp_utils.c \
  $(libsipsnmp_dir)/sipMIB.c \
  $(libsipsnmp_dir)/snmp_sp.c \
  $(libsipsnmp_dir)/trans_impl.c \
  $(libsipsnmp_dir)/registrar_impl.c 

LIBSIPSNMP_HEADERS := \
  $(libsipsnmp_dir)/sipsnmp_utils.h \
  $(libsipsnmp_dir)/sipentity_ds.h \
  $(libsipsnmp_dir)/mib2headers/sipentity_commonds.h \
  $(libsipsnmp_dir)/mib2headers/sipentity_registrards.h \
  $(libsipsnmp_dir)/mib2headers/sipentity_serverds.h \
  $(libsipsnmp_dir)/sipMIB.h 

# LIBSIPSNMP_MISC also includes some of the .c files which
# are not compiled explicitly but are included in other
# .c files using #include(s)

LIBSIPSNMP_MISC := \
  $(libsipsnmp_dir)/module.mk \
  $(libsipsnmp_dir)/libsipsnmp.dsp \
  $(libsipsnmp_dir)/README \
  $(libsipsnmp_dir)/commoncfg.c \
  $(libsipsnmp_dir)/commonstats.c \
  $(libsipsnmp_dir)/proxy.c \
  $(libsipsnmp_dir)/registrar.c \
  $(libsipsnmp_dir)/transactions.c \
  $(libsipsnmp_dir)/trapgen.c \
  $(libsipsnmp_dir)/ua.c


LIBSIPSNMP_MISCDIST := \
  $(libsipsnmp_dir)/INSTALL.README

LIBSIPSNMP_MISCCLEAN := \
  $(libsipsnmp_dir)/libsipsnmp.a


LIBSIPSNMP_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(LIBSIPSNMP_SRC)))

LIBSIPSNMP_DEP := \
	$(LIBSIPSNMP_OBJ:.o=.d)


# How other parts of the build find us:
# Target for make:
LIBSIPSNMP := $(libsipsnmp_dir)/libsipsnmp.a


# Incantations for compile and build:
LIBSIPSNMP_INC := -I$(topsrcdir)/$(libsipsnmp_dir) -I$(topsrcdir)/$(libsipsnmp_dir)/mib2headers 
LIBSIPSNMP_LIB := -L$(libsipsnmp_dir) -lsipsnmp $(SNMPLIBS)


# Include files required locally.
LIBSIPSNMP_INCS := $(LIBCINE_INC) $(LIBSIP_INC) $(DBAPI_INC) $(LIBSIPSNMP_INC)


$(LIBSIPSNMP_OBJ): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(LIBSIPSNMP_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(LIBSIPSNMP_DEP): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(libsipsnmp_dir) -o $@ $(LIBSIPSNMP_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<

$(LIBSIPSNMP): $(LIBSIPSNMP_OBJ)
	@echo "creating library $@..."
	$(AR) rc $@ $^
	$(RANLIB) $@

SRC       += $(LIBSIPSNMP_SRC) 
HEADERS   += $(LIBSIPSNMP_HEADERS)
MISC      += $(LIBSIPSNMP_MISC) 
MISCDIST  += $(LIBSIPSNMP_MISCDIST)
MISCCLEAN += $(LIBSIPSNMP_MISCCLEAN)

# Files for distributions:
LIBSIPSNMP_DIST := $(LIBSIPSNMP_SRC) $(LIBSIPSNMP_HEADERS) \
	$(LIBSIPSNMP_MISC) $(LIBSIPSNMP_MISCDIST)

LIBSIPSNMP_BINDIST := $(LIBSIPSNMP_MISCDIST)