/*
 * This file implements the ucd-snmp/SNMP specific parts of the sip-snmp
 * support provider interface.
 */

#ifdef USE_SNMP 
/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. 
*/


#ifdef IN_UCD_SNMP_SOURCE

/* If we're compiling this file inside the ucd-snmp source tree */

/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */

#include <ucd-snmp/ucd-snmp-config.h>
#include <ucd-snmp/ucd-snmp-includes.h>
#include <ucd-snmp/ucd-snmp-agent-includes.h>
#include <ucd-snmp/util_funcs.h>
#include <ucd-snmp/agent_trap.h>

#endif /* !IN_UCD_SNMP_SOURCE */


#include "sipMIB.h"

/* forward declarations of our callback functions - 
 * from sipMIB.h moved here and made static
 */
static FindVarMethod var_sipCommonCfgTable;

static FindVarMethod var_sipPortTable;

static FindVarMethod var_sipUriSupportedTable;

static FindVarMethod var_sipFtrSupportedTable;

static FindVarMethod var_sipSummaryStatsTable;

static FindVarMethod var_sipMethodStatsTable;

static FindVarMethod var_sipStatsExtMethodTable;

static FindVarMethod var_sipStatusCodesTable;

static FindVarMethod var_sipCommonStatusCodeTable;

static FindVarMethod var_sipCurrentTransTable;

static FindVarMethod var_sipTransactionTable;

static FindVarMethod var_sipOtherStatsTable;

static FindVarMethod var_sipUACfgTimerTable;

static FindVarMethod var_sipUACfgRetryTable;

static FindVarMethod var_sipUAStatsRetryTable;

static FindVarMethod var_sipServerCfgTable;

static FindVarMethod var_sipProxyCfgTable;

static FindVarMethod var_sipRxProxyAuthTable;

static FindVarMethod var_sipProxyStatsTable;

static FindVarMethod var_sipRegCfgTable;

static FindVarMethod var_sipRegUserTable;

static FindVarMethod var_sipContactTable;

static FindVarMethod var_sipRegStatsTable;


static WriteMethod write_sipServiceAdminStatus;
static WriteMethod write_sipOrganization;
static WriteMethod write_sipInviteTimeout;
static WriteMethod write_sipHideOperation;
static WriteMethod write_sipUserLocationServerAddr;
static WriteMethod write_sipRequestUriHostMatching;
static WriteMethod write_sipTransport;
static WriteMethod write_sipPortStatus;
static WriteMethod write_sipStatsExtMethodName;
static WriteMethod write_sipStatsExtMethodStatus;
static WriteMethod write_sipCommonStatusCodeSendNotif;
static WriteMethod write_sipCommonStatusCodeStatus;

/*-deprecated
static WriteMethod write_sipUACfgTimerTrying;
static WriteMethod write_sipUACfgTimerProv;
static WriteMethod write_sipUACfgTimerAck;
static WriteMethod write_sipUACfgTimerDisconnect;
static WriteMethod write_sipUACfgTimerReRegister;
static WriteMethod write_sipUACfgRetryInvite;
static WriteMethod write_sipUACfgRetryBye;
static WriteMethod write_sipUACfgRetryCancel;
static WriteMethod write_sipUACfgRetryRegister;
static WriteMethod write_sipUACfgRetryResponse;
*/

static WriteMethod write_sipServerHost;
static WriteMethod write_sipInformationAlwaysSendTrying;
static WriteMethod write_sipInformationTryingInterval;
static WriteMethod write_sipServerDfltAction;
static WriteMethod write_sipServerRespectUAAction;
static WriteMethod write_sipRequestMaxExpires;
static WriteMethod write_sipProxyStateful;
static WriteMethod write_sipProxySendsCancel;
static WriteMethod write_sipProxyForwardAll1xx;
static WriteMethod write_sipProxyRecursion;
static WriteMethod write_sipProxyProvideAlternatives;
static WriteMethod write_sipProxyRecordRoute;
static WriteMethod write_sipProxyStateTimeout;
static WriteMethod write_sipProxyAuthMethod;
static WriteMethod write_sipProxyAuthPgpAlgorithm;
static WriteMethod write_sipProxyAuthRealm;
static WriteMethod write_sipProxyNonceLifeTime;
static WriteMethod write_sipPgpPrivateKey;
static WriteMethod write_sipHideRespect;

/* - not implemented, as doesnt seem to make a lot of sense
static WriteMethod write_sipRxProxyAuthRealm;
static WriteMethod write_sipRxProxyAuthPassword;
static WriteMethod write_sipRxProxyAuthStatus;
*/

static WriteMethod write_sipRegAllowThirdParty;
static WriteMethod write_sipRegContactDfltExpiryDuration;
static WriteMethod write_sipRegContactDfltExpiryDate;
static WriteMethod write_sipRegMaxContactExpiryDate;
static WriteMethod write_sipRegRespHasContacts;
static WriteMethod write_sipUserUri;
static WriteMethod write_sipUserPassword;
static WriteMethod write_sipUserTableRowStatus;

/* 
 * sipMIB_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid sipMIB_variables_oid[] = { 1,3,6,1,2,1,9998 };
#define SIPMIB_OIDLEN ((sizeof(sipMIB_variables_oid)/sizeof(oid)))

/* 
 * variable7 sipMIB_variables:
 *   this variable defines function callbacks and type return information 
 *   for the sipMIB mib section 
 */


struct variable7 sipMIB_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define   SIPPROTOCOLVERSION    3
  { SIPPROTOCOLVERSION  , ASN_OCTET_STR , RONLY , var_sipCommonCfgTable, 5, { 2,1,1,1,1 } },
#define   SIPSERVICEOPERSTATUS  4
  { SIPSERVICEOPERSTATUS, ASN_INTEGER   , RONLY , var_sipCommonCfgTable, 5, { 2,1,1,1,2 } },
#define   SIPSERVICEADMINSTATUS  5
  { SIPSERVICEADMINSTATUS, ASN_INTEGER   , RWRITE, var_sipCommonCfgTable, 5, { 2,1,1,1,3 } },
#define   SIPSERVICESTARTTIME   6
  { SIPSERVICESTARTTIME , ASN_TIMETICKS , RONLY , var_sipCommonCfgTable, 5, { 2,1,1,1,4 } },
#define   SIPSERVICELASTCHANGE  7
  { SIPSERVICELASTCHANGE, ASN_TIMETICKS , RONLY , var_sipCommonCfgTable, 5, { 2,1,1,1,5 } },
#define   SIPORGANIZATION       8
  { SIPORGANIZATION     , ASN_OCTET_STR , RWRITE, var_sipCommonCfgTable, 5, { 2,1,1,1,6 } },
#define   SIPMAXTRANSACTIONS    9
  { SIPMAXTRANSACTIONS  , ASN_GAUGE   , RONLY , var_sipCommonCfgTable, 5, { 2,1,1,1,7 } },
#define   SIPINVITETIMEOUT      10
  { SIPINVITETIMEOUT    , ASN_GAUGE   , RWRITE, var_sipCommonCfgTable, 5, { 2,1,1,1,8 } },
#define   SIPHIDEOPERATION      11
  { SIPHIDEOPERATION    , ASN_INTEGER   , RWRITE, var_sipCommonCfgTable, 5, { 2,1,1,1,9 } },
#define   SIPUSERLOCATIONSERVERADDR  12
  { SIPUSERLOCATIONSERVERADDR, ASN_OCTET_STR , RWRITE, var_sipCommonCfgTable, 5, { 2,1,1,1,10 } },
#define   SIPCANUSECOMPACT      13
  { SIPCANUSECOMPACT    , ASN_INTEGER   , RONLY , var_sipCommonCfgTable, 5, { 2,1,1,1,11 } },
#define   SIPREQUESTURIHOSTMATCHING  14
  { SIPREQUESTURIHOSTMATCHING, ASN_INTEGER   , RWRITE, var_sipCommonCfgTable, 5, { 2,1,1,1,12 } },
#define   SIPTRANSPORT          18
  { SIPTRANSPORT        , ASN_INTEGER   , RWRITE, var_sipPortTable, 5, { 2,1,2,1,2 } },
#define   SIPPORTSTATUS         19
  { SIPPORTSTATUS       , ASN_INTEGER   , RWRITE, var_sipPortTable, 5, { 2,1,2,1,3 } },
#define   SIPURISUPPORTED       23
  { SIPURISUPPORTED     , ASN_OCTET_STR , RONLY , var_sipUriSupportedTable, 5, { 2,1,3,1,2 } },
#define   SIPFTRSUPPORTED       27
  { SIPFTRSUPPORTED     , ASN_OCTET_STR , RONLY , var_sipFtrSupportedTable, 5, { 2,1,4,1,2 } },
#define   SIPSUMMARYINREQUESTS  30
  { SIPSUMMARYINREQUESTS, ASN_COUNTER   , RONLY , var_sipSummaryStatsTable, 6, { 2,2,1,1,1,1 } },
#define   SIPSUMMARYOUTREQUESTS  31
  { SIPSUMMARYOUTREQUESTS, ASN_COUNTER   , RONLY , var_sipSummaryStatsTable, 6, { 2,2,1,1,1,2 } },
#define   SIPSUMMARYINRESPONSES  32
  { SIPSUMMARYINRESPONSES, ASN_COUNTER   , RONLY , var_sipSummaryStatsTable, 6, { 2,2,1,1,1,3 } },
#define   SIPSUMMARYOUTRESPONSES  33
  { SIPSUMMARYOUTRESPONSES, ASN_COUNTER   , RONLY , var_sipSummaryStatsTable, 6, { 2,2,1,1,1,4 } },
#define   SIPSUMMARYTOTALTRANSACTIONS  34
  { SIPSUMMARYTOTALTRANSACTIONS, ASN_COUNTER   , RONLY , var_sipSummaryStatsTable, 6, { 2,2,1,1,1,5 } },
#define   SIPSTATSINVITEINS     37
  { SIPSTATSINVITEINS   , ASN_COUNTER   , RONLY , var_sipMethodStatsTable, 6, { 2,2,2,1,1,1 } },
#define   SIPSTATSINVITEOUTS    38
  { SIPSTATSINVITEOUTS  , ASN_COUNTER   , RONLY , var_sipMethodStatsTable, 6, { 2,2,2,1,1,2 } },
#define   SIPSTATSACKINS        39
  { SIPSTATSACKINS      , ASN_COUNTER   , RONLY , var_sipMethodStatsTable, 6, { 2,2,2,1,1,3 } },
#define   SIPSTATSACKOUTS       40
  { SIPSTATSACKOUTS     , ASN_COUNTER   , RONLY , var_sipMethodStatsTable, 6, { 2,2,2,1,1,4 } },
#define   SIPSTATSBYEINS        41
  { SIPSTATSBYEINS      , ASN_COUNTER   , RONLY , var_sipMethodStatsTable, 6, { 2,2,2,1,1,5 } },
#define   SIPSTATSBYEOUTS       42
  { SIPSTATSBYEOUTS     , ASN_COUNTER   , RONLY , var_sipMethodStatsTable, 6, { 2,2,2,1,1,6 } },
#define   SIPSTATSCANCELINS     43
  { SIPSTATSCANCELINS   , ASN_COUNTER   , RONLY , var_sipMethodStatsTable, 6, { 2,2,2,1,1,7 } },
#define   SIPSTATSCANCELOUTS    44
  { SIPSTATSCANCELOUTS  , ASN_COUNTER   , RONLY , var_sipMethodStatsTable, 6, { 2,2,2,1,1,8 } },
#define   SIPSTATSOPTIONSINS    45
  { SIPSTATSOPTIONSINS  , ASN_COUNTER   , RONLY , var_sipMethodStatsTable, 6, { 2,2,2,1,1,9 } },
#define   SIPSTATSOPTIONSOUTS   46
  { SIPSTATSOPTIONSOUTS , ASN_COUNTER   , RONLY , var_sipMethodStatsTable, 6, { 2,2,2,1,1,10 } },
#define   SIPSTATSREGISTERINS   47
  { SIPSTATSREGISTERINS , ASN_COUNTER   , RONLY , var_sipMethodStatsTable, 6, { 2,2,2,1,1,11 } },
#define   SIPSTATSREGISTEROUTS  48
  { SIPSTATSREGISTEROUTS, ASN_COUNTER   , RONLY , var_sipMethodStatsTable, 6, { 2,2,2,1,1,12 } },
#define   SIPSTATSEXTMETHODNAME  52
  { SIPSTATSEXTMETHODNAME, ASN_OCTET_STR , RWRITE, var_sipStatsExtMethodTable, 6, { 2,2,2,2,1,2 } },
#define   SIPSTATSEXTMETHODINS  53
  { SIPSTATSEXTMETHODINS, ASN_COUNTER   , RONLY , var_sipStatsExtMethodTable, 6, { 2,2,2,2,1,3 } },
#define   SIPSTATSEXTMETHODOUTS  54
  { SIPSTATSEXTMETHODOUTS, ASN_COUNTER   , RONLY , var_sipStatsExtMethodTable, 6, { 2,2,2,2,1,4 } },
#define   SIPSTATSEXTMETHODSTATUS  55
  { SIPSTATSEXTMETHODSTATUS, ASN_INTEGER   , RWRITE, var_sipStatsExtMethodTable, 6, { 2,2,2,2,1,5 } },
#define   SIPSTATSINFOCLASSINS  58
  { SIPSTATSINFOCLASSINS, ASN_COUNTER   , RONLY , var_sipStatusCodesTable, 6, { 2,2,3,1,1,1 } },
#define   SIPSTATSINFOCLASSOUTS  59
  { SIPSTATSINFOCLASSOUTS, ASN_COUNTER   , RONLY , var_sipStatusCodesTable, 6, { 2,2,3,1,1,2 } },
#define   SIPSTATSSUCCESSCLASSINS  60
  { SIPSTATSSUCCESSCLASSINS, ASN_COUNTER   , RONLY , var_sipStatusCodesTable, 6, { 2,2,3,1,1,3 } },
#define   SIPSTATSSUCCESSCLASSOUTS  61
  { SIPSTATSSUCCESSCLASSOUTS, ASN_COUNTER   , RONLY , var_sipStatusCodesTable, 6, { 2,2,3,1,1,4 } },
#define   SIPSTATSREDIRCLASSINS  62
  { SIPSTATSREDIRCLASSINS, ASN_COUNTER   , RONLY , var_sipStatusCodesTable, 6, { 2,2,3,1,1,5 } },
#define   SIPSTATSREDIRCLASSOUTS  63
  { SIPSTATSREDIRCLASSOUTS, ASN_COUNTER   , RONLY , var_sipStatusCodesTable, 6, { 2,2,3,1,1,6 } },
#define   SIPSTATSREQFAILCLASSINS  64
  { SIPSTATSREQFAILCLASSINS, ASN_COUNTER   , RONLY , var_sipStatusCodesTable, 6, { 2,2,3,1,1,7 } },
#define   SIPSTATSREQFAILCLASSOUTS  65
  { SIPSTATSREQFAILCLASSOUTS, ASN_COUNTER   , RONLY , var_sipStatusCodesTable, 6, { 2,2,3,1,1,8 } },
#define   SIPSTATSSERVERFAILCLASSINS  66
  { SIPSTATSSERVERFAILCLASSINS, ASN_COUNTER   , RONLY , var_sipStatusCodesTable, 6, { 2,2,3,1,1,9 } },
#define   SIPSTATSSERVERFAILCLASSOUTS  67
  { SIPSTATSSERVERFAILCLASSOUTS, ASN_COUNTER   , RONLY , var_sipStatusCodesTable, 6, { 2,2,3,1,1,10 } },
#define   SIPSTATSGLOBALFAILCLASSINS  68
  { SIPSTATSGLOBALFAILCLASSINS, ASN_COUNTER   , RONLY , var_sipStatusCodesTable, 6, { 2,2,3,1,1,11 } },
#define   SIPSTATSGLOBALFAILCLASSOUTS  69
  { SIPSTATSGLOBALFAILCLASSOUTS, ASN_COUNTER   , RONLY , var_sipStatusCodesTable, 6, { 2,2,3,1,1,12 } },
#define   SIPCOMMONSTATUSCODEINS  73
  { SIPCOMMONSTATUSCODEINS, ASN_COUNTER   , RONLY , var_sipCommonStatusCodeTable, 6, { 2,2,3,2,1,2 } },
#define   SIPCOMMONSTATUSCODEOUTS  74
  { SIPCOMMONSTATUSCODEOUTS, ASN_COUNTER   , RONLY , var_sipCommonStatusCodeTable, 6, { 2,2,3,2,1,3 } },
#define   SIPCOMMONSTATUSCODESENDNOTIF  75
  { SIPCOMMONSTATUSCODESENDNOTIF, ASN_INTEGER   , RWRITE, var_sipCommonStatusCodeTable, 6, { 2,2,3,2,1,4 } },
#define   SIPCOMMONSTATUSCODESTATUS  76
  { SIPCOMMONSTATUSCODESTATUS, ASN_INTEGER   , RWRITE, var_sipCommonStatusCodeTable, 6, { 2,2,3,2,1,5 } },
#define   SIPCURRENTTRANSACTIONS  79
  { SIPCURRENTTRANSACTIONS, ASN_GAUGE     , RONLY , var_sipCurrentTransTable, 6, { 2,2,4,1,1,1 } },
#define   SIPTRANSTO            83
  { SIPTRANSTO          , ASN_OCTET_STR , RONLY , var_sipTransactionTable, 6, { 2,2,4,2,1,2 } },
#define   SIPTRANSFROM          84
  { SIPTRANSFROM        , ASN_OCTET_STR , RONLY , var_sipTransactionTable, 6, { 2,2,4,2,1,3 } },
#define   SIPTRANSCALLID        85
  { SIPTRANSCALLID      , ASN_OCTET_STR , RONLY , var_sipTransactionTable, 6, { 2,2,4,2,1,4 } },
#define   SIPTRANSCSEQ          86
  { SIPTRANSCSEQ        , ASN_INTEGER   , RONLY , var_sipTransactionTable, 6, { 2,2,4,2,1,5 } },
#define   SIPTRANSSTATE         87
  { SIPTRANSSTATE       , ASN_INTEGER   , RONLY , var_sipTransactionTable, 6, { 2,2,4,2,1,6 } },
#define   SIPTRANSNUMOUTSTANDINGBRANCHES  88
  { SIPTRANSNUMOUTSTANDINGBRANCHES, ASN_INTEGER   , RONLY , var_sipTransactionTable, 6, { 2,2,4,2,1,7 } },
#define   SIPTRANSEXPIRY        89
  { SIPTRANSEXPIRY      , ASN_OCTET_STR , RONLY , var_sipTransactionTable, 6, { 2,2,4,2,1,8 } },
#define   SIPTRANSCALLINGPARTYCONTENTTYPE  90
  { SIPTRANSCALLINGPARTYCONTENTTYPE, ASN_OCTET_STR , RONLY , var_sipTransactionTable, 6, { 2,2,4,2,1,9 } },
#define   SIPTRANSCALLEDPARTYCONTENTTYPE  91
  { SIPTRANSCALLEDPARTYCONTENTTYPE, ASN_OCTET_STR , RONLY , var_sipTransactionTable, 6, { 2,2,4,2,1,10 } },
#define   SIPNUMUNSUPPORTEDURIS  94
  { SIPNUMUNSUPPORTEDURIS, ASN_COUNTER   , RONLY , var_sipOtherStatsTable, 5, { 2,2,5,1,5 } },
#define   SIPUACFGTIMERTRYING   97
  { SIPUACFGTIMERTRYING , ASN_INTEGER   , RWRITE, var_sipUACfgTimerTable, 6, { 3,1,1,1,1,1 } },
#define   SIPUACFGTIMERPROV     98
  { SIPUACFGTIMERPROV   , ASN_INTEGER   , RWRITE, var_sipUACfgTimerTable, 6, { 3,1,1,1,1,2 } },
#define   SIPUACFGTIMERACK      99
  { SIPUACFGTIMERACK    , ASN_INTEGER   , RWRITE, var_sipUACfgTimerTable, 6, { 3,1,1,1,1,3 } },
#define   SIPUACFGTIMERDISCONNECT  100
  { SIPUACFGTIMERDISCONNECT, ASN_INTEGER   , RWRITE, var_sipUACfgTimerTable, 6, { 3,1,1,1,1,4 } },
#define   SIPUACFGTIMERREREGISTER  101
  { SIPUACFGTIMERREREGISTER, ASN_INTEGER   , RWRITE, var_sipUACfgTimerTable, 6, { 3,1,1,1,1,5 } },
#define   SIPUACFGRETRYINVITE   104
  { SIPUACFGRETRYINVITE , ASN_INTEGER   , RWRITE, var_sipUACfgRetryTable, 6, { 3,1,2,1,1,1 } },
#define   SIPUACFGRETRYBYE      105
  { SIPUACFGRETRYBYE    , ASN_INTEGER   , RWRITE, var_sipUACfgRetryTable, 6, { 3,1,2,1,1,2 } },
#define   SIPUACFGRETRYCANCEL   106
  { SIPUACFGRETRYCANCEL , ASN_INTEGER   , RWRITE, var_sipUACfgRetryTable, 6, { 3,1,2,1,1,3 } },
#define   SIPUACFGRETRYREGISTER  107
  { SIPUACFGRETRYREGISTER, ASN_INTEGER   , RWRITE, var_sipUACfgRetryTable, 6, { 3,1,2,1,1,4 } },
#define   SIPUACFGRETRYRESPONSE  108
  { SIPUACFGRETRYRESPONSE, ASN_INTEGER   , RWRITE, var_sipUACfgRetryTable, 6, { 3,1,2,1,1,5 } },
#define   SIPSTATSRETRYINVITES  111
  { SIPSTATSRETRYINVITES, ASN_COUNTER   , RONLY , var_sipUAStatsRetryTable, 6, { 3,2,1,1,1,1 } },
#define   SIPSTATSRETRYBYES     112
  { SIPSTATSRETRYBYES   , ASN_COUNTER   , RONLY , var_sipUAStatsRetryTable, 6, { 3,2,1,1,1,2 } },
#define   SIPSTATSRETRYCANCELS  113
  { SIPSTATSRETRYCANCELS, ASN_COUNTER   , RONLY , var_sipUAStatsRetryTable, 6, { 3,2,1,1,1,3 } },
#define   SIPSTATSRETRYREGISTERS  114
  { SIPSTATSRETRYREGISTERS, ASN_COUNTER   , RONLY , var_sipUAStatsRetryTable, 6, { 3,2,1,1,1,4 } },
#define   SIPSTATSRETRYRESPONSES  115
  { SIPSTATSRETRYRESPONSES, ASN_COUNTER   , RONLY , var_sipUAStatsRetryTable, 6, { 3,2,1,1,1,5 } },
#define   SIPSERVERHOST         118
  { SIPSERVERHOST       , ASN_OCTET_STR , RWRITE, var_sipServerCfgTable, 5, { 4,1,1,1,1 } },
#define   SIPINFORMATIONALWAYSSENDTRYING  119
  { SIPINFORMATIONALWAYSSENDTRYING, ASN_INTEGER   , RWRITE, var_sipServerCfgTable, 5, { 4,1,1,1,2 } },
#define   SIPINFORMATIONTRYINGINTERVAL  120
  { SIPINFORMATIONTRYINGINTERVAL, ASN_INTEGER   , RWRITE, var_sipServerCfgTable, 5, { 4,1,1,1,3 } },
#define   SIPPGPVERSION         121
  { SIPPGPVERSION       , ASN_OCTET_STR , RONLY , var_sipServerCfgTable, 5, { 4,1,1,1,4 } },
#define   SIPSERVERDFLTACTION   122
  { SIPSERVERDFLTACTION , ASN_INTEGER   , RWRITE, var_sipServerCfgTable, 5, { 4,1,1,1,5 } },
#define   SIPSERVERRESPECTUAACTION  123
  { SIPSERVERRESPECTUAACTION, ASN_INTEGER   , RWRITE, var_sipServerCfgTable, 5, { 4,1,1,1,6 } },
#define   SIPREQUESTMAXEXPIRES  126
  { SIPREQUESTMAXEXPIRES, ASN_INTEGER   , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,1 } },
#define   SIPPROXYSTATEFUL      127
  { SIPPROXYSTATEFUL    , ASN_INTEGER   , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,2 } },
#define   SIPPROXYSENDSCANCEL   128
  { SIPPROXYSENDSCANCEL , ASN_INTEGER   , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,3 } },
#define   SIPPROXYFORWARDALL1XX  129
  { SIPPROXYFORWARDALL1XX, ASN_INTEGER   , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,4 } },
#define   SIPPROXYRECURSION     130
  { SIPPROXYRECURSION   , ASN_INTEGER   , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,5 } },
#define   SIPPROXYPROVIDEALTERNATIVES  131
  { SIPPROXYPROVIDEALTERNATIVES, ASN_INTEGER   , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,6 } },
#define   SIPPROXYRECORDROUTE   132
  { SIPPROXYRECORDROUTE , ASN_INTEGER   , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,7 } },
#define   SIPPROXYSTATETIMEOUT  133
  { SIPPROXYSTATETIMEOUT, ASN_INTEGER   , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,8 } },
#define   SIPPROXYAUTHMETHOD    134
  { SIPPROXYAUTHMETHOD  , ASN_INTEGER   , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,9 } },
#define   SIPPROXYAUTHPGPALGORITHM  135
  { SIPPROXYAUTHPGPALGORITHM, ASN_INTEGER   , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,10 } },
#define   SIPPROXYAUTHREALM     136
  { SIPPROXYAUTHREALM   , ASN_OCTET_STR , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,11 } },
#define   SIPPROXYNONCELIFETIME  137
  { SIPPROXYNONCELIFETIME, ASN_INTEGER   , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,12 } },
#define   SIPPGPPRIVATEKEY      138
  { SIPPGPPRIVATEKEY    , ASN_OCTET_STR , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,13 } },
#define   SIPHIDERESPECT        139
  { SIPHIDERESPECT      , ASN_INTEGER   , RWRITE, var_sipProxyCfgTable, 6, { 4,3,1,1,1,14 } },
#define   SIPRXPROXYAUTHREALM   143
  { SIPRXPROXYAUTHREALM , ASN_OCTET_STR , RWRITE, var_sipRxProxyAuthTable, 6, { 4,3,1,2,1,2 } },
#define   SIPRXPROXYAUTHPASSWORD  144
  { SIPRXPROXYAUTHPASSWORD, ASN_OCTET_STR , RWRITE, var_sipRxProxyAuthTable, 6, { 4,3,1,2,1,3 } },
#define   SIPRXPROXYAUTHSTATUS  145
  { SIPRXPROXYAUTHSTATUS, ASN_INTEGER   , RWRITE, var_sipRxProxyAuthTable, 6, { 4,3,1,2,1,4 } },
#define   SIPNUMPROXYREQUIREFAILURES  148
  { SIPNUMPROXYREQUIREFAILURES, ASN_COUNTER   , RONLY , var_sipProxyStatsTable, 6, { 4,3,2,1,1,1 } },
#define   SIPREGALLOWTHIRDPARTY  151
  { SIPREGALLOWTHIRDPARTY, ASN_INTEGER   , RWRITE, var_sipRegCfgTable, 5, { 5,1,1,1,1 } },
#define   SIPREGCONTACTDFLTEXPIRYDURATION  152
  { SIPREGCONTACTDFLTEXPIRYDURATION, ASN_INTEGER   , RWRITE, var_sipRegCfgTable, 5, { 5,1,1,1,2 } },
#define   SIPREGCONTACTDFLTEXPIRYDATE  153
  { SIPREGCONTACTDFLTEXPIRYDATE, ASN_OCTET_STR , RWRITE, var_sipRegCfgTable, 5, { 5,1,1,1,3 } },
#define   SIPREGMAXCONTACTEXPIRYDATE  154
  { SIPREGMAXCONTACTEXPIRYDATE, ASN_INTEGER   , RWRITE, var_sipRegCfgTable, 5, { 5,1,1,1,4 } },
#define   SIPREGRESPHASCONTACTS  155
  { SIPREGRESPHASCONTACTS, ASN_INTEGER   , RWRITE, var_sipRegCfgTable, 5, { 5,1,1,1,5 } },
#define   SIPREGMAXUSERS        156
  { SIPREGMAXUSERS      , ASN_GAUGE   , RONLY , var_sipRegCfgTable, 5, { 5,1,1,1,6 } },
#define   SIPREGCURRENTUSERS    157
  { SIPREGCURRENTUSERS  , ASN_GAUGE     , RONLY , var_sipRegCfgTable, 5, { 5,1,1,1,7 } },
#define   SIPUSERURI            161
  { SIPUSERURI          , ASN_OCTET_STR , RWRITE, var_sipRegUserTable, 5, { 5,1,2,1,2 } },
#define   SIPUSERPASSWORD       162
  { SIPUSERPASSWORD     , ASN_OCTET_STR , RWRITE, var_sipRegUserTable, 5, { 5,1,2,1,3 } },
#define   SIPUSERAUTHENTICATIONFAILURES  163
  { SIPUSERAUTHENTICATIONFAILURES, ASN_COUNTER   , RONLY , var_sipRegUserTable, 5, { 5,1,2,1,4 } },
#define   SIPUSERTABLEROWSTATUS  164
  { SIPUSERTABLEROWSTATUS, ASN_INTEGER   , RWRITE, var_sipRegUserTable, 5, { 5,1,2,1,5 } },
#define   SIPCONTACTDISPLAYNAME  168
  { SIPCONTACTDISPLAYNAME, ASN_OCTET_STR , RONLY , var_sipContactTable, 5, { 5,1,3,1,2 } },
#define   SIPCONTACTURI         169
  { SIPCONTACTURI       , ASN_OCTET_STR , RONLY , var_sipContactTable, 5, { 5,1,3,1,3 } },
#define   SIPCONTACTLASTUPDATED  170
  { SIPCONTACTLASTUPDATED, ASN_TIMETICKS , RONLY , var_sipContactTable, 5, { 5,1,3,1,4 } },
#define   SIPCONTACTEXPIRY      171
  { SIPCONTACTEXPIRY    , ASN_OCTET_STR , RONLY , var_sipContactTable, 5, { 5,1,3,1,5 } },
#define   SIPCONTACTPREFERENCE  172
  { SIPCONTACTPREFERENCE, ASN_OCTET_STR , RONLY , var_sipContactTable, 5, { 5,1,3,1,6 } },
#define   SIPCONTACTACTION      173
  { SIPCONTACTACTION    , ASN_INTEGER   , RONLY , var_sipContactTable, 5, { 5,1,3,1,7 } },
#define   SIPCONTACTRETRYAFTER  174
  { SIPCONTACTRETRYAFTER, ASN_OCTET_STR , RONLY , var_sipContactTable, 5, { 5,1,3,1,8 } },
#define   SIPREGACCEPTEDREGISTRATIONS  177
  { SIPREGACCEPTEDREGISTRATIONS, ASN_COUNTER   , RONLY , var_sipRegStatsTable, 5, { 5,2,1,1,1 } },
#define   SIPREGREJECTEDREGISTRATIONS  178
  { SIPREGREJECTEDREGISTRATIONS, ASN_COUNTER   , RONLY , var_sipRegStatsTable, 5, { 5,2,1,1,2 } },

};
/*    (L = length of the oidsuffix) */


/*
 * init_sipMIB():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_sipMIB(void) {

 
  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("sipMIB", sipMIB_variables, variable7,
               sipMIB_variables_oid);

}

const static char* DEF_ERR = "Unrecognized var...";
#define DEFERR DEF_ERR

static long long_ret;
static unsigned char string[SPRINT_MAX_LEN];

#define GET_RETTYPE static unsigned char*

#define GET_PARAMS (struct variable *vp, \
		    oid *name,size_t  *length, \
		    int     exact, \
		    size_t  *var_len,\
		    WriteMethod **write_method)

#define GET_FUNCTION(X) GET_RETTYPE X GET_PARAMS

#define SET_RETTYPE static int

#define SET_PARAMS (int action,\
		    u_char   *var_val,\
		    u_char   var_val_type, size_t   var_val_len,\
		    u_char   *statP,\
		    oid      *name, size_t   name_len)

#define SET_FUNCTION(X) SET_RETTYPE X SET_PARAMS


#define __SIPSNMP_MIB__

#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "error.h"         /* from libsip */

#include "sipentity_ds.h"

#include "commoncfg.c"     /* implementation code for the commoncfg part */

#include "commonstats.c"   /* implementation code for the common stats and other stats part */

#include "transactions.c"  /* implementation code for the transaction table part */

#include "proxy.c"         /* code for the server specific part */

#include "registrar.c"     /* registrar server specific */

#include "trapgen.c"       /* trap generation */

#include "ua.c"            /* ua code, dummy placeholders */
#undef __SIPSNMP_MIB__

#endif

