/*
* Read configuration files.
* # comment
* <empty line>
* parameter value value ... \
*/

#include <stdio.h>
#include <ctype.h>    /* isspace() */
#include "strdupn.h"

#define MAX_LINE 1024

/*
* ConfigRead()
* Fill array argv[] (up to *argc entries) with arguments from file 'f'. 
* Return number of arguments, 0 on end-of-file.
*/
int ConfigRead(FILE *f, int *argc, char *argv[])
{
  char line[MAX_LINE], *s, *start = NULL;
  enum {C_word, C_between} state = C_between;
  int k = 0;

  do {
    if ((s = fgets(line, sizeof(line), f))) {
      if (*s == '#' || *s == '\n' || *s == '\r') continue;
      for (s = line; *s; s++) {
        switch(state) {
        case C_between:
          if (!isspace((int)*s)) {
            start = s;
            state = C_word;
          }
          break;
        case C_word:
          if (isspace((int)*s)) {
            if (k < *argc) argv[k++] = strdupn(start, s - start);
            state = C_between;
          }
          break;
        }
      }
      if (k > 0) break;
    }
  } while (s);
  *argc = k;
  return *argc;
} /* ConfigRead */
