/* 
 * Copyright (c) 2000 by Columbia University
 *
 * file: mpv.h
 * description: mpeg video interface module
 * author: Stephen Chou
 * email: schou@cs.columbia.edu
 */

#ifndef MPV_H
#define MPV_H

#ifdef __cplusplus
extern "C" {
#endif

// MPEG-1 video payload - this should be defined rtp_pt.h
#define RTP_PT_MPV 32

extern void* MpvOpen(char *path, char *track, int rw);


extern char* MpvDescribe(void* mpv, char* type);

extern int MpvSeek(void *mpv, double npt);


extern int MpvRead(void *mpv, 
		   char *buffer, 
		   double *npt, 
		   int *pt, 
		   int *tsinc);

extern int MpvWrite(void *mpv, 
		    int pt, 
		    u_int32 ts,
		    u_int16 seq, 
		    char *buffer,
		    int size, 
		    double *npt);

extern int MpvClose(void *mpv);

#ifdef __cplusplus
}
#endif

#endif









