#include "server.h"

STREAM          Stream[ STREAMS_NUM ];
int             NextStreamId=0;

void
ScheduleInit()
{
    int i;
 
    for(i=0;i<STREAMS_NUM;i++){
        Stream[i].id = INVALID_STREAM;
	Stream[i].state = INVALID_STATE;
        mutex_init(&Stream[i].stateMutex ,USYNC_THREAD,0);
    }

}

u_long
ScheduleStream()
{
    int i;
 
    for(i=0;i<STREAMS_NUM;i++)
    {
        if(Stream[i].id == INVALID_STREAM)
        {
            Stream[i].id = ++NextStreamId;
            return Stream[i].id;
        }
    }
    printf("ScheduleStream(): Error >>No Available ID ...\n");
    return INVALID_STREAM;
}

u_long
GetStream(u_long id)
{
int i;
 
    for (i=0; i<STREAMS_NUM; i++){
             if ( Stream[i].id == id ) return i;
        }
    return INVALID_STREAM;
}


void
RemoveStream(u_long id)
{
    int i;
 
    for (i=0; i<STREAMS_NUM; i++)
    {
        if ( Stream[i].id == id ) 
        {
            Stream[i].id = INVALID_STREAM;
            return;
        }
    }
   printf("RemoveStream(): There is no Stream with id = %d !\n",id);
}
 
PrintStreamsInfo()
{
    int i;
 
    printf("PrintStreamsInfo():\n");

    for (i=0; i<STREAMS_NUM; i++)
        if ( Stream[i].id != INVALID_STREAM )
            printf (" %d-th Stream : has id = %d \n", i,Stream[i].id );

}

PrintStreamInfo(u_long id)
{
int	i;

printf("PrintStreamInfo(%id):\n",id);
for (i=0; i<STREAMS_NUM; i++)
        if ( Stream[i].id == id ){
            printf (" %d-th Stream : has id = %d \n", i,Stream[i].id );
	    return;
        }

printf("PrintStreamInfo(): No Stream with id = %d \n", id);
return 1;
}


