#!/usr/local/bin/wish -f

proc trace {str} {
   puts "$str"
}
 
proc exiting {} {
    exit
}

proc temp {} {
    set msg "This command is not yet implemented!"
    tk_messageBox -default ok -type ok -icon info -message $msg -parent . -title "Help" 
}

proc readInput {} {
    global server
    global port
    global file
    set server "localhost"
    set port "8085"
    set file "file"
    set tempserver "localhost"
    set tempport "8084"
    toplevel .dlg
    frame .dlg.top
    frame .dlg.bottom
    label .dlg.label1 -text "Server rtsp://"
    entry .dlg.server -width 30 -relief sunken -textvariable  tempserver
    # label .dlg.label2 -text "Port:"
    # entry .dlg.port -width 6 -relief sunken -textvariable tempport 
    button .dlg.b1 -text "Ok" -command { 
	regexp -nocase {([a-z\.0-9\-]+)\:([0-9]*)([a-z0-9\./]*)} $tempserver junk server port file
	if [string length $server]>0 then { 
	    if [string length $port]>0 then { 
		#puts "Fine"
		exitinput 1 } else {
		    set msg "Please enter a Port Number at the server: $server to establish a connection"
		    tk_messageBox -default ok -type ok -icon error -message $msg -parent . -title "Info"
		}
	    } else {
		set msg "Please enter a valid port and server address for opening a new connection"
		tk_messageBox -default ok -type ok -icon error -message $msg -parent . -title "Info"
	    }
	} 
	button .dlg.b2 -text "Cancel" -command {exitinput 0}
	pack .dlg.top -side top -padx 3m -pady 3m
	pack .dlg.bottom -side bottom -padx 3m -pady 3m
	
	pack .dlg.label1 .dlg.server -in .dlg.top -side left -anchor w
	pack .dlg.b1 .dlg.b2 -in .dlg.bottom -side left -anchor w 
	
	grab set .dlg
    }
    
    proc exitinput {val} {
	grab release .dlg
	destroy -window .dlg
	if $val==1 start
    }
    
    proc start {} {
	toplevel .vcr
	global server 
	global port
	global file
	global sock
	global Seqnum
	set Seqnum 250
	set sock [socket $server $port]
        trace "socket $sock is created"

	#puts $sock
	# puts "Just read dock....sock"
	button .vcr.play -text "Set Up" -command { setup $sock }
	button .vcr.rec -text "Play" -command { play $sock }
	button .vcr.pause -text "Pause" -command { pause $sock}
	button .vcr.stop -text "Stop" -command { stop $sock}
	# puts $sock
	pack .vcr.play .vcr.rec .vcr.pause .vcr.stop -side left -padx 3m -pady 10m

        set rtspmsg "DESCRIBE rtsp://$server/$file RTSP/1.0\r\nCSeq: $Seqnum\r\nAccept: application/sdp, application/rtsl, application/mheg\r\n\r\n"
        incr Seqnum 
        send $sock 1 $rtspmsg
        trace "sent message\n$rtspmsg"
	receive $sock 1
        trace "received msg"
    }
        
    proc disconnect {} {
	global sock
	global file
	global server
	global Seqnum
	send $sock 1 "TEARDOWN rtsp://$server/$file RTSP/1.0\r\n"
	send $sock 1 "CSeq: $Seqnum\r\n\r\n"
	incr Seqnum
	receive $sock 1
	close "$sock"	
    }

    proc playsend {val param} {
	global sock
        grab release .play
        destroy -window .play
        if $val==1||$val==2 {
	    global file
	    global server
	    global Seqnum
	    puts "IN PLAY SEND"
	    send $sock 1 "PLAY rtsp://$server/$file RTSP/1.0\r\n"
	    send $sock 1 "CSeq: $Seqnum\r\n"
	    
	    incr Seqnum
	    if $val==1 {
		send $sock 1 "Range: $param\r\n"
	    }
            send $sock 1 "\r\n"
	    receive $sock 1
	}
    }
    
    proc play {chID} {

        toplevel .play
        frame .play.top
        frame .play.bottom
        label .play.label1 -text "Range Value:"
        entry .play.param  -width 30 -relief sunken -textvariable  playparam
        button .play.ok -text "OK" -command {
	    if [string length $playparam]>0 then {
                #puts "Fine"
                playsend 1 $playparam 
	    } else {
		playsend 2 "none"
	    }   
	}
	
	button .play.cancel -text "Cancel" -command { playsend 0 "none"}
	pack .play.top -side top -padx 3m -pady 3m
	pack .play.bottom -side bottom -padx 3m -pady 3m
	
        pack .play.label1 .play.param -in .play.top -side left -anchor w
        pack .play.ok .play.cancel -in .play.bottom -side left -anchor w
	
        grab set .play
	
    }
    
    proc setupsend {val param} {
	global sock 
	grab release .setup
	destroy -window .setup
	if $val==1 {
	    global file
	    global server
	    global Seqnum
	    
	    send $sock 1 "SETUP rtsp://$server/$file RTSP/1.0\r\n"
	    send $sock 1 "CSeq: $Seqnum\r\n"
	    incr Seqnum 
	    send $sock 1 "Transport: $param\r\n\r\n"
 	    receive $sock 1
	}
    }
    
    proc setup {chID} {
	
	toplevel .setup
	frame .setup.top
	frame .setup.bottom
	label .setup.label1 -text "Transport Parameters:"
	entry .setup.param  -width 30 -relief sunken -textvariable  setupparam
	button .setup.ok -text "OK" -command {
	    if [string length $setupparam]>0 then { 
		#puts "Fine"
		setupsend 1 $setupparam } else {
		    set msg "Please enter Transport parameters for this setup request. e.g  RTP/AVP;unicast"
		    tk_messageBox -default ok -type ok -icon error -message $msg -parent . -title "Info"
	    }   
	}
	button .setup.cancel -text "Cancel" -command { setupsend 0 "none"}
	pack .setup.top -side top -padx 3m -pady 3m
	pack .setup.bottom -side bottom -padx 3m -pady 3m
	
	pack .setup.label1 .setup.param -in .setup.top -side left -anchor w
	pack .setup.ok .setup.cancel -in .setup.bottom -side left -anchor w 
	
	grab set .setup
	
    }
        
    proc pause {chID} {
	global sock
	global file
	global server
	global Seqnum
	send $sock 1 "PAUSE rtsp://$server/$file RTSP/1.0\r\n"
	send $sock 1 "CSeq: $Seqnum\r\n\r\n"
	incr Seqnum
	receive $sock 1
	
    }
    
    proc stop {chID} {
	global sock
	global file
	global server
	global Seqnum
	send $sock 1 "TEARDOWN rtsp://$server/$file RTSP/1.0\r\n"
	send $sock 1 "CSeq: $Seqnum\r\n\r\n"
	incr Seqnum
	receive $sock 1
	
    }	


    
    proc send {chID debugtag str } {
	# if the tag is on open a separate window.. else don't open it.. 
	if $debugtag==1 then {
	    # puts "I am here"
	    puts $chID $str
	    flush $chID
	}
    }
    
    proc receive {chID debugtag} {
	# if the tag is on open a separate window.. else don't open it.. 
	if $debugtag==1 then {
	    # puts "I am here"
	   # set line [read -nonewline $chID]
	   
	    #puts "hello"
	    gets $chID line
	    puts $line
	    #gets $chID ln
	    #puts [string length $ln]
	    #puts "mmmeeeeemmemmeme"
	    while { [string length $line] > 0  } {
		#while { ([fblocked $chID] ==  0)||([string length $line] > 0)  } 
	#	puts $line
	#	puts "hello"
		#puts [fblocked $chID]
		gets $chID line
		#puts [fblocked $chID]
		#gets $chID ln
	    }
	}
    }
    

    proc connectTo {} {
	readInput
    }
    
    frame .mbar -relief raised -bd 2
    wm title . "rtspc - RTSP Client, (c) 2000 Columbia University" 
    frame .dummy -width 10c -height 5c
    pack .mbar .dummy -side top -fill x
    menubutton .mbar.file -text File -underline 0 -menu .mbar.file.menu
    menubutton .mbar.help -text Help -underline 0 -menu .mbar.help.menu
    pack .mbar.file -side left
    pack .mbar.help -side right
    menu .mbar.file.menu 
    .mbar.file.menu add command -label "Connect" -underline 2 -accelerator "Ctrl+n" -command connectTo
    .mbar.file.menu add command -label "Disconnect" -underline 0 -accelerator "Ctrl+d" -command disconnect
    .mbar.file.menu add command -label "Exit" -underline 1 -accelerator "Ctrl+e" -command exiting
    
    bind .mbar <Control-n> { 
	connectTo
    }
    bind .mbar.file.menu <Control-n> { 
	connectTo
    }
    bind .mbar <Control-d> {
	disconnect
    }
    bind .mbar.file.menu <Control-d> {
	disconnect
    }
    bind .mbar <Control-e> {
	exiting
    }
    bind .mbar.file.menu <Control-e> {
	exiting
    }
    
    menu .mbar.help.menu 
    .mbar.help.menu add command -label "Help" -underline 0 -accelerator "Ctrl+h" -command temp 
    
    bind .mbar <Control-h> { 
	temp
    }
    bind .mbar.help.menu <Control-h> { 
	temp
    }
    
    tk_menuBar .mbar .mbar.file .mbar.help 
    focus .mbar
    
    
    
    





