#ifndef SERVER_H
#define SERVER_H
#include "stream.h"
#include <stdio.h>
#include <pwd.h>

extern int   Setup      (request_t *r);
extern int   PlayRecord (int op, Stream *st, request_t *r);
extern int   Pause      (Stream *st, request_t *r);
extern int   Teardown   (Stream *st, request_t *r);
extern int   Describe   (request_t *, int *fd);
extern int   Announce   (request_t *);
extern int   Delete     (request_t *);

extern void *Service       (void *arg);
extern void  PlayService   (Stream *st, request_t *r);
extern void  RecordService (Stream *st, request_t *r);

extern int debug_flag;

extern struct config_t {
  int port;            /* RTSP server port */
  int timeout;         /* RTSP connection timeout, in seconds */
  uid_t uid;           /* user id of process owner */
  gid_t gid;           /* group id of process owner */
  char *ServerName;    /* host name of server */
  char *ServerRoot;    /* location of config files */
  char *DocumentRoot;  /* root of content */
  char *ErrorLog;      /* name of error logging file */
  char *TransferLog;   /* name of transfer logging file */
  char *CNAME;         /* CNAME for server content */
} config;
#endif
