# Convert a CINEMA database from the format of the April 2001 release
# to the current format.

use sip;

alter table put
  modify auth enum('required','request','never', 'register') default 'never',
  modify sip_methods varchar(100) default 'any';

#this may give an error if email was already there. if so, ignore that
#error.
alter table put
  add email text;

alter table contacts
  drop key user,
  modify user text not null,
  modify contact text not null,
  modify expires datetime default '9999-12-31 23:59:59', 
  add primary key (user (250), contact (250));


create table requestlog(
request_time datetime,
method varchar(100),
sip_status int(3) unsigned default 0,
request_url varchar(255),
sip_callid varchar(255),
sip_from varchar(255),
sip_to varchar(255),
period datetime,
id int(11) auto_increment,
charge decimal(9,3),
bye int(11),
primary key(id));

create table tariff(
valid_from datetime,
valid_to datetime,
rate decimal(9,3),
daytime_start time,
daytime_end time,
prefix varchar(100),
increment int(10) unsigned,
id int(11) auto_increment,
gwclass varchar(100),
primary key(id));
