#ifndef TCP_H_
#define TCP_H_

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

struct ssl_socket_info {
  int socket;              /* socket number */
  struct sockaddr_in sin;  /* name of peer */
  SSL *ssl;
  void *server;            /* 
                            * server object (ifany) 
                            * associated with this.
                            */
};

/* tcp_thread_arg: is used for passing argument to the TCP thread */
struct tcp_thread_arg {  
  unsigned short port;
  void *server; /* Server object pointer */
};

extern void *ReceiveSSLTCPRequests(void *arg);
extern void *ReceiveSSLTCP(void *arg);

#endif /* TCP_H_ */
