/*
 * sipd-policy.h - aspects of policies specific to sipd.
 */

/* Copyright 1998-2001 by Columbia University.  All rights reserved. */

#ifndef SIPD_POLICY_H_
#define SIPD_POLICY_H_

#include "policy.h"
#include "script.h"
#include "sip.h"

/* For sipd, the policy info is about registrations. */
struct policy_info_t {
  u_int32 contacts;    /* number of locations */
  time_t update; /* last updated for all contacts */
  sip_contact_t *contact;
  scriptset_t scriptset; /* user's registered content */
};

typedef struct policy_info_t registration_t;

/* Figure out what policy to use */
policy_t *find_primary_policy(policy_info_t *reg, int status);

/* Sipd's policies */
extern policy_t proxy_policy;
extern policy_t redirect_policy;
extern policy_t cgi_policy;
extern policy_t route_policy;
extern policy_t subscribe_policy;
extern policy_t notify_policy;

#endif /* SIPD_POLICY_H_ */
