/* sipd-support.h -- Miscellaneous support functions for sipd. */
/* Copyright 1998-2001 Columbia University.  All rights reserved. */

#ifndef SIPD_SUPPORT_H_
#define SIPD_SUPPORT_H_

#include "uri.h"

#include "dbaccess.h"

#include "request-sip.h"
#include "canonicalize.h"

extern int IsAcceptableURI(request_t *r, const uri_t *uri,
                           const char *uri_desc); 

extern int CanonicalizeAcceptableURI(request_t *r, const uri_t *uri,
                                     canon_result *canon_res,
                                     int remote_ok,
                                     const char *uri_desc,
                                     const char *process_desc);


put_table_entry* CanonicalizeAndLookupURI(request_t *r, const uri_t *uri,
                                          int remote_ok,
                                          const char *uri_desc,
                                          const char *process_desc,
                                          put_table_entry *other_user_val);


#endif /* SIPD_SUPPORT_H_ */
