/* telmap.h: map a telephone number to a SIP url of an appropriate gateway. */
/* Copyright 2001 Columbia University.  All rights reserved. */

#ifndef TELMAP_H_
#define TELMAP_H_

#include "uri.h"

typedef enum {
  /* Normal responses */ 
  TELMAP_UNKNOWN = 0,
  TELMAP_OK = 1,
  TELMAP_NOTFOUND = -404,
  TELMAP_NOPERM = -403,
  TELMAP_ERR = -500
} telmap_err;

extern telmap_err map_tel(uri_t *uri_dest, const uri_t *uri_src,
                          const char *user_gateway_class);

#endif /* TELMAP_H_ */
