#!/usr/bin/env perl -w
# A CGI script with pauses in its output -- first sends a 180, then a 302.
# Note also that there's a pause before the generation of the 302 is complete.
# We must use $| = 1 here to turn off stdio buffering, or this won't work.
# (For C programmers: this is the equivalent of
#   setvbuf(stdout, NULL, _IOLBF, BUFSIZ).)

sub dump_env {
    open(OUT, ">/tmp/script-output.$$") or die("$!");
    foreach $env (sort keys %ENV) {
        print OUT "$env=\"$ENV{$env}\"\n";
    }
    print OUT "\n";
    while (<>) {
        print OUT;
    }
}
dump_env();

$| = 1;
print "SIP/2.0 180 I'm thinking about it\n\n";
sleep 5;
print "SIP/2.0 302 Nope, not here\n";
sleep 5;
print "Contact: somebody\@example.com\n";
