#! /usr/bin/env perl -w
# JDR's example #4:
# respond informational, proxy two requests, CGI-AGAIN. Set a request
# token in each. Get final response on the first. Script CGI-AGAINs,
# sets cookie. Get final response on second, script forwards response
# with response token from first. First response should be
# returned. This verifies forwarding of responses, request and response
# tokens, CGI-AGAIN.

sub dump_env {
    open(OUT, ">/tmp/script-output.$$") or die("$!");
    foreach $env (sort keys %ENV) {
        print OUT "$env=\"$ENV{$env}\"\n";
    }
    print OUT "\n";
    while (<>) {
        print OUT;
    }
}
dump_env();

if (defined($ENV{SCRIPT_COOKIE}) && $ENV{SCRIPT_COOKIE} =~ /^([0-9]+)/) {
    $state = $1;
    if ($ENV{SCRIPT_COOKIE} =~ /;(.+)/) {
        $token = $1;
    }
}
else {
    $state = 0;
}

if ($state == 0) {
    print "SIP/2.0 150 Working on it...\n\n";

    print "CGI-PROXY-REQUEST sip:lennox\@calvin.clic.cs.columbia.edu SIP/2.0\n";
    print "CGI-Request-Token: first\n\n";

    print "CGI-PROXY-REQUEST sip:lennox\@mork.clic.cs.columbia.edu SIP/2.0\n";
    print "CGI-Request-Token: second\n\n";
    
    print "CGI-AGAIN yes SIP/2.0\n\n";

    $state = 1;
}
elsif ($state == 1) {
    if (defined($ENV{RESPONSE_STATUS}) && $ENV{REQUEST_TOKEN} =~ /first/) {
        $token = $ENV{RESPONSE_TOKEN};
    }
    print "CGI-AGAIN yes SIP/2.0\n\n";

    $state = 2;
}
elsif ($state == 2) {
    if (defined($ENV{RESPONSE_STATUS}) && $ENV{REQUEST_TOKEN} =~ /first/) {
        $token = $ENV{RESPONSE_TOKEN};
    }
    if (!defined($token)) {
        print "SIP/2.0 500 Something (1) went wrong in the test...\n\n";
        exit(0);
    }
    print "CGI-FORWARD-RESPONSE $token SIP/2.0\n\n";

    print "CGI-AGAIN yes SIP/2.0\n\n";

    $state = 3;
}
else {
    print "SIP/2.0 500 Something (2) went wrong in the test...\n\n";
    exit(0);
}

$cookie = "$state";
if (defined($token)) { $cookie .= ";$token" }

print "CGI-SET-COOKIE $cookie SIP/2.0\n\n";

exit(0);
