# Makefile module for sipd test directory
# Copyright 1998-1999 by Columbia University; all rights reserved 

sipd_test_dir := $(sipd_dir)/test

sipd_test_srcdir := $(topsrcdir)/$(sipd_test_dir)

SIPD_TEST_BIN := $(sipd_test_dir)/siptc $(sipd_test_dir)/sipts-old

SIPD_TEST_SRC := \
  $(sipd_test_dir)/siptc.c \
  $(sipd_test_dir)/sipts-old.c 


SIPD_TEST_LIBS := $(LIBCINE_LIB) $(SOCKLIBS) -lssl -lcrypto

SIPD_TEST_MISC := \
  $(sipd_test_dir)/module.mk \
  $(sipd_test_dir)/siptc.dsp

SIPD_TEST_MISCDIST := \
  $(sipd_test_dir)/sipts

SIPD_TEST_MISCDIST += $(patsubst $(topsrcdir)/%,$(topdir)/%,$(wildcard \
  $(sipd_test_srcdir)/*invite*[^~] \
  $(sipd_test_srcdir)/*request*[^~] \
  $(sipd_test_srcdir)/*register*[^~] \
  $(sipd_test_srcdir)/*ack*[^~] \
  $(sipd_test_srcdir)/*broken*[^~] \
  $(sipd_test_srcdir)/*runon*[^~] \
  $(sipd_test_srcdir)/cgi/*register*[^~] \
  $(sipd_test_srcdir)/cgi/*.pl \
  $(sipd_test_srcdir)/torture/*/*.txt \
 ))

SIPD_TEST_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(SIPD_TEST_SRC)))

SIPD_TEST_DEP := \
	$(SIPD_TEST_OBJ:.o=.d)

# Include files required locally.
SIPD_TEST_INCS := $(LIBCINE_INC)

$(SIPD_TEST_OBJ): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(SIPD_TEST_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(SIPD_TEST_DEP): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(sipd_test_dir) -o $@ $(SIPD_TEST_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<


$(sipd_test_dir)/siptc: $(sipd_test_dir)/siptc.o $(LIBCINE)
	@echo "linking $@..."
	$(CC) -o $@ $^ $(LDFLAGS) $(SIPD_TEST_LIBS)

$(sipd_test_dir)/sipts-old: $(sipd_test_dir)/sipts-old.o $(LIBCINE)
	@echo "linking $@..."
	$(CC) -o $@ $^ $(LDFLAGS) $(SIPD_TEST_LIBS)


BIN       += $(SIPD_TEST_BIN)
SRC       += $(SIPD_TEST_SRC)
MISCCLEAN += $(SIPD_TEST_MISCCLEAN)

SIPD_TEST_DIST := $(SIPD_TEST_SRC) $(SIPD_TEST_MISC) $(SIPD_TEST_MISCDIST)
SIPD_TEST_BINDIST := $(SIPD_TEST_BIN) $(SIPD_TEST_MISCDIST)
