
//package SipSImp;

import java.util.List;
import org.ietf.sip.*;

/**
 * Contact Database is currently not implemented due to udergoing
 * changes. Methods will throw exceptions.
 */

/**
 * Access to the servlet engines contact database.
 *
 * <p>These operations are highly sensitive from a security point of view.
 * Not only should information about the whereabouts of individuals be
 * protected but changing a callees contact information can make someone
 * unreachable or worse. Hence all of these operations MUST be protected,
 * although the details of what access control mechanism is employed is
 * outside the scope of the SIP Servlet API.
 *
 * <p>Security is based on the JDK1.2 Java security framework.
 */
public class ContactDatabaseImpl implements ContactDatabase {

   /**
    * Returns the set of Contact objects currently associated with the
    * specified address by the server.
    *
    * <p>This operation may be subject to
    * security checks, for example to prevent a servlet from obtaining
    * contact information for users other than the callee on whose behalf
    * it currently executes. The details of what access control mechanism
    * is employed is outside the scope of the SIP Servlet API.
    *
    * @param sipAddr   identifies the SIP endpoint whose contact
    *      information is being requested. The server may lookup contact
    *      addresses based on the SipURL or display-name or other
    *      attributes of the argument.
    * @return  the set of current Contacts associated with the specified
    *      user, or null if the server doesn't maintain contact information
    */
   public List getContacts(SipAddress sipAddr) {
      throw new UnsupportedOperationException("ContactDatabase: method not implemented");
   }

   /**
    * Sets the set of Contact objects currently associated with the
    * specified address by the server.
    * @param sipAddr   identifies the SIP endpoint whose contact
    *                  information is being modified.
    */
   public void setContacts(SipAddress sipAddr, List contacts) {
      throw new UnsupportedOperationException("ContactDatabase: method not implemented");
   }

   /**
    * Adds the specified Contact address to the set of Contact
    * objects currently associated with the specified address.
    * @param sipAddr   identifies the SIP endpoint whose contact
    *                  information is being modified.
    * @param contact   the Contact address to be added
    */
   public void addContact(SipAddress sipAddr, Contact contact) {
      throw new UnsupportedOperationException("ContactDatabase: method not implemented");
   }

   /**
    * Removes the specified Contact address from the set of Contact
    * objects currently associated with the specified address.
    * @param sipAddr   identifies the SIP endpoint whose contact
    *                  information is being modified.
    * @param contact   the Contact address to be removed
    */
   public void removeContact(SipAddress sipAddr, Contact contact) {
      throw new UnsupportedOperationException("ContactDatabase: method not implemented");
   }
}
