
// package SipSImp;

/**
 *
 * This class represents a header unit which is used in
 * implementation of class SipMessageImpl and its subclasses.
 * It represents a header and its value; its characteristic is
 * that its test for equality based on header name alone (not its
 * value).
 */

class SipHeaderUnit{
   public String header;
   public String value;

   public SipHeaderUnit(String h, String v) {
      header = h;
      value = v;
   }

   public SipHeaderUnit(SipHeaderUnit sh) {
      header = (sh.header!=null ? new String(sh.header) : null);
      value = (sh.value!=null ? new String(sh.value) : null);
   }

   // assumes that the string represents header unit in this format
   // <header_name>: <header value>
   public SipHeaderUnit(String u) {
      if(u!=null) {
         u.trim();
         int i = u.indexOf(":");
         if(i > 0 && u.length() > i+2) {
            header = u.substring(0,i);
            value = (u.substring(i+1,u.length())).trim();
         }
      }
   }

   public boolean equals(Object ho) {
      if(ho instanceof SipHeaderUnit) {
         SipHeaderUnit sh = (SipHeaderUnit) ho;
         String h = (sh.header==null ? "" : sh.header);
         if(h.equals(header))
            return true;
         else
            return false;
      }
      else if(ho instanceof String) {
         String h = (ho==null ? "" : (String) ho);
         if(h.equals(header))
            return true;
         else
            return false;
      }
      else
         return false;
   }

   public boolean equals(SipHeaderUnit sh) {
      String h = (sh.header==null ? "" : sh.header);
      if(h.equals(header))
         return true;
      else
         return false;
   }

   // test full equality of 2 SipHeaderUnit objects:
   // header type and value
   public boolean equalsValue(Object ho) {
      if(ho instanceof SipHeaderUnit) {
         SipHeaderUnit sh = (SipHeaderUnit) ho;
         String h = (sh.header==null ? "" : sh.header);
         if(h.equals(header)) {
            String v = (sh.value==null ? "" : sh.value);
            if(v.equals(value))
               return true;
            else
               return false;
         }
         else
            return false;
      }
      else
         return false;
   }

   public String toString() {
      if(header!=null && value!=null)
         return header + ": " + value;
      else
         return null;
   }
}