
#ifndef JNI_SIPS_UTIL_H
#define JNI_SIPS_UTIL_H

#include <jni.h>

#define JFIELDSTR "Ljava/lang/String;"
#define JFIELDOBJ "Ljava/lang/Object;"

// object allocation in JVM
int allocateJObject(JNIEnv *env, jobject *obj, char *class);
jobject allocateEmptyJObject(JNIEnv *env, char *class);
jobject allocateNewJObject(JNIEnv *env, char *class);

// C -> Java
int setJObjectStringField(JNIEnv *env, jobject *obj, jclass cls, char *field, char *value);
int setJObjectIntField(JNIEnv *env, jobject *obj, jclass cls, char *field, int value);
int setJObjectDoubleField(JNIEnv *env, jobject *obj, jclass cls, char *field, double value);
int setJObjectLongField(JNIEnv *env, jobject *obj, jclass cls, char *field, long value);
int setJObjectObjectField(JNIEnv *env, jobject *obj, jclass cls, char *field, char *descr, jobject value);
int addJHashMapObjectPair(JNIEnv *env, jobject *obj, jclass cls, char *key, char *value);
int addJListObjectObject(JNIEnv *env, jobject *obj, jclass cls, jobject jval);

// Java -> C
char *getUTFString(JNIEnv *env, jstring jstr);
char *getJObjectStringField(JNIEnv *env, jobject obj, jclass cls, char *field);
int getJObjectIntField(JNIEnv *env, jobject obj, jclass cls, char *field);
long getJObjectLongField(JNIEnv *env, jobject obj, jclass cls, char *field);
double getJObjectDoubleField(JNIEnv *env, jobject obj, jclass cls, char *field);
jobject getJObjectObjectField(JNIEnv *env, jobject parentObj, jclass cls, char *field, char *descr);

// List interface access
int getListSize(JNIEnv *env, jobject obj, jclass class);
jobject getListElement(JNIEnv *env, jobject obj, jclass class, int index);

jobject getMapKeyList(JNIEnv *env, jobject obj, jclass cls);
jobject getMapValue(JNIEnv *env, jobject obj, jclass cls, jobject pObj);


#endif
