
/**************************************************************
* Program:  <name>.c
* Header:   <hfile>.c
*
* Matthias Rusinski
* msr52@columbia.edu
*
*/

#include <stdio.h>
#include <stdlib.h>
#include <jni.h>

#include "SipRequestWrapper.h"

#include "policy.h"
#include "message.h"
#include "request-sip.h"
#include "sysdep.h"
#include "dstring.h"
#include "config.h"

#include "JNI_util.h"

struct config_t config;
/* The name of this server */
const char *server_name = "Columbia-Sip-Server";


JNIEXPORT jint JNICALL
Java_SipRequestWrapper_processSend(JNIEnv *env, jobject obj, jobject req, jobject msg, jobject uri)
{
   jint ret = 1;
   request_t *r;
   message_t *m;
   int i;

   /* temp structures */
   struct sockaddr_in sin;

   /* settings for sipd compatibility */
   config.defaultreg = L_redirect;

   if(req==NULL || msg==NULL)
      return -2;

   /* create empty request */
   if((r = RequestCreate(0,0,sin))==NULL)
      return -1;

   if(build_request_t(env, req, r)<0)
      return (jint) -1;

   /* build message type */
   if((m = MessageCreateTrivial(0,0))==NULL)
      return -1;
   if(build_message_t(env, msg, m)<0)
      return (jint) -1;

   printf("   --> sips: Request: native code: processSend: request_t, message_t built\n");
   /* send request using ResponseSendSocket */

   /* new socket must be created since original socket from request_t is not longer available in JVM */
   /* comonents of message to be sent are in request_t (message_t is not needed here, but is also
    * created and assigned values if a need arises in the future

    * r->headers has headers for outgoinh message
    * r->p (parser_t) has URI_string (for Request) and status, reason (for Response)
    * r->reponse_body has body Request (empty for Response)
    * r->sin should be the socket structure of the destination
    */
   /* message can be built into DString and sent using ResponseSendSocket */

   return ret;
}
