

/**
 * file with copied functions from sipd.c
 * which is used to build sips message libraries
 * (so that sipd.c does not have to be included)
 */

#include "dstring.h"
#include "config.h"
#include "md5.h"
//#include "sipd.h"
#include "udp.h"
#include "tcp.h"
#include "log.h"
#include "error.h"
#include "strdupn.h"   /* free_valid() */
#include "libsip.h"
#include "sysdep.h"

#ifndef VERSION
#define VERSION "1.0"
#endif

//static struct config_t config;

/* The name of this server */
//const char *server_name = "Columbia-Sip-Server";


/*
 * SIP_HandleRequestLocally()
 * Tell libsip whether an incoming request is handled locally or
 * remotely (i.e. whether to use WWW-Authenticate and Require, or
 * Proxy-Authenticate and Proxy-Require, respectively).
 * For sipd, REGISTER requests whose host part matches the local host
 * pattern are local; everything else is remote.
 * XXX: OPTIONS requests sent to the registrar address?
 */
int SIP_HandleRequestLocally(char *method, uri_t uri)
{
  if (strcasecmp(method, "REGISTER") != 0) {
    return 0;
  }
  if (regexec(config.domain, uri.host, 0, NULL, 0) != 0) {
    return 0;
  }

  return 1;
}


/*
 * Dummy implementation of OnIncomingRequest()
 * so that libsip works.  Always use the default libsip
 * behavior.
 */
int OnIncomingRequest(request_t *r)
{
  return -1;
}

/*
 * Dummy implementation of UnmapRequestFromCall()
 * so that libsip works without C++ part.
 */
void UnmapRequestFromCall(void *c, void *r)
{
  /* Do nothing */
}

