package org.ietf.sip;

import java.util.Iterator;

/**
 * The ServletConfig class represents servlet configuration information.
 * The mechanism for specifying configuration parameters and associating
 * them with servlet instances is outside the scope of the SIP Servlet API
 * itself, but this information is made available to servlets using this
 * class.
 */
public interface ServletConfig {
    /**
     * Returns the value of the named parameter, or null if is undefined.
     */
    public String getInitParameter(String name);
    
    /**
     * Returns an iterator over all parameters defined for the servlet for
     * which this ServletConfig applies. The iterator returns Strings.
     */
    public Iterator getInitParameterNames();
    
    /**
     * Returns the ServletContext associated with the servlet corresponding
     * to this ServletConfig.
     */
    public SipServletContext getServletContext();
}
