

/*
 * simple test servlet
 */

import java.io.*;
import java.text.*;
import java.util.*;
import org.ietf.sip.*;



/**
 * Example servlet
 */

public class myservlet implements SipServlet {

   String st;
   int i, reqCnt, resCnt;
   ServletConfig config;

   public void init(ServletConfig sipConfig){
      st = new String("  <<watson's servlet>>");
      i = 0;
      config = sipConfig;
      System.out.println(st+": init()...");
      reqCnt=0;
      resCnt=0;
   }


   public boolean gotRequest(SipRequest req) throws ServletException {
      reqCnt++;

      System.out.println(st + ": gotRequest(), number:"+reqCnt);
      SipServletContext context = config.getServletContext();
      if(reqCnt==1) {
         SipURL url = null;
         SipAddress ad = null;
         try {
            url = context.createSipURL("Tom", "cs.columbia.edu", 5066);
            System.out.println(st + "created url: " + url.toString());
            ad =  context.createSipAddress(url, "\"Mr. Tom\"");
            System.out.println(st + "created address: " + ad.getDisplayName() + " "+url.toString());
         }catch(Exception ex) {
            System.out.println(st + ": exception creating url");
         }

         String protocol = req.getProtocol();
         System.out.println(st + ": adding headers...");
         req.addHeader("Via", protocol+"/UDP msnbc.com:5060");

         if(url!=null) {
            req.setHeader("To", url.toString());
            System.out.println(st + ": sending");
            req.send(url);
         }
      }
      else {
         System.out.println(st + ": creating response...");
         SipResponse resp = req.createResponse();
         System.out.println(st + ": setting status & reason");
         resp.setStatus(200, "OK");
         resp.send();
      }

      return true;
   }



   public boolean gotResponse(SipResponse res) throws ServletException {
      resCnt++;
      System.out.println(st + ": gotResponse(), number:"+resCnt);

      res.setStatus(100, "Trying");
      String localHost = new String("columbia.edu");
      System.out.println(st + ": adding headers...");
      res.addHeader("Via", "SIP/2.0/UDP "+localHost);
      System.out.println(st + ": sending response...");
      res.send();
      return true;
   }


   public void destroy() {
      System.out.println(st + ": destroy()... ");
   }


   public ServletConfig getServletConfig() {
      return config;
   }

   public String getServletInfo() {
      return st;
   }
}
