#ifndef WIN32 /* For unix */
#include "unistd.h"
#include <sys/types.h>
#include <sys/socket.h>
#include "netinet/in.h"
#include "arpa/inet.h"
#else
#include "winsock2.h"
#endif

/*
 * AudioTool 
 */
class AudioTool
{
public :
  ///use internal PCMU based audio tool.
  AudioTool();
  ///used the specified audio tool (e.g., vat, rat).
  AudioTool(const char *path);
  ///destroy the audio tool.
  ~AudioTool();

  /**Start the audio tool. This may open the 
     audio device or invoke the external tool. */
  void StartTool(bool usedevice = true);

  /**Start the audio tool. This may close the audio device
     or kill the external tool. */
  void StopTool();

  ///set the receive RTP port. RTCP is RTP + 1.
  void SetSelfPort(unsigned short port);
  ///retrieve self RTP port.
  unsigned short GetSelfPort();
  ///set the destination address to send audio to.
  void SetRemoteAddress(const struct sockaddr_in sin);
  ///retrieve the destination address.
  void GetRemoteAddress(struct sockaddr_in & sin);

private:
  unsigned short selfport;
  struct sockaddr_in remoteaddr;
  char *tool;
  bool active;
  int externaltool;
};

