# Makefile module for sipum tools directory
# Copyright 2000 by Columbia University; all rights reserved 

sipum_tools_dir := $(sipum_dir)/tools

sipum_tools_srcdir := $(topsrcdir)/$(sipum_tools_dir)

SIPUM_TOOLS_BIN := \
  $(sipum_tools_dir)/sipum-conf \
  $(sipum_tools_dir)/mkpasswd \
  $(sipum_tools_dir)/ckpasswd

SIPUM_TOOLS_SRC := \
  $(sipum_tools_dir)/confuser.c \
  $(sipum_tools_dir)/mkpasswd.c \
  $(sipum_tools_dir)/ckpasswd.c

SIPUM_TOOLS_MISC := \
  $(sipum_tools_dir)/module.mk \
  $(sipum_tools_dir)/confuser.dsp

SIPUM_TOOLS_MISCDIST := \
  $(sipum_tools_dir)/README \
  $(sipum_tools_dir)/libgdbm-Linux.a \
  $(sipum_tools_dir)/libgdbm-SunOS.a

# Set the platform.
Platform   := $(shell uname -s)

$(sipum_tools_dir)/sipum-conf: $(sipum_tools_dir)/confuser.o
	@echo "linking $@..."
	$(CC) -o $@ $^ $(LDFLAGS) $(sipum_tools_srcdir)/libgdbm-$(Platform).a

$(sipum_tools_dir)/mkpasswd: $(sipum_tools_dir)/mkpasswd.o
	@echo "linking $@..."
	$(CC) -o $@ $^ -lcrypt

$(sipum_tools_dir)/ckpasswd: $(sipum_tools_dir)/ckpasswd.o
	@echo "linking $@..."
	$(CC) -o $@ $^ -lcrypt

SRC += $(SIPUM_TOOLS_SRC)

SIPUM_TOOLS_DIST := $(SIPUM_TOOLS_SRC) $(SIPUM_TOOLS_MISC) $(SIPUM_TOOLS_MISCDIST)
SIPUM_TOOLS_BINDIST := $(SIPUM_TOOLS_BIN) $(SIPUM_TOOLS_MISCDIST)
