# Makefile fragment for tracker
# Copyright 1998-1999 by Columbia University; all rights reserved 

addsipuser_dir := $(tools_dir)/addsipuser


DIRS += $(addsipuser_dir)


ADDSIPUSER_BIN := \
	$(addsipuser_dir)/addsipuser

ADDSIPUSER_SRC := \
	$(addsipuser_dir)/addsipuser.c

ADDSIPUSER_LIBS := $(MYSQLLIBS) $(ZLIBLIBS) $(LIBCINE_LIB) $(SOCKLIBS) $(MATHLIBS)

ADDSIPUSER_MISC := \
	$(addsipuser_dir)/module.mk \
        $(addsipuser_dir)/addsipuser.dsp

ADDSIPUSER_MISCDIST := \
	$(addsipuser_dir)/addsipuser.html

ADDSIPUSER_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(ADDSIPUSER_SRC)))

ADDSIPUSER_DEP := \
	$(ADDSIPUSER_OBJ:.o=.d)

# Include files required locally.
ADDSIPUSER_INCS := $(LIBCINE_INC)

$(ADDSIPUSER_OBJ): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(ADDSIPUSER_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(ADDSIPUSER_DEP): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(addsipuser_dir) -o $@ $(ADDSIPUSER_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<

tools: $(addsipuser_dir)/addsipuser

$(addsipuser_dir)/addsipuser: $(ADDSIPUSER_OBJ) $(LIBCINE)
	@echo "linking $@..."
	$(CC) -o $@ $^ $(LDFLAGS) $(ADDSIPUSER_LIBS) $(LIBS)

ADDSIPUSER_BIN_WIN32 := $(addsipuser_dir)/Debug/addsipuser.exe \
                        $(addsipuser_dir)/Release/addsipuser.exe

SRC       += $(ADDSIPUSER_SRC)
BIN       += $(ADDSIPUSER_BIN)

TOOLS_DIST    += $(ADDSIPUSER_SRC) $(ADDSIPUSER_MISC) $(ADDSIPUSER_MISCDIST)
TOOLS_BINDIST += $(ADDSIPUSER_BIN) $(ADDSIPUSER_MISCDIST)
TOOLS_BINDIST_WIN32 += $(ADDSIPUSER_BIN_WIN32) $(ADDSIPUSER_MISCDIST)
