# Makefile fragment for base64
# Copyright 1998-2000 by Columbia University; all rights reserved 

base64_dir := $(tools_dir)/base64

DIRS += $(base64_dir)


BASE64_BIN := \
	$(base64_dir)/base64-encode \
	$(base64_dir)/base64-decode

BASE64_SRC := \
	$(base64_dir)/base64-encode.c \
	$(base64_dir)/base64-decode.c

BASE64_LIBS :=


BASE64_HEADERS :=


BASE64_MISC := \
	$(base64_dir)/module.mk \
        $(base64_dir)/base64encode.dsp \
        $(base64_dir)/base64decode.dsp

BASE64_MISCDIST :=


BASE64_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(BASE64_SRC)))

BASE64_DEP := \
	$(BASE64_OBJ:.o=.d)

# Include files required locally.
BASE64_INCS := $(LIBCINE_INC)

$(BASE64_OBJ): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(BASE64_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(BASE64_DEP): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(base64_dir) -o $@ $(BASE64_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<


tools: $(base64_dir)/base64-encode $(base64_dir)/base64-decode 

$(base64_dir)/base64-encode: $(base64_dir)/base64-encode.o \
			$(libcine_dir)/base64.o
	@echo "linking $@..."
	$(CC) -o $@ $^ $(BASE64_LIBS)

$(base64_dir)/base64-decode: $(base64_dir)/base64-decode.o \
			$(libcine_dir)/base64.o
	@echo "linking $@..."
	$(CC) -o $@ $^ $(BASE64_LIBS)


BIN += $(BASE64_BIN)
SRC += $(BASE64_SRC)
HEADERS += $(BASE64_HEADERS)

TOOLS_DIST    += $(BASE64_SRC) $(BASE64_HEADERS) $(BASE64_MISC) \
	$(BASE64_MISCDIST)
TOOLS_BINDIST += $(BASE64_BIN) $(BASE64_MISCDIST)
