# Makefile fragment for tracker
# Copyright 1998-1999 by Columbia University; all rights reserved 
# XXX this fragment assumes that $(CC) is gcc.
# Don't try to build libfbsql.so if we didn't enable tcl.

ifeq ($(USE_TCL), yes)

fbsql_dir := $(tools_dir)/fbsql


DIRS += $(fbsql_dir)


FBSQL_SHLIB := \
	$(fbsql_dir)/libfbsql.so

FBSQL_BIN := $(FBSQL_SHLIB)

FBSQL_SRC := \
	$(fbsql_dir)/fbsql.c

FBSQL_LIBS := $(MYSQL_STATIC_LIB) $(ZLIBLIBS) $(MATHLIBS) $(TCLLIBS)

FBSQL_MISC := \
	$(fbsql_dir)/module.mk \
        $(fbsql_dir)/fbsql.dsp

FBSQL_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(FBSQL_SRC)))

FBSQL_DEP := \
	$(FBSQL_OBJ:.o=.d)

# Include files required locally.
FBSQL_INCS := $(MYSQL_INC) $(TCL_INC)

$(FBSQL_OBJ): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(FBSQL_INCS) -fPIC $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(FBSQL_DEP): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(fbsql_dir) -o $@ $(FBSQL_INCS) -fPIC $(CFLAGS) $(CPPFLAGS) $(DEFS) $<

tools: $(FBSQL_SHLIB)

$(FBSQL_SHLIB): $(FBSQL_OBJ)
	@echo "creating library $@..."
	$(CC) -shared -fPIC -o $@ $^ $(LDFLAGS) $(FBSQL_LIBS) $(LIBS)


SRC       += $(FBSQL_SRC)
BIN       += $(FBSQL_BIN)

FBSQL_BIN_WIN32 := \
  $(fbsql_dir)/Debug/fbsql.dll \
  $(fbsql_dir)/Release/fbsql.dll

TOOLS_DIST    += $(FBSQL_SRC) $(FBSQL_MISC) 
# Because mysql is LGPL'd, distribute source for this module.
TOOLS_BINDIST += $(FBSQL_SRC) $(FBSQL_BIN) 
TOOLS_BINDIST_WIN32 += $(FBSQL_SRC) $(FBSQL_BIN_WIN32)

endif # eq($USE_TCL, yes)
