# Makefile fragment for ishere
# Copyright 1998-1999 by Columbia University; all rights reserved 

ishere_dir := $(tools_dir)/ishere

DIRS += $(ishere_dir)


ISHERE_BIN := \
	$(ishere_dir)/ishere

ISHERE_SRC := \
	$(ishere_dir)/ishere.c

ISHERE_LIBS := $(LIBCINE_LIB)


ISHERE_HEADERS := \
	$(ishere_dir)/copyright.h

ISHERE_MISC := \
	$(ishere_dir)/module.mk \
	$(ishere_dir)/Makefile.old

ISHERE_MISCDIST := \
	$(ishere_dir)/ishere.html


ISHERE_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(ISHERE_SRC)))
ISHERE_DEP := \
	$(ISHERE_OBJ:.o=.d)

# Include files required locally.
ISHERE_INCS := $(LIBCINE_INC)

$(ISHERE_OBJ): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(ISHERE_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(ISHERE_DEP): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(ishere_dir) -o $@ $(ISHERE_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<




tools: $(ishere_dir)/ishere

$(ishere_dir)/ishere: $(ISHERE_OBJ) $(LIBCINE)
	@echo "linking $@..."
	$(CC) -o $@ $(ISHERE_OBJ) $(ISHERE_LIBS)


BIN += $(ISHERE_BIN)
SRC += $(ISHERE_SRC)
HEADERS += $(ISHERE_HEADERS)

TOOLS_DIST    += $(ISHERE_SRC) $(ISHERE_HEADERS) $(ISHERE_MISC) \
	$(ISHERE_MISCDIST)
TOOLS_BINDIST += $(ISHERE_BIN) $(ISHERE_MISCDIST)
