#! /bin/sh
# The next line is executed by /bin/sh, but not Tcl \
exec tclsh $0 ${1+"$@"}

#
# Tcl client for getting all hosts where user might be
#

#
# Return list of hosts where user might be logged on.
#
proc lswhod {dir user} {
  set prior [pwd]

  if {[catch {cd $dir/$user}]} {
    return ""
  }

  set hosts [glob *]
  set where {}
  foreach h $hosts {
    if {[file size $h] == 0} {
      lappend where $h
    } else {
      set f [open $h r]
      while {[gets $f line] >= 0} {
        if {[lsearch $where $line] < 0} {
          lappend where $line
        }
      }
    }
  }

  cd $prior
  return $where
}
