# Makefile fragment for lswhod
# Copyright 1998-1999 by Columbia University; all rights reserved 

lswhod_dir := $(tools_dir)/lswhod

DIRS += $(lswhod_dir)


LSWHOD_BIN := \
	$(lswhod_dir)/lswhod

LSWHOD_SRC := \
	$(lswhod_dir)/lswhod.c

LSWHOD_LIBS := $(LIBCINE_LIB)


LSWHOD_HEADERS := \
	$(lswhod_dir)/copyright.h

LSWHOD_MISC := \
	$(lswhod_dir)/module.mk \
	$(lswhod_dir)/Makefile.old

LSWHOD_MISCDIST := \
	$(lswhod_dir)/lswhod.html \
	$(lswhod_dir)/lswhod.tcl


LSWHOD_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(LSWHOD_SRC)))
LSWHOD_DEP := \
	$(LSWHOD_OBJ:.o=.d)

# Include files required locally.
LSWHOD_INCS := $(LIBCINE_INC)

$(LSWHOD_OBJ): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(LSWHOD_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(LSWHOD_DEP): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(lswhod_dir) -o $@ $(LSWHOD_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<




old-tools: $(lswhod_dir)/lswhod

$(lswhod_dir)/lswhod: $(LSWHOD_OBJ) $(LIBCINE)
	@echo "linking $@..."
	$(CC) -o $@ $(LSWHOD_OBJ) $(LSWHOD_LIBS)


BIN += $(LSWHOD_BIN)
SRC += $(LSWHOD_SRC)
HEADERS += $(LSWHOD_HEADERS)

#TOOLS_DIST    += $(LSWHOD_SRC) $(LSWHOD_HEADERS) $(LSWHOD_MISC) \
#	$(LSWHOD_MISCDIST)
#TOOLS_BINDIST += $(LSWHOD_BIN) $(LSWHOD_MISCDIST)

