/* md5string -- command-line wrapper around MD5().  Convert
 * a command-line argument to a hashed string.
 * Equivalent to md5sum --string.
 */

/* Copyright 2001 Columbia University.  All rights reserved. */

#include <stdio.h>
#include <stdlib.h>

#include "md5.h"

int main(int argc, char *argv[])
{
  char *thehash;

  if (argc < 2) {
    fprintf(stderr, "Usage: %s string\n", argv[0]);
    exit(2);
  }

  thehash = MD5L(argv[1]);

  printf("%s\n", thehash);

  free(thehash);

  exit(0);
}
