# Makefile fragment for md5string
# Copyright 2000 by Columbia University; all rights reserved 

md5string_dir := $(tools_dir)/md5string


DIRS += $(md5string_dir)


MD5STRING_BIN := \
	$(md5string_dir)/md5string

MD5STRING_SRC := \
	$(md5string_dir)/md5string.c

MD5STRING_LIBS := $(LIBCINE_LIB)

MD5STRING_MISC := \
	$(md5string_dir)/module.mk \
        $(md5string_dir)/md5string.dsp

MD5STRING_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(MD5STRING_SRC)))

MD5STRING_DEP := \
	$(MD5STRING_OBJ:.o=.d)

# Include files required locally.
MD5STRING_INCS := $(LIBCINE_INC)

$(MD5STRING_OBJ): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(MD5STRING_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(MD5STRING_DEP): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(md5string_dir) -o $@ $(MD5STRING_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<

tools: $(md5string_dir)/md5string

$(md5string_dir)/md5string: $(MD5STRING_OBJ) $(LIBCINE)
	@echo "linking $@..."
	$(CC) -o $@ $^ $(LDFLAGS) $(MD5STRING_LIBS) $(LIBS)

MD5STRING_BIN_WIN32 := \
  $(md5string_dir)/Debug/md5string.exe \
  $(md5string_dir)/Release/md5string.exe

SRC       += $(MD5STRING_SRC)
BIN       += $(MD5STRING_BIN)

TOOLS_DIST    += $(MD5STRING_SRC) $(MD5STRING_MISC) 
TOOLS_BINDIST += $(MD5STRING_BIN) 
TOOLS_BINDIST_WIN32 += $(MD5STRING_BIN_WIN32)