# Makefile fragment for random32
# Copyright 2000 by Columbia University; all rights reserved 

random32_dir := $(tools_dir)/random32


DIRS += $(random32_dir)


RANDOM32_BIN := \
	$(random32_dir)/random32

RANDOM32_SRC := \
	$(random32_dir)/random32.c

RANDOM32_LIBS := $(LIBCINE_LIB)

RANDOM32_MISC := \
	$(random32_dir)/module.mk \
        $(random32_dir)/random32.dsp

RANDOM32_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(RANDOM32_SRC)))

RANDOM32_DEP := \
	$(RANDOM32_OBJ:.o=.d)

# Include files required locally.
RANDOM32_INCS := $(LIBCINE_INC)

$(RANDOM32_OBJ): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(RANDOM32_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(RANDOM32_DEP): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(random32_dir) -o $@ $(RANDOM32_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<

tools: $(random32_dir)/random32

$(random32_dir)/random32: $(RANDOM32_OBJ) $(LIBCINE)
	@echo "linking $@..."
	$(CC) -o $@ $^ $(LDFLAGS) $(RANDOM32_LIBS) $(LIBS)

SRC       += $(RANDOM32_SRC)
BIN       += $(RANDOM32_BIN)

RANDOM32_BIN_WIN32 := \
  $(random32_dir)/Debug/random32.exe \
  $(random32_dir)/Release/random32.exe

TOOLS_DIST    += $(RANDOM32_SRC) $(RANDOM32_MISC) 
TOOLS_BINDIST += $(RANDOM32_BIN) 
TOOLS_BINDIST_WIN32 += $(RANDOM32_BIN_WIN32)