# Makefile fragment for sippasswd
# Copyright 2000 by Columbia University; all rights reserved 

sippasswd_dir := $(tools_dir)/sippasswd


DIRS += $(sippasswd_dir)


SIPPASSWD_BIN := \
	$(sippasswd_dir)/sippasswd

SIPPASSWD_SRC := \
	$(sippasswd_dir)/sippasswd.c

SIPPASSWD_LIBS := $(LIBCINE_LIB)

SIPPASSWD_MISC := \
	$(sippasswd_dir)/module.mk

SIPPASSWD_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(SIPPASSWD_SRC)))

SIPPASSWD_DEP := \
	$(SIPPASSWD_OBJ:.o=.d)

# Include files required locally.
SIPPASSWD_INCS := $(LIBCINE_INC)

$(SIPPASSWD_OBJ): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(SIPPASSWD_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(SIPPASSWD_DEP): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(sippasswd_dir) -o $@ $(SIPPASSWD_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<

tools: $(sippasswd_dir)/sippasswd

$(sippasswd_dir)/sippasswd: $(SIPPASSWD_OBJ) $(LIBCINE)
	@echo "linking $@..."
	$(CC) -o $@ $^ $(LDFLAGS) $(SIPPASSWD_LIBS) $(LIBS)

SRC       += $(SIPPASSWD_SRC)
BIN       += $(SIPPASSWD_BIN)

TOOLS_DIST    += $(SIPPASSWD_SRC) $(SIPPASSWD_MISC) 
TOOLS_BINDIST += $(SIPPASSWD_BIN) 
