# Makefile fragment for tracker
# Copyright 1998-1999 by Columbia University; all rights reserved 

tracker_dir := $(tools_dir)/tracker

TRACKER_BIN := \
	$(tracker_dir)/tracker

TRACKER_SRC := \
	$(tracker_dir)/tracker.c \
	$(tracker_dir)/finger.c \
	$(tracker_dir)/hostfix.c

TRACKER_LIBS := $(LIBCINE_LIB) $(SOCKLIBS)


TRACKER_HEADERS := \
	$(tracker_dir)/copyright.h

TRACKER_MISC := \
	$(tracker_dir)/module.mk \
	$(tracker_dir)/Makefile.old \
	$(tracker_dir)/hosts

TRACKER_MISCDIST := \
	$(tracker_dir)/tracker.html

TRACKER_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(TRACKER_SRC)))

TRACKER_DEP := \
	$(TRACKER_OBJ:.o=.d)

# Include files required locally.
TRACKER_INCS := $(LIBCINE_INC)

$(TRACKER_OBJ): %.o: %.c
	@echo "compiling $<..."
	$(CC) $(TRACKER_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

$(TRACKER_DEP): %.d: %.c
	@echo "dependencies for $<..."
	$(DEPEND) -d $(tracker_dir) -o $@ $(TRACKER_INCS) $(CFLAGS) $(CPPFLAGS) $(DEFS) $<



tools: $(tracker_dir)/tracker

$(tracker_dir)/tracker: $(TRACKER_OBJ) $(LIBCINE)
	@echo "linking $@..."
	$(CC) -o $@ $^ $(TRACKER_LIBS)


SRC       += $(TRACKER_SRC)
BIN       += $(TRACKER_BIN)
HEADERS   += $(TRACKER_HEADERS)

TOOLS_DIST    += $(TRACKER_SRC) $(TRACKER_HEADERS) $(TRACKER_MISC) \
	$(TRACKER_MISCDIST)
TOOLS_BINDIST += $(TRACKER_BIN) $(TRACKER_MISCDIST)

