#! /usr/local/bin/tclsh

# List all requests.

source where.tcl

cgi_eval {
  set level [auth Bill "List requests"]

  cgi_body {
    import_default sortby "request_time"
    import_default period
    import_default select_from
    import_default select_to
    import_default start_time  "1000-01-01"
    import_default end_time    "9999-12-31"

    if {$period == ""} {
      set plist [sql "SELECT DISTINCT period FROM requestlog WHERE period is not NULL ORDER BY period"]
      h1 "Select billing period"
      foreach p $plist {
        maplist $p period
        p [url [lindex $period 0] [cgi_cgi Bill [cgi_set period $period]]]
      }
    } else {
      h1 "Charges for $for ([lindex $period 0] bill)"

      set rlist [sql "SELECT unix_timestamp(request_time),request_url,charge,bye FROM requestlog WHERE period='$period' and sip_from = 'sip:$for' ORDER BY request_time"] 
      set ri 0
      set total_charges 0
      set total_duration 0
      table {
        table_row {
          th "Call began"
          th "Duration (hh:mm:ss)"
          th "Destination"
          th "Charge"
        }
        foreach r $rlist {
          maplist $r request_time request_url charge bye_id
          set bye [sql "SELECT unix_timestamp(request_time) FROM requestlog WHERE id=$bye_id"]
          maplist [lindex $bye 0] bye_time
          set duration [expr $bye_time - $request_time]
          incr total_duration $duration
          set total_charges [expr $total_charges + $charge]
          table_row bgcolor=[lindex $bglist [expr $ri % 2]] {
            td [clock format $request_time]
            td [hhmmss $duration]
            td $request_url
            td align=right "\$$charge"
          }
          incr ri
        }
        table_row {
          td [bold "Total"]
          td [bold [hhmmss $total_duration]]
          td [blank]
          td align=right [bold "\$$total_charges"]
        }
      }
    }

    done
  }
}
