#! /usr/local/bin/tclsh

# Edit conference properties.

# Include the cinema libraries.
source where.tcl

set F(url)                   [list "Conference URL [small "(name or name@domain)"]" 1 text 30]
set F(owner)                 {"Owner"        2 hidden 0}
set F(password)              {"Password"     2 password 16}
set F(Description)           {"Description"  3 textarea {3 30}}
set F(start_time)            {"Start time"   4 datetime}
set F(end_time)              {"End time"     5 datetime}
set F(authentication)        {"Authentication"   6 select {none basic digest}}
set F(conference_type)       {"Conference type"  7 select {public restricted}}
set F(participant_list_type) {"Participant list" 8 select {public restricted}}
set F(max_participant_count) {"Max. number of participants" 9 text 3}
set F(media_allowed)         {"Media" 10 checkbox {audio video chat}}

cgi_eval {
  set level [auth ConfEdit "Conference Properties" 2]

  cgi_body {
    import_default op
    import_default url

    h1 "Editing Conference $url"

    # check if existing conference
    set fieldlist [array names F]
    if {$url != ""} {
      set c [sql "SELECT [join $fieldlist ,] FROM conferences WHERE url='$url'"]
      if {$c != ""} {
        maparray [lindex $c 0] $fieldlist C 
        if {$C(owner) != $for && $level < 3} {
          p "The conference is owned by $owner and cannot be edited by you."
          cgi_exit
        }
      } else {
        p "The conference $url does not exist."
      }
    }

    # enter conference information into database
    if {$op == "Edit"} {
      set q [tableforminput F]
      if {$url != ""} {
        sql "UPDATE conferences SET [join $q ,] WHERE url='$url'"
        h1 "Conference $url updated."
      } else {
        sql "INSERT conferences SET owner='$for',[join $q ,]"
        h1 "Created new conference $url. You can add users to the conference."
      }
    }

    # show form to edit conference parameters
    if {$op == "New" || $op == ""} {
      if {$op == ""} {
        set F(url) [lreplace $F(url) 2 2 "show"]
      }
      form ConfEdit name=ConfEdit {
        tableform "op=Edit" F C
      }
    }
    sql disconnect
  } 
}
