#! /usr/local/bin/tclsh

# sipconf conference listing

# Include the cinema libraries.
source where.tcl

source ConfUtil.tcl

cgi_eval {
  set level [auth ConfList "List Conferences" 2]

  cgi_body {
    import_default op

    h1 "Conference List for $for"

    set confcount 0
    table border=1 {
      table_row {
        th "Conference <br> URL [small "(Click to edit)"]"
        th "Owner"
        th "Description"
        th "Duration"
        th "Access"
        th "Size"
        th "Media"
        th "Delete?"
      }
      foreach row [sql "SELECT url,owner,description,
             start_time,end_time,
             authentication,conference_type,
             participant_list_type,media_allowed,
             max_participant_count,password 
             FROM conferences ORDER BY url"] {
        maplist $row url owner description start_time end_time authentication conference_type participant_list_type media_allowedList max_participant_count password
        incr confcount
        table_row valign=top bgcolor=[lindex $bglist [expr $confcount % 2]] {
          td [url $url [cgi_cgi ConfEdit [cgi_set url $url] [cgi_set for $for]]]
          td [url $owner [cgi_cgi UserShow [cgi_set for $for]] target=UserShow]
          td [blank $description]
          table_data {
            if {$start_time == "0000-00-00 00:00:00" &&
                  $end_time == "9999-12-31 00:00:00" } {
              puts "always on"; cgi_br
            } else {
              if {$start_time == "0000-00-00 00:00:00"} {
                puts "No start time."; cgi_br
              } else {
                puts "From $start_time"; cgi_br
              }

              if {$end_time == "9999-12-31 00:00:00"} {
                puts "Never ends."; cgi_br
              } else {
                puts "to $end_time"; cgi_br
              }
            }
          }
          table_data {
            puts "[url "$conference_type" "[cgi_cgi ConfMembers [cgi_set for $for] [cgi_set confurl "$url"]]"]"
            cgi_br
            if {$authentication != "none" } {
              puts "$authentication authentication required"; cgi_br
            }
          }
          table_data {
            if {$max_participant_count == "NULL"} {
              puts "no limit"
            } else {
              puts "$max_participant_count"
            }
          }
          td "$media_allowedList"
          td [url [imglink Delete] [cgi_cgi ConfDelete [cgi_set for $user] [cgi_set url $url]]]
        } 
      }
    }

    p "Click [url "here" [cgi_cgi ConfEdit [cgi_set op add_new_conference]]]
to setup a new conference."

    sql disconnect

  }
}
