#! /usr/local/bin/tclsh

# sipconf conference participant list
# Changes can be made by the moderator, the admin and owner of the conference.

source where.tcl

cgi_eval {
  set level [auth ConfMembers "Conference Participants" 2]

  cgi_body {
    import_default confurl "#"
    import_default op
    import_default user

    h1 "Conference Membership for [url $confurl [cgi_cgi ConfEdit [cgi_set url $confurl]] target=ConfEdit]"
    set F(user)      {"Member"     1 url        {UserShow user}}  
    set FF(user)     {"Member"     1 text       20}  
    set F(privilege) {"Privileges" 2 checkbox_v {send receive admin}}
    set F(type)      {"Type"       3 select     {dialin dialout}}
    set F(status)    {"Status"     4 show       {notconnected connected}}
    set F(audio)     {"Audio"      5 select     {off send receive send-receive}}
    set F(video)     {"Video"      6 select     {off send receive send-receive}}
    set fieldlist [array names F]
    set F(delete)    {"Delete"     7 url_hidden {ConfMembers {op Delete} user confurl}}
    set F(for)       {"for"        8 hidden     ""}
    set F(confurl)   {"confurl"    9 hidden     ""}

    if {$op == "Delete"} {
      p "Member $user deleted."
      sql "DELETE FROM confusers WHERE user='$user' AND confurl='$confurl'"
    } elseif {$op == "Add"} {
      set q [tableforminput F [concat $fieldlist confurl]]
      if {[sql "SELECT user FROM confusers \
            WHERE user='$user' AND confurl='$confurl'"] == ""} {
        sql "INSERT confusers SET [join $q ,]"
        p "Member $user added to conference [join $q ,]."
      } else {
        p "Member $user already in conference."
      }
    } elseif {$op == "Update"} {
      set q [tableforminput F {privilege type status audio video}]
      sql "UPDATE confusers SET [join $q ,]
         WHERE user='$user' AND confurl='$confurl'"
      p "Member $user modified [join $q ,]."
    }

    # for public listing
    set L(user)      {"Member"     1 show       20}  
    set L(privilege) {"Privileges" 2 show       {send receive admin}}
    set L(type)      {"Type"       3 show       {dialin dialout}}
    set L(status)    {"Status"     4 show       {notconnected connected}}
    set L(audio)     {"Audio"      5 show       {off send receive send-receive}}
    set L(video)     {"Video"      6 show       {off send receive send-receive}}

    set status()             [imglink No]
    set status(connected)    [imglink Registered]
    set status(notconnected) [imglink No]

    set conf [sql "SELECT description,owner,participant_list_type
                FROM conferences WHERE url='$confurl'"]
    maplist [lindex $conf 0] description owner participant_list_type

    set members [sql "SELECT [join $fieldlist ,]
                FROM confusers WHERE confurl='$confurl' ORDER BY user"]
    set V(for)     $for
    set V(confurl) $confurl

    # check if 'for' is member
    set ismember [sql "SELECT privilege FROM confusers
       WHERE confurl='$confurl' AND user='$for'"]

    set wpriv [expr $level > 2 || [string equal $owner "$for"] || [lsearch $ismember admin] >= 0]
    set rpriv [expr $wpriv || [string equal $participant_list_type "public"]]

    # table that allows editing
    if {$rpriv} {
      table {
        tableheader F 
        set count 0
        foreach m $members {
          set bgcolor [lindex $bglist [expr $count % 2]]
          maparray $m $fieldlist V
          set V(delete) [imglink Delete] 
          set V(status) $status($V(status))
          if {$wpriv} {
            tablehform ConfMembers $bgcolor op=Update F V
          } else {
            tablehform ConfMembers $bgcolor "" L V
          }
          incr count
        }
        # add new member if admin or owner or have admin privileges
        if {$wpriv} {
          foreach f $fieldlist {
            set V($f) ""
          }
          set V(delete) ""
          set V(status) ""
          set F(user) $FF(user)
          set bgcolor [lindex $bglist [expr $count % 2]]
          tablehform ConfMembers $bgcolor op=Add F V
        } 
      }
      if {$wpriv} {
        p "You $for can also add users from the 
        [url "address book" [cgi_cgi PersonList [cgi_set for $for]]]."
      }
    }
  }
}
