#! /usr/local/bin/tclsh

# Edit the sipd configuration file.

source where.tcl

cgi_eval {
  cgi_body {
    cgi_input

    import_default what  "sipd"
    import_default where "."

    if {[lsearch {sipd cinema sipum} $what] >= 0} {
      set f $what
    } else {
      p "Invalid configuration $what."
      cgi_exit
    }

    # read the current configuration file
    source config-${f}.tcl
    config ${where}/${f}.conf

    h1 "$what Configuration"

    # form
    form ConfigWrite {
      cgi_export what
      cgi_export where
      table border=1 {
        foreach item $c {
          set v        [lindex $item 0]
          set d        [lindex $item 1] 
          set t        [lindex $item 2]
          set p        [lindex $item 3]
          set def      [lindex $item 4]
          set instance [lindex $item 5]

          table_row {
            td [url [bold $v] ${manurl}${what}.html\#$v target=man]
            td $d
            set vv ${v}${instance}
            if {[info exists $vv]} {
              set value [set $vv]
            } else {
              set value $def
            }
            table_data {
              if {$t == "string" || $t == "integer" || $t == "file" || $t == "directory" || $t == "email" || $t == "p_url"} {
                cgi_text $vv=$value size=$p
              } elseif {$t == "enum"} {
                cgi_select $vv {
                  foreach a $p {
                    cgi_option $a selected_if_equal=$value
                  }
                }
              }
            }
          }
        }
        table_row {
          table_data colspan=2 align=center {submit_button "=Change $what configuration"}
        }
      } 
    }

    cgi_exit
  }
}
