#! /usr/local/bin/tclsh

# Log in form; set cookie as hidden variable in form, so that server can tell
# whether the client has cookies.

source where.tcl

cgi_input
cgi_eval {
  cgi_head {
    validate_user_script
    cgi_script language=JavaScript {
      cgi_puts {
        var expires = new Date()
        var today   = new Date()

        function setCookie(name, value, expire) {
          document.cookie = name + "=" + escape(value)
          + ((expire == null) ? "" : ("; expires=" + expire.toGMTString()))
        }

        function getCookie(Name) {
          var search = Name + "="
          if (document.cookie.length > 0) {
            offset = document.cookie.indexOf(search)
            if (offset != -1) {
              offset += search.length;
              end = document.cookie.indexOf(";", offset)
              if (end == -1)
                end = document.cookie.length
              return unescape(document.cookie.substring(offset,end))
            }
          } 
        } 
        expires.setTime(today.getTime() + 86400000*365)

        function login(f) {
          setCookie("cinema_user", f.user.value, expires)
          setCookie("cinema_pw",   f.password.value, expires)
          f.cookies.value = hascookies
          if (f.password.value.length == 0) {
            window.alert("Password missing")
            return false
          } else {
            return true
          }
        }
        setCookie("Cinema", "test", expires)
      }
    }
  }
  cgi_body {
    banner
    h1 "Login"
    import_default user

    cgi_script language=JavaScript {
      cgi_puts {
        if (!getCookie("Cinema")) {
          document.write("<b>Cookies are currently disabled in your browser. You must enable cookies to use this system.</b>")
          hascookies = false;
        } else {
          hascookies = true;
        }
      }
    }
    cgi_noscript {
      p [bold "JavaScript must be enabled in your browser to use this system."]
    }

    form index name=form "onSubmit=return login(this);" {
      table {
        cgi_export cookies=
        table_row {
          td "User name ([italic user@domain]):"
          table_data {
            cgi_text user=$user type=text size=30 "onChange=validate_user(this);"
          }
        }
        table_row {
          td "Password:"
          table_data {
            cgi_text password= type=password size=30
          }
        }
        table_row {
          table_data {
            submit_button =Login
          }
        }
      }
    }
  }
}
