#! /usr/local/bin/tclsh

# Write new script.

source where.tcl

cgi_eval {
  set level [auth ScriptEdit "Edit or create a user script"]
  cgi_body {
    import_default disposition  "#"
    import_default script       ""
    import_default content_type "#"

    # uploaded file
    set serverfn [cgi_import_filename -server scriptfile]
    set clientfn [cgi_import_filename -client scriptfile]

    set dispositionlist {sip-cgi cpl}
    set content_type_list {application/java application/perl application/tcl application/sh}
    if {[lsearch $dispositionlist $disposition] < 0} {
      p "Only dispositions $dispositionlist are supported."
      cgi_exit
    }

    # check valid 'for'
    if {[regexp $for {/\.}]} {
      p "$for is not a valid user."
      cgi_exit
    }

    # get the script directory
    scriptbase

    if {![file exists ${ScriptBase}/$for]} {
      if {[catch {file mkdir ${ScriptBase}/$for} msg]} {
        p "$msg"
        cgi_exit
      }
    }
    if {![file exists ${ScriptBase}/$for/$disposition]} {
      if {[catch {file mkdir ${ScriptBase}/$for/$disposition} msg]} {
        p "$msg"
        cgi_exit
      }
    }

    if {[catch {set f [open ${ScriptBase}/$for/$disposition/CONTENT-TYPE "WRONLY CREAT"]} msg]} {
      p "$msg"
      cgi_exit
    } else {
      puts $f $content_type
      close $f
    }

    # script file, either via file upload or via normal form input
    if {[string length $clientfn]} {
      p "Uploaded $clientfn script."
      if {[catch {file copy -force $serverfn ${ScriptBase}/$for/$disposition/SCRIPT} msg]} {
        p "$msg"
        cgi_exit
      }
      catch {file delete $serverfn}
    } else {
      if {[catch {set f [open ${ScriptBase}/$for/$disposition/SCRIPT "WRONLY CREAT"]} msg]} {
        p "$msg"
        cgi_exit
      }
      puts $f $script
      close $f
    }

    p "Script $disposition for $for modified ($content_type)."
  }
}
