#! /usr/local/bin/tclsh

# Edit or create a user script.

source where.tcl

cgi_eval {
  set level [auth ScriptForm "Edit or create a user script"]
  cgi_body {
    import_default disposition "#"

    set dispositionlist {sip-cgi cpl}
    set content_type_list {application/java application/perl application/tcl application/sh}
    if {[lsearch $dispositionlist $disposition] < 0} {
      p "Only types $dispositionlist are supported."
      cgi_exit
    }

    # check valid 'for'
    if {[regexp $for {/\.}]} {
      p "$for is not a valid user."
      cgi_exit
    }

    # read the current sipd configuration file to get ScriptBase
    scriptbase

    set ct ""
    if {[file readable ${ScriptBase}/$for/$disposition/CONTENT-TYPE]} {
      set ct [catfile ${ScriptBase}/$for/$disposition/CONTENT-TYPE]
    }
    set script ""
    if {[file readable ${ScriptBase}/$for/$disposition/SCRIPT]} {
      set script [catfile ${ScriptBase}/$for/$disposition/SCRIPT]
    }

    h1 "Edit $disposition script for $for"
    form ScriptEdit enctype=multipart/form-data {
      cgi_export for
      cgi_export disposition
      table {
        table_row {
          td "Type of script:"
          table_data {
            cgi_select content_type {
              foreach c $content_type_list {
                cgi_option $c selected_if_equal=$ct
              }
            }
          }
        }
        table_row {
          td "Script file:"
          table_data {cgi_file_button scriptfile}
        }
        table_row {
          td "Script:"
          table_data {
            cgi_textarea script=$script rows=20 cols=72
          }
        }
        table_row {
          td [blank]
          table_data {submit_button "=Edit"}
        }
      }
    }

    cgi_exit
  }
}
