#! /usr/local/bin/tclsh

# Form for editing single tariff 

source where.tcl

cgi_eval {
  set level [auth TariffForm "Edit tariff" 3]

  cgi_body {
    import_default id "#"

    h1 "Edit Tariff $id"

    set flist {valid_from valid_to gwclass rate daytime_start daytime_end prefix increment}
    set t [sql "SELECT [join $flist ,] FROM tariff WHERE id='$id'"]
    maparray [lindex $t 0] $flist T
    set GWCLASS [sql "SELECT gwclass FROM gwclass ORDER BY gwclass"]

    set F(prefix)        {"Prefix (e.g., +1 or +49, use ? to match any number)" 1 text 6}
    set F(gwclass)       [list "User class" 2 select [concat [list ""] $GWCLASS]]
    set F(valid_from)    {"Valid from (YYYY-MM-DD)"  3 text 16} 
    set F(valid_to)      {"Valid until (YYYY-MM-DD)" 4 text 16}
    set F(rate)          {"Rate (\$) per increment"  5 text 4}
    set F(daytime_start) {"Daily start time"         6 text 8}
    set F(daytime_end)   {"Daily end time"           7 text 8}
    set F(increment)     {"Billing increment (s)"    8 text 2}

    form TariffEdit {
      cgi_export id
      tableform action=Edit F T
    }

    sql disconnect
  }
}
