#! /usr/local/bin/tclsh

# Check if user already exists or not.

source where.tcl

cgi_eval {
  set level [auth UploadForm "Upload the greetings"]

  cgi_body {
    global VMAILUSERDIR

    banner

    if {$level < 1 || ![localuser $for]} {
      cgi_exit
    }

    if {![info exists VMAILUSERDIR] || $VMAILUSERDIR == "" } {
      p "Voice Mail is not installed."
      cgi_exit
    }

    # get current user information
    set u [sql "SELECT busy,noresponse FROM put WHERE user = '$for'"]
    maplist [lindex $u 0] busy noresponse

    import_default busyfile             ""
    import_default noresponsefile       ""

    if { $busyfile != "" } {
        # Update the busy and noresponse files.
        set thisuser [userpart $for]
        
        if { [llength $busyfile] == 2 && [lindex $busyfile 1] != "" } {
            set busyfile [lindex $busyfile 1]

            set server [cgi_import_filename -server "busyfile"]
            set client [cgi_import_filename -client "busyfile"]
            set type   [cgi_import_filename -type   "busyfile"]
            set filename [file tail $client]
            if {[string length $client]} {
                if {[catch {file rename -- $server "$VMAILUSERDIR/$thisuser/$filename"} msg] == 0 } { 
                    p "Uploaded $client as rtsp://SERVER/$thisuser/$filename"
                    set busy "rtsp://SERVER/$thisuser/$filename"
                    # update user
                    sql "UPDATE put SET \
                            busy='$busy'\
                            WHERE user='$for'"
                } else {
                    p "Could not move: $msg"
                    catch {file delete -- $server}
                }
            } else {
                p "File $client is empty"
            }
        }
    }
    if { $noresponsefile != "" } {
        # Update the busy and noresponse files.
        set thisuser [userpart $for]
        
        if { [llength $noresponsefile] == 2 && [lindex $noresponsefile 1] != "" } {
            set noresponsefile [lindex $noresponsefile 1]

            set server [cgi_import_filename -server "noresponsefile"]
            set client [cgi_import_filename -client "noresponsefile"]
            set type   [cgi_import_filename -type   "noresponsefile"]
            set filename [file tail $client]
            if {[string length $client]} {
                if {[catch {file rename -- $server "$VMAILUSERDIR/$thisuser/$filename"} msg] == 0 } { 
                    p "Uploaded $client as rtsp://SERVER/$thisuser/$filename"
                    set noresponse "rtsp://SERVER/$thisuser/$filename"
                    # update user
                    sql "UPDATE put SET \
                            noresponse='$noresponse'\
                            WHERE user='$for'"
                } else {
                    p "Could not move: $msg"
                    catch {file delete -- $server}
                }
            } else {
                p "File $client is empty"
            }
        }
    }

    form UploadForm enctype=multipart/form-data onsubmit="return validate_pw_user(this.user,this.pass,this.pass1)" {
      table {
        cgi_export for=$for
        
        if {$level > 1 || [lsearch $sip_groupList voicemail] >= 0} {
          table_row {
            table_data { 
                puts "URL for forwarding busy calls (typically, RTSP):"
            }
            table_data {
                puts "Current value: [bold $busy]"
                cgi_br
                cgi_file_button busyfile size=30
            }
          }
          table_row {
            table_data {
                puts "URL for forwarding calls when no response (typically, RTSP):"
            }
            table_data {
                puts "Current value: [bold $noresponse]"
                cgi_br
                cgi_file_button noresponsefile size=30
            }
          }
        }
        table_row {
          td ""
          table_data {submit_button "=Change"}
        }
      }
    }

    footer $for
    sql disconnect
  } 
}
