#! /usr/local/bin/tclsh

# Delete the user given.

source where.tcl

# Extract the user name from user@host
proc extractuserid {userhost} {
    set uh [split $userhost @ ]
    return [lindex $uh 0]
}

cgi_eval {
  global VMAILUSERDIR 

  set level [auth UserDeleteConfirmed "Delete user"]

  cgi_body {
    import_default form
    import_default Action "No"

    if {$Action == "Yes"} {
      h1 "Deleting $for"

      if {$level < 1} {
        p "Unknown account."
        cgi_exit
      }

      # Format other important links and variables
      set userid [extractuserid $for]

      # Format other important links and variables
      if {[info exists VMAILUSERDIR] && $VMAILUSERDIR != "" } {

        set topdir "$VMAILUSERDIR/$userid"

        if {$userid == ""} {
          p "Could not delete voicemail account for empty userid"
        } else {
          if {[catch {file delete -force -- "$VMAILUSERDIR/$userid"} msg] == 0 } {
            p "Deleted the voicemail account (if any)."
          } else {
            p "Could not delete voicemail account $userid: $msg"
          }
        }
      }
      # Voicemail  deleted.

      if {[catch {sql "DELETE FROM put WHERE user='$for'"} msg] == 0 } {
        p "Deleted $for from primary user table."
      } else {
        p "Could not delete $for from primary user table: $msg"
      }
      if {[catch {sql "DELETE FROM aliases WHERE primary_user='$for'"} msg] == 0} {
        p "Deleted $for from aliases table."
      } else {
        p "Could not delete $for from aliases table: $msg"
      }
      if {[catch {sql "DELETE FROM contacts WHERE user='$for'"} msg] == 0} {
        p "Deleted $for from contacts table."
      } else {
        p "Could not delete $for from contacts table: $msg"
      }

      # send email to user
      if {1} {
        cgi_mail_start $for
        cgi_mail_add "Subject: Your CINEMA account is deleted"
        cgi_mail_add      
        cgi_mail_add "Your CINEMA account $for has been deleted."
        if { [catch {cgi_mail_end} error] == 0 } {  
          p "Email notification has been sent to [bold $for]."
        } else {
          p "Could not send email notification about account deletion to $for."
          p "$error" 
        }
      }

      sql disconnect
    } 
    if {$form != ""} {
      form $form {
        cgi_export for=$for
        submit_button "=Return to form"
      }
    }
  }
}
