#! /usr/local/bin/tclsh

# Edit existing user.

source where.tcl

cgi_eval {
  set level [auth UserEditForm "Edit User Information" 2]

  cgi_body {
    import_default realm

    if {$for != ""} {
      h1 "Edit $for"
    } else {
      h1 "Create New User"
    }
    set V(for) $for

    # get current user information
    set fieldlist {email realm sip_groups gwclass auth algorithm
       hash_value sip_methods busy noresponse message_template um_timeout
       max_msgsize_kb}
    set u [sql "SELECT [join $fieldlist ,] FROM put WHERE user = '$for'"]
    maparray [lindex $u 0] $fieldlist V 

    set tmsg [cgi_buffer {
      table {
        table_row {
          td colspan=2 "Message template for unified messages. Templates can
             contain variables and functions:"
        }  
        table_row {
          td [typewriter \$user]
          td "userid"
        }
        table_row {
          td [typewriter \$to]
          td "SIP header field of call"
        }
        table_row {
          td [typewriter \$from]
          td "SIP header field of call"
        }
        table_row {
          td [typewriter \$name]
          td "SIP header field of call"
        }
        table_row {
          td [typewriter \$priority]
          td "SIP header field of call"
        }
        table_row {
          td [typewriter \$subject]
          td "SIP header field of call"
        }
        table_row {
          td [typewriter \$sipurl]
          td "URL for accessing the message via SIP"
        }
        table_row {
          td [typewriter \$httpurl]
          td "URL for accessing the message via HTTP"
        }
        table_row {
          td [typewriter \$rtspurl]
          td "URL for accessing the message via RTSP"
        }
        table_row {
          td [typewriter \$msgid]
          td "the random number of the message"
        }
        table_row {
          td [typewriter \$administrator]
          td "userid of the person running sipum"
        }
        table_row {
          td [typewriter "\[url [italic "name link"]\]"]
          td "generates link enclosing 'name'"
        }
        table_row {
          td [typewriter "\[email [italic uri]\]"]
          td "removes the scheme (if any) from the URI so
              that it looks like an email address"
        }
        table_row {
          td [typewriter "\[dataurl [italic "name uri"]\]"]
          td "creates a link for data URL by extracting the scheme from the URI and using data:application/scheme as the URL type."
        }
      }
    }]

    if {$for == "" || [regexp {^@} $for]} {
      set F(for)        [list "User identifier [italic (user@domain)]" \
                                                     1 text 50]
    } else {
      set F(for)        {"User identifier"           1 hidden 0}
    }
    set F(realm)        [list "Realm (prompt for user)<br>[small "Must supply password to change realm"]" \
                                                     2 text     50]
    set F(pass)         {"New password"              3 password 16}
    set F(pass1)        {"Reenter password for verification"
                                                     4 password 16}
    if {$MODE == "remote"} {
      set F(email)      {"Email address"             5 text     30}
    }
    set F(auth)         {"Callers must authenticate" 6 select   {never request required ""}}
    set F(algorithm)    {"Algorithm"                 7 select   {MD5 MD5-sess}}
    set F(sip_method)   {"SIP methods"               8 checkbox {REGISTER INVITE any}}
    if {$level > 2 || [lsearch $V(sip_groups) voicemail] >= 0} {
      set F(busy)           {"URL of announcement played when busy (typically, a RTSP URL)"
                                                     9 text     30}
      set F(noresponse)     {"URL of announcement played when no answer (typically, a RTSP URL; word SERVER is replaced by voicemail server)"
                                                    10 text     30}
      set F(message_template) [list $tmsg           11 textarea {20 60}]
      set F(um_timeout)     {"Timeout (seconds) until voicemail"
                                                    12 text     4}
      set F(max_msgsize_kb) {"Maximum size (in KB) for each message"
                                                    13 text     4} 
    }
    if {$level > 2} {
      set GWCLASS [sql "SELECT gwclass FROM gwclass ORDER BY gwclass"]
      set F(sip_groups)     [list "Privileges"      14 checkbox_v  $POLICY]
      set F(gwclass)        [list "Gateway class"   15 select  [concat [list ""] $GWCLASS]]
    }

    form UserEdit enctype=multipart/form-data onsubmit="return validate_pw_user(this.user,this.pass,this.pass1)" {
      tableform =Edit F V
    }              

    cgi_hr

    p "[url [imglink Scripts] [cgi_cgi Scripts [cgi_set for $for]]]"

    cgi_hr

    if {$for != ""} {
      form UserDelete {
        # Form to delete this user.
        p "If you delete your account all the information will be lost."
        cgi_export for=$for
        submit_button "=Delete this user"
      }
    }

    sql disconnect
  } 
}
