#! /usr/local/bin/tclsh

# List users in database.

source where.tcl

cgi_eval {
  set level [auth UserList "List CINEMA Users" 3]

  cgi_body {
    cgi_division id=overDiv "style=position:absolute; visibility:hidden; z-index:1000;" {}
    cgi_script "language=JavaScript" "src=overlib.js" {}
    import_default format
    import_default match "."

    h1 "CINEMA User List"

    p "The information for [bold default@domain] is used as the default template for new users."

    if {$match == ""} {
      set match "."
    }

    set usercount 0
    table border=1 {
      table_row {
        th "User name [small "(Click to edit)"]"
        if {$format == "long"} {
          th "Realm"
          th "Groups"
          th "Class"
          th "Authentication"
          th "Algorithm"
          th "SIP methods"
        }
        th colspan=2 "Aliases"
        th colspan=2 "Contacts"
        th "Delete?"
        th colspan=2 "Users that can register for this user"
        if {$format == "long"} {
          th "Last modified"
        }
      }
      set onMouseOut  "nd();"
      foreach row [sql "SELECT user,email,realm,sip_groups,gwclass,
             auth,algorithm,sip_methods,remote_user,
             DATE_FORMAT(last_modified,'%d %b %Y %H:%i')
             FROM put WHERE user REGEXP '$match' ORDER BY user"] {
        maplist $row user email realm sip_groups gwclass auth algorithm sip_methods remote_user last_modified
        incr usercount
        cgi_buffer_nl ""
        set text [cgi_buffer {
          table {
            table_row {
              td "Email:"
              td "$email"
            }
            table_row {
              td "Realm:"
              td "$realm"
            }
            table_row {
              td "Groups:"
              td "$sip_groups"
            }
            table_row {
              td "Gateway class:"
              td "$gwclass"
            }
            table_row {
              td "Authentication:"
              td "$auth"
            }
            table_row {
              td "Algorithm:"
              td "$algorithm"
            }
            table_row {
              td "SIP methods:"
              td "$sip_methods"
            }
            table_row {
              td "Last modified:"
              td "$last_modified"
            }
          }
        }]
        set onMouseOver "return overlib('$text')"
        table_row bgcolor=[lindex $bglist [expr $usercount % 2]] {
          td [url $user [cgi_cgi UserEditForm [cgi_set for $user]] onMouseOver=$onMouseOver onMouseOut=$onMouseOut]
          if {$format == "long"} {
            foreach col [lrange $row 1 6] {
              td [blank $col]
            }
          }
          set aliases [sql "SELECT alias FROM aliases WHERE primary_user='$user'"]
          if {$aliases != ""} {
            table_data {
              foreach a $aliases {
                maplist $a alias
                puts -nonewline $alias
                cgi_br
              }
            }
          } else {
            td [nbspace]
          }
          td [url [imglink Aliases] [cgi_cgi Aliases [cgi_set for $user]]]
          set contacts [sql "SELECT contact FROM contacts WHERE user='$user'"]
          if {$contacts != ""} {
            table_data {
              foreach c $contacts { 
                maplist $c contact
                puts -nonewline [url $contact $contact]
                cgi_br
              }
            }
          } else {
            td [nbspace]
          }
          td [url [imglink Contacts] [cgi_cgi Contacts [cgi_set for $user]]]
          td [url [imglink Delete] [cgi_cgi UserDelete [cgi_set for $user] [cgi_set form UserList]]]
          table_data {
            if {$remote_user == ""} {
              puts [nbspace]
            } else {
              foreach r $remote_user {
                set reg [sql "SELECT user FROM put WHERE user='$r'"]
                if {$reg == ""} {
                  puts -nonewline $r
                } else {
                  puts -nonewline [bold $r]
                }
                cgi_br
              }
            }
          }
          table_data {
            # only allow third party if local
            if {[lsearch $DOMAINS [domain $user]] >= 0} {
              puts [url [imglink ThirdParty] [cgi_cgi ThirdParty [cgi_set for $user]]]
            } else {
              puts [nbspace] 
            }
          }
          if {$format == "long"} {
            td $last_modified
          }
        } 
      }
    }

    p "$usercount users registered."
    sql disconnect
  }
}
