#! /usr/local/bin/tclsh

# Voice mail.

source where.tcl
source vmaildisplay.tcl

proc vmail_delete {dir msgList} {
  foreach m $msgList {
    if [catch {file delete -force -- $folderdir/$m} msg] {
      p "Cannot delete $dir/$m: $msg"
    }
  }
}

proc vmail_move {olddir newdir msgList} {
  foreach m $msgList {
    if [catch {file rename -force -- $olddir/$m $newdir} msg] {
      p "Cannot move $olddir/$m to $newdir: $msg"
    }
  }
}

cgi_eval {
  set level [auth Vmail "Voicemail" 2]

  import_default folder  "inbox"
  import_default from    ""
  import_default msgList ""
  import_default to      ""
  import_default change  ""
  import_default Action  ""
  import_default sort    "Date"

  cgi_body {
    checkfilename $folder
    set topdir    "$VMAILUSERDIR/[userpart $for]/"
    set folderdir "$topdir/$folder"

    # create the directory if not already created.
    if {![file exists $topdir]} {
      if {[catch {file mkdir "$topdir"} msg]} {
        p "Cannot create $topdir: $msg"
      } elseif {[catch {file mkdir "$topdir/inbox"} msg]} {
        p "Cannot create $topdir/inbox: $msg"
      } else {
        catch {file attributes $topdir -permissions 0700}
        catch {file attributes $topdir/inbox -permissions 0700}
        p "Created the voicemail home directory."
      }
    } else {
      if {[file type $topdir] != "directory" } {
        p "$topdir is not a directory. Report the problem."
      }
    }

    switch $Action {
      Change {set folder $change}
      Delete {vmail_delete $folderdir $msgList}
      Move {
        if {$to != "" && $from != ""} {
          vmail_move $topdir/$from $topdir/$to $msgList
        }
      }
    }

    vmaildisplay $folderdir $for $folder $sort
  } 
}
