# Check if email address is valid by checking if it has an MX record.
proc checkemail {email} {
  set emaildomain [lindex [split $email "@"] 1]
  if {$emaildomain == ""} {
    return "Invalid email address $email."
  }
  if {[checkdomain $emaildomain] == ""} {
    # see if 
    if {[file executable /usr/local/bin/host]} {
      if {[catch {set f [exec /usr/local/bin/host -t mx $emaildomain]} msg]} {
        return "$emaildomain: $msg"
      }
      if {[regexp "does not exist" $f]} {
        return $f
      }
    } else {
      return ""
    }
  }
}


# Check for validity of domain.
# Return "" if ok, text otherwise.
proc checkdomain {domain} {
  if {[regexp -nocase {^[A-Z0-9.-]+$} $domain] == 0} {
    return "$domain is not a valid domain name."
  }
  set tld [lindex [split $domain .] end]
  if {[llength [split $domain .]] < 2} {
    return "Cannot just use TLD in $domain."
  }

  if {[lsearch {com edu mil net org gov int \
ad af ag ai al am ao aq ar as at au aw az \
ba bb bd be bf bg bh bi bj bm bn bo br bs bt bv bw by bz \
ca cc cf cg ch cl cm cn co cr cu cv cx cy cz \
de dk dj dm \
es \
fi \
fr \
gr \
hk hr hu \
ie il in ir it \
jp \
kr \
lk lu \
mg mk mo mt mw mx \
nc ne ng ni nl no nu nz \
pa ph pl pn pt \
ru \
se sg si sk \
td th tn tr tw \
ua uk us za} $tld] < 0} {
    return "Top-level domain $tld not recognized in $domain."
  }
  return ""
}

package provide cinema 1.0
