# Check for validity of user name.
# or the tel: URL with a leading + sign.
# or an empty userid.
proc checkuser {u} {
  if {[regexp {^[A-Za-z0-9+-.]+@[A-Za-z0-9][.A-Za-z0-9-]+$} $u]} {
    if {[llength [split [domain $u] .]] < 2} {
      return "The domain part of $u must be fully qualified."
    }
  } elseif {[regexp {^tel:(\+)?[0-9]+} $u]} {
      return ""
  } elseif { $u != "" } {
    return "$u is not a valid user name of the form [italic user@domain]."
  }
  return "";
}

# Return 1 if it is a tel: URL or 0 otherwise.
proc telurl {u} {
    if {[regexp {^tel:\+[0-9]+} $u]} {
        return 1
    } else {
        return 0
    }
}

package provide cinema 1.0
