set h [split [info hostname] .]
set domain [join [lrange $h 1 end] .]

set c "
  {{SQL}
    {The SQL 'URL' for the user database, consisting of the user, password, host name and table name, e.g., sql://sipdb:secret@db.example.com/sip.}
    {string} {40} {sql://user:pw@host/sip}
  }
  {{DOMAINS}
    {The domain the server is responsible for.}
    {string} {40} {$domain}
  }
  {{MODE}
    {The mode of the server. Local servers serve users with local email accounts, while remote servers serve anybody.}
    {enum} {local remote} {local}
  }
  {{REALM}
    {The realm used in SIP prompting.}
    {string} {40} {$domain}
  }
  {{ADMINISTRATOR}
    {The email address of the administrator where bug email should be sent to.}
    {email} {40} {@$domain}
  }
  {{VMAILUSERDIR}
    {Top level directory under which all voicemail user accounts are maintained.}
    {directory} {40} {/usr/local/sipum/users}
  }
  {{VMAILHOST}
    {host name of the voice mail server.}
    {string} {40} {vmail.$domain}
  }
  {{SERVERROOT}
    {Directory for the sipd configuration files.}
    {directory} {40} {}
  }
"
