set c "
  {{CGITimeout}
    {Time, in seconds, that program waits for CGI script to return an answer.}
    {integer} {10} {15}
  }
  {{DefaultReg}
    {If a registration contains a Contact header that does not have an action parameter, fill in this action.}
    {enum} {proxy redirect} {redirect}
  }
  {{DisplayAmbiguous}
    {Should the server return the contacts list in case of ambiguous response (more than one match).}
    {enum} {true false} {false}
  }
  {{Domain}
    {A regular expression defining the domains that the server accepts registrations from. If the host part of the To header does not match the regular expression, the server returns a status of 404 (Not Found).}
    {string} {40} {}
  }
  {{ErrorLog}
    {File to which the server will log any errors. If the logfile does not begin with a slash (/), then it is assumed to be relative to the ServerRoot. If the logfile begins with a pipe (|) then it is assumed to be a command to spawn to handle the error log.  Using syslog instead of a filename enables logging via syslogd(8) if the system supports it. The filename stderr directs output to stderr. }
    {file} {40} {stderr}
  }
  {{Expires}
    {How long, in seconds, until registrations expire?}
    {integer} {5} {3600}
  }
  {{ForeignDomain}
    {If the request contains a URI with a domain that does not match the Domain regular expression, the server can either proxy the request, redirect it (possibly substituting the IP address for the host name) or reject the request.}
    {enum} {proxy redirect reject} {proxy}
  }
  {{GatewayMap}
    {A file describing a static map from telephone numbers to telephony gateways.  The format is similar to the dialplan map of canonicalize, with an additional second field listing a comma-separated set of gateway classes.  Every user registered in the database may have a gateway class assigned; only users in a particular class may access a gateway described by that class.  The special class * matches all classes, except the NULL class.}
    {file} {40} {}
  }
  {{Group}
    {The group under which the server will answer requests, either a name or \# followed by a group number.} 
    {string} {10} {nobody}
  }
  {{HelpResolve}
    {The server returns redirect responses with numeric (dotted-quad) IP addresses instead of host names, relieving the client from doing name resolution.}
    {enum} {true false} {false}
  }
  {{PidFile}
    {The file to which the server records the process id of the daemon. If the filename does not begin with a slash (/), then it is assumed to be relative to the ServerRoot.}
    {file} {40} {}
  }
  {{Port}
    {The port number the server listens on for both TCP and UDP.}
    {integer} {5} {5060}
  }
  {{ProxyName}
    {The hostname which this machine should put in its Via headers. Must be a name which DNS resolves to this server.}
    {string} {40} {}
  }
  {{ProxyRecursion}
    {Should the server recursively process 3xx-responses containing Contact headers with sip URI's when proxying, or just return 3xx responses to the originator the same way any other failure status would be returned?}
    {enum} {true false} {false}
  }
  {{LogFormat}
    {Format for first request log; see [url "man page" http://www.cs.columbia.edu/~hgs/software/cinema/sipd.html#RequestFormat target=man].}
    {string} {40} {} {}
  }
  {{LogCondition}
    {Request logging can be made conditional by specifying the status
     code and request method when the log entry below applies.  Specify
     as a comma-separated list, without spaces, e.g., 200,INVITE.}
    {string} {20} {} {}
  }
  {{RequestLog}
    {File name, format and restriction for the first request log.  If
    the name of the file starts with '|', it is assumed to be a program
    that will receive, via stdin, the log file output.  Names starting
    with '@' indicate syslog output, identified by facility.severity.}
    {file} {40} {} {}
  }
  {{LogFormat}
    {Format for a second request log, defined below. Leave blank if not needed.}
    {string} {40} {} {1}
  }
  {{LogCondition}
    {Conditions for the second request log; leave blank if all requests are to be logged.}
    {string} {20} {} {1}
  }
  {{RequestLog}
    {File name for a second request log; leave blank if not needed.}
    {file} {40} {} {1}
  }
  {{RecordRoute}
    {The flag determines whether the proxy server automatically inserts a <var>Record-Route</var> header in requests that it processes.}
    {enum} {true false} {true}
  }
  {{ScriptBase}
    {Directory for cgi and CPL scripts.}
    {directory} {40} {scripts}
  }
  {{ServerRoot}
    {Directory for the server configuration files. Also used for relative paths for logs and PID file.}
    {directory} {40} {.}
  }
  {{ServerName}
    {DNS name for which this server will accept registration. For example if this is 'example.com' then server will accept registration for \"sip:user@example.com\".}
    {string} {40} {}
  }
  {{ThirdPartyReg}
    {Are third parties allowed to register each other, or insist that users only register themselves?}
    {enum} {true false} {false}
  }
  {{UseThreadPool}
    {The system uses a pool of threads or just allocates new ones for each request.}
    {enum} {true false} {true}
  }
  {{ThreadPoolSize}
    {The number of threads to be included in the pool of worker threads.}
    {integer} {3} {128}
  }
  {{TimeOut}
    {Amount of time the server will wait for completion of a batch of proxied requests.}
    {integer} {5} {30}
  }
  {{User}
    {The userid as which the server will answer requests.}
    {string} {10} {} {}
  }
  {{UserConfig}
    {The SQL 'URL' for the user database, consisting of the user, password, host name and table name, e.g., sql://sipdb:secret@db.example.com/sip.}
    {p_url} {40} {sql://user:pw@host/sip}
  }
"
