# Configuration for unified messaging
set h [split [info hostname] .]
set domain [join [lrange $h 1 end] .]

vmailserver cisalpino.cs.columbia.edu:10022
rtspserver  marta.cs.columbia.edu:8554
httpserver  www.cs.columbia.edu
emaildomain cs.columbia.edu

onbusy      rtsp://SERVER/audio/welcome.au
noresponse  rtsp://SERVER/audio/welcome.au
topdir      /proj/irt-gc4/working/vmusers/LOGNAME/
msgfile     /proj/irt-gc4/working/vmusers/LOGNAME/inbox/MSGID.au
rtspmsgurl  rtsp://SERVER/LOGNAME/inbox/MSGID.au
httpmsgurl  http://www.cs.columbia.edu/~kns10/research/cinema
vmailhome   http://www.cs.columbia.edu/~kns10/research/cinema
register    LOGNAME@DOMAIN default
waittimeout 10
emailto     LOGNAME@DOMAIN
randomdigits 6
totalsize_KB  2000
max_msgsize_kb 1000

set c "
  {{vmailserver}
    {The server}
    {}
  }
  {{onbusy}
    {The SQL 'URL' for the user database, consisting of the user, password, host name and table name, e.g., sql://sipdb:secret@db.example.com/sip.}
    {string} {40} {sql://user:pw@host/sip}
  }
  {{noresponse}
    {The domain the server is responsible for.}
    {string} {40} {$domain}
  }
  {{topdir}
    {The mode of the server. Local servers serve users with local email accounts, while remote servers serve anybody.}
    {enum} {local remote} {local}
  }
  {{msgfile}
    {The realm used in SIP prompting.}
    {string} {40} {$domain}
  }
  {{rtspmsgurl}
    {The email address of the administrator where bug email should be sent to.}
    {email} {40} {@$domain}
  }
  {{httpmsgurl}
    {Top level directory under which all voicemail user accounts are maintained.}
    {directory} {40} {/usr/local/sipum/users}
  }
  {{vmailhome}
    {host name of the voice mail server.}
    {string} {40} {vmail.$domain}
  }
  {{waittimeout}
    {Directory for the sipd configuration files.}
    {directory} {40} {}
  }
"
