# Read configuration file in 'parameter value' format.
# skip lines starting with '#'
# Return -1 if error.
proc config {{file config}} {
  if {[catch {set fd [open $file r]} error]} {
    p "$error"
    return -1
  }

  while {[gets $fd line] >= 0} {
    set line [string trim $line]

    # skip comments and empty lines
    if {[string index $line 0] == "#" || [string length $line] == 0} {
      continue
    }


    # read line; if multiple instances, create var1, var2
    # multiple elements are treated as list elements
    set w [string wordend $line 0]
    set name [string trim [string range $line 0 $w]]
    if {[info exists already($name)]} {
      incr already($name)
      set varname ${name}$already($name)
    } else {
      set already($name) 0
      set varname $name
    }
    global $varname
    set $varname [string trim [string range $line $w end]]
  }  
}

package provide cinema 1.0
