#!/usr/local/bin/tclsh
# format message into lines of 72 characters or less
# do not touch lines starting with a period

# split paragraph into lines of 72 characters or less
proc fmt_para {para} {
  set out ""
  set line 0
  foreach word [split $para " \t\n"] {
    if {[string length $out] == 0} {
      set out "$word"
      set line [string length $word]
    } elseif {$line + [string length $word] < 72} {
      set out "$out $word"
      incr line [expr [string length $word] + 1]
    } else {
      set out "$out\n$word"
      set line [string length $word]
    }
  } 
  if {$out != ""} {
    return "$out\n"
  } else {
    return ""
  }
}

proc fmt {msg} {
  set m [split [string trim $msg] "\n"]
  set para ""
  set f ""

  foreach line $m {
    set line [string trim $line]
    if {[string index $line 0] == "."} {
      set f "$f[fmt_para $para][string range $line 1 end]\n"
      set para ""
    } elseif {[string length $line] == 0} {
      # blank line
      set f "$f[fmt_para $para]\n\n"
      set para ""
    } else {
      # add to paragraph
      set para "$para $line"
    }
  }
  if {$para != ""} {
    set f "$f[fmt_para $para]"
  }
  return $f
}

#puts "[fmt [read stdin]]"

package provide cinema 1.0
