# Check whether user is authorized to do this.  The 'needs' lists the
# properties the user needs to have.  'form' is the web form to
# authenticate. In non-administrative mode, an administrative password
# also works. If 'user' is "", present the login form.

proc login {form needs user pw {admin ""} {adminpw ""}} {
  # if 'needs' is "admin", we're in admin mode
  if {$needs == "admin"} {
    set user_field "admin"
    set pw_field   "adminpw"
    if {[set admin] == "" } { 
      set admin $user
      set adminpw $pw
    }
  } else {
    set user_field "user"
    set pw_field   "pw"
  }

  if {[set $user_field] == ""} {
    form $form {
      table {
        table_row {
          td "User name (user@domain):"
          table_data {cgi_text ${user_field}= size=30}
        }
        table_row {
          td "Password:"
          table_data {cgi_text ${pw_field}= type=password size=15}
        }
        table_row {
          table_data {submit_button =Login}
        }
      }
    }
    cgi_exit
  }

  # if administrator name is defined by caller of function, use it
  if {$admin != ""} {
    set user  $admin
    set pw    $adminpw
    set needs "admin"
  }

  set row [sql "SELECT realm,hash_value,sip_groups FROM put WHERE user='$user'"]
  if {[llength $row] == 0} {
    p "User [bold $user] is not a valid user."
    cgi_exit
  }
  maplist [lindex $row 0] realm hash_value sip_groups
  if {[hash $user $realm $pw] != $hash_value} {
    if {$pw != ""} {
      p "The password that you've entered is incorrect. Please try again."
    }
    form $form {
      cgi_export $user_field=$user
      puts "$realm"
      cgi_text $pw_field= type=password size=30
      submit_button =Login
    }
    sql disconnect
    cgi_exit
  }

  # check whether this user is privileged
  if {$needs != "" && [lsearch $sip_groups $needs] < 0} {
    p "The user $user is not authorized to perform this operation."
    sql disconnect
    cgi_exit
  }
}

package provide cinema 1.0
