# Columbia CINEMA project makefile fragment for web CGI scripts
# Copyright 1998-2001 by Columbia University; all rights reserved 

web_dir := $(topdir)/web

# Files imported by 'package require cinema', or miscellaneously sourced
# by the core scripts.
CINEMA_WEB_TCL_CORE := \
	$(web_dir)/auth.tcl \
	$(web_dir)/banner.tcl \
	$(web_dir)/checkemail.tcl \
	$(web_dir)/checkuser.tcl \
	$(web_dir)/config.tcl \
	$(web_dir)/fmt.tcl \
	$(web_dir)/gwclass_default.tcl \
	$(web_dir)/gwclass_list.tcl \
	$(web_dir)/import_default.tcl \
	$(web_dir)/localuser.tcl \
	$(web_dir)/login.tcl \
	$(web_dir)/printdate.tcl \
	$(web_dir)/opendb.tcl \
	$(web_dir)/randomword.tcl \
	$(web_dir)/usermenu.tcl \
        $(web_dir)/scriptbase.tcl \
	$(web_dir)/tarifflist.tcl \
	$(web_dir)/util.tcl \
	\
	$(web_dir)/where.tcl \
	$(web_dir)/config-cinema.tcl \
	$(web_dir)/pkgIndex.tcl

# The core CINEMA CGI scripts -- basic user manipulation
CINEMA_WEB_CORE := \
	$(web_dir)/Aliases.cgi \
	$(web_dir)/Config.cgi \
	$(web_dir)/ConfigWrite.cgi \
	$(web_dir)/ConfigureMenu.cgi \
	$(web_dir)/Logout.cgi \
	$(web_dir)/NewUser.cgi \
	$(web_dir)/UserDelete.cgi \
	$(web_dir)/UserDeleteConfirmed.cgi \
	$(web_dir)/UserEdit.cgi \
	$(web_dir)/UserEditForm.cgi \
	$(web_dir)/UserList.cgi \
	$(web_dir)/banner.cgi \
	$(web_dir)/blank.cgi \
	$(web_dir)/index.cgi \
	$(web_dir)/menu.cgi

# Images used by the core scripts
CINEMA_WEB_CORE_IMAGES := \
	$(web_dir)/cinema.gif \
	$(web_dir)/trash2d.gif \
	$(web_dir)/wrench.gif \
	$(web_dir)/passport.gif \
	$(web_dir)/people0a.gif \
	$(web_dir)/person_add.gif \
	$(web_dir)/page.gif \
	$(web_dir)/exit_emergency.jpg \
        $(web_dir)/button_help.gif \
        $(web_dir)/gui_conference.jpg \
        $(web_dir)/gui_login.jpg \
        $(web_dir)/gui_vmail.jpg \
        $(web_dir)/gui_menu.jpg

# Other files needed by the core
CINEMA_WEB_CORE_SUPPORT := \
        $(web_dir)/usermanual.html \
        $(web_dir)/usermanual.cgi \
	$(web_dir)/cinema.conf \
	$(web_dir)/overlib.js \
	$(web_dir)/wordlist

# CINEMA CGI scripts for proxying
CINEMA_WEB_SIPD := \
	$(web_dir)/Contacts.cgi \
	$(web_dir)/Gwclass.cgi \
	$(web_dir)/GwclassAdd.cgi \
	$(web_dir)/GwclassDelete.cgi \
	$(web_dir)/ThirdParty.cgi \
	\
	$(web_dir)/config-sipd.tcl

# Images used by proxying scripts
CINEMA_WEB_SIPD_IMAGES := \
	$(web_dir)/rolodex2.gif \
	$(web_dir)/tick_green.gif \
	$(web_dir)/register3.gif \
	$(web_dir)/permit.gif

# CINEMA CGI scripts for conferencing
CINEMA_WEB_SIPCONF := \
	$(web_dir)/ConfInfo.cgi \
	$(web_dir)/ConfList.cgi \
	$(web_dir)/ConfUtil.tcl	\
	$(web_dir)/PartList.cgi

# Images used by conferencing scripts
CINEMA_WEB_SIPCONF_IMAGES := \
	$(web_dir)/meeting12.gif

# CINEMA CGI scripts for voicemail/unified messaging
CINEMA_WEB_SIPUM := \
	$(web_dir)/UserVmail.cgi \
	$(web_dir)/vmail.cgi \
        $(web_dir)/UploadForm.cgi

# Images used by voicemail scripts
CINEMA_WEB_SIPUM_IMAGES := \
	$(web_dir)/voicemail1.gif \
	$(web_dir)/newmail.gif \
	$(web_dir)/emailicon.gif

# Tcl CGI sources
web_tcl_cgi_dir := $(web_dir)/cgi1.4.3
CINEMA_WEB_TCL_CGI := \
	$(web_tcl_cgi_dir)/README \
	$(web_tcl_cgi_dir)/cgi.tcl \
	$(web_tcl_cgi_dir)/pkgIndex.tcl

# Miscellaneous files needed for a source distribution
WEB_MISC := \
	$(web_dir)/module.mk \
	$(web_dir)/pkg


CINEMA_WEB_SIPD_BINDIST := \
	$(CINEMA_WEB_TCL_CORE) \
	$(CINEMA_WEB_CORE) \
	$(CINEMA_WEB_CORE_IMAGES) \
	$(CINEMA_WEB_CORE_SUPPORT) \
	$(CINEMA_WEB_SIPD) \
	$(CINEMA_WEB_SIPD_IMAGES) \
	$(CINEMA_WEB_TCL_CGI) \
	$(web_dir)/where.tcl.win32


CINEMA_WEB_SIPD_DIST := \
	$(CINEMA_WEB_SIPD_BINDIST) \
	$(WEB_MISC)

CINEMA_WEB_SIPUM_BINDIST := \
	$(CINEMA_WEB_TCL_CORE) \
	$(CINEMA_WEB_CORE) \
	$(CINEMA_WEB_CORE_IMAGES) \
	$(CINEMA_WEB_CORE_SUPPORT) \
        $(CINEMA_WEB_SIPD) \
	$(CINEMA_WEB_SIPUM) \
	$(CINEMA_WEB_SIPUM_IMAGES) \
	$(CINEMA_WEB_SIPD_IMAGES) \
	$(CINEMA_WEB_TCL_CGI)

CINEMA_WEB_SIPUM_DIST := \
	$(CINEMA_WEB_SIPUM_BINDIST) \
	$(WEB_MISC)
