# Open MySQL database
# Return list: status message
proc opendb {} {
  global SQL

  if {[info exists SQL]} {
    regexp {sql://([0-9A-z]+)(:[0-9A-z-]+)*@([A-z0-9.-]+)/([A-z0-9.-]+)} $SQL g user pass host db
  } else {
    return {-5 "SQL variable is not defined"}
  }

  # get rid of colon
  if {$pass != ""} {
    set pass [string range $pass 1 end]
  } 

  # NULL is no password
  if { $pass == "NULL" } {
     set pass ""
  } 

  if {[catch {sql connect $host $user $pass} msg]} {
    puts stderr "Cannot connect to database server $host as user $user: $msg"
    return [list "-4" "Cannot connect to database server $host as user $user: $msg"]
  }
  if {[catch {sql selectdb $db} msg]} {
    puts stderr "Cannot select database $db: $msg"
    return [list "-4" "Cannot select database $db: $msg"]
  }
  return 0
}

package provide cinema 1.0
