# TCL routine to print the date/time. Date is printed in a shorter form,
# e.g., only day and time for this week's mail, only time for todays mail,
# only date for this months mail and year/month/date for older mails.
# Please update this routine if you would like a different format or
# policy for displaying the date/time of the message.
proc printdate {input} {
  set date $input

  # Get useful date/time information as integers.
  set s1 [clock scan $input]
  set s2 [clock seconds]
  set y1 [clock format $s1 -format "%Y"]
  set y2 [clock format $s2 -format "%Y"]
  set y [clock format $s1 -format "%m"]
  scan $y "%d" m1
  set y [clock format $s2 -format "%m"]
  scan $y "%d" m2
  set y [clock format $s1 -format "%U"]
  scan $y "%d" w1
  set y [clock format $s2 -format "%U"]
  scan $y "%d" w2
  set y [clock format $s1 -format "%j"]
  scan $y "%d" j1
  set y [clock format $s2 -format "%j"]
  scan $y "%d" j2
  set y [clock format $s1 -format "%d"]
  scan $y "%d" d1
  set y [clock format $s2 -format "%d"]
  scan $y "%d" d2
 
  if {$y1 == $y2} {
    #  Same year
    # puts "$j1,$j2"
    set x [ expr $j1 + 4 ]
    if {$x >= $j2} {  
      # Same past week 
      if {$j1 == $j2} {
        # Today: print hr:min:sec
        set date [clock format $s1 -format "%I:%M:%S %p"]
      } else {
        if {$j1 < $j2} {
          # Other day of past week: print day,hr:min
          set date [clock format $s1 -format "%a %I:%M %p"]
        } else {
          # Date is in future.
          set date [clock format $s1 -format "%b %d, %Y; %I:%M:%S %p (future)"]
        }   
      }
    } else {
      if { $m1 == $m2 } {
        # Same month: print date,hr:min
        set date [clock format $s1 -format "%a %d, %I %p"]
      } else {
        # Print: month, date, 
        set date [clock format $s1 -format "%b %d"]
      }
    }
  } else {
    # Print year:month,date
    set date [clock format $s1 -format "%b %d, %Y"]
  }
  return $date
}

package provide cinema 1.0
