proc tarifflist {level sortby} {
  global bglist

  set hlist {
    {prefix        "Prefix"}
    {gwclass       "User class"}
    {valid_from    "Valid from"}
    {valid_to      "to"}
    {"60/increment*rate" "$/minute"}
    {daytime_start "Daily from"}
    {daytime_end   "to"}
    {increment     "increment (sec)"}
  }

  # get list
  form TariffEdit {
    table {
      table_row {
        foreach h $hlist {
          if {$sortby == [lindex $h 0]} {
            set bgcolor red
          } else {
            set bgcolor white
          }
          th bgcolor=$bgcolor [url [lindex $h 1] [cgi_cgi TariffList [cgi_set sortby [lindex $h 0]]]]
        }
      }
      set count 0
      foreach row [sql "SELECT id,valid_from,valid_to,gwclass,rate,daytime_start,daytime_end,prefix,increment FROM tariff ORDER BY $sortby"] {
        incr count
        maplist $row id valid_from valid_to gwclass rate daytime_start daytime_end prefix increment
        table_row bgcolor=[lindex $bglist [expr $count % 2]] {
          if {$level > 2} {
            td [url $prefix [cgi_cgi TariffForm [cgi_set id $id]]]
          } else {
            td $prefix
          }
          td [blank $gwclass]
          if {[llength $valid_from] == 2 && [lindex $valid_from 1] == "00:00:00"} {
            set valid_from [lindex $valid_from 0]
          }
          if {[llength $valid_to] == 2 && [lindex $valid_to 1] == "23:59:59"} {
            set valid_to [lindex $valid_to 0]
          }
          td $valid_from
          td $valid_to
          if {$increment > 0} {
            td [format "%.3f" [expr 60./$increment * $rate]]
          } else {
            td [format "%.3f" 0.0]
          }
          set ds [split $daytime_start :]
          if {[lindex $ds 2] == 0} {
            set daytime_start "[lindex $ds 0]:[lindex $ds 1]"
          }
          set de [split $daytime_end :]
          if {[lindex $de 2] == 59} {
            set daytime_end "[lindex $de 0]:[lindex $de 1]"
          }
          td $daytime_start
          td $daytime_end
          td align=right $increment
        }
      }

      # allow adding new tariff
      if {$level > 2} {
        set GWCLASS [sql "SELECT gwclass FROM gwclass ORDER BY gwclass"]
        table_row {
          table_data {cgi_text prefix=*                 size=6} 
          table_data {
            cgi_select gwclass {
              foreach g [concat [list ""] $GWCLASS] {
                cgi_option $g selected_if_equal=$gwclass
              }
            }
          }
          table_data {cgi_text valid_from=1999-01-01    size=10} 
          table_data {cgi_text valid_to=2002-12-31      size=10} 
          table_data {cgi_text minute=                  size=4} 
          table_data {cgi_text daytime_start=00:00      size=5} 
          table_data {cgi_text daytime_end=23:59        size=5} 
          table_data align=right {cgi_text increment=60 size=2}
          table_data {cgi_submit_button "=Add"}
        }
      }
    }
  }
}

package provide cinema 1.0
