/******************************** INCLUDES *****************************/
#include <stdio.h>
#include <thread.h>
#include <synch.h>
 
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
 
/* --------	DEFINES 		-------			*/

#define         QUE_NO_LIMIT    	-1
 
#define         MAXTHREADS              6
#define         NUM_WRITERS             1
#define         NUM_READERS             1
#define         NUMMSGS                 100
 


 
typedef struct _SEMA
{
        sema_t  sema; /* UI semaphores */
} SEMA;
 
typedef struct  _qmsg   QMSG;
struct _qmsg
{
        void    *pMsg;
        QMSG    *next;
};

typedef struct _queue
{
          int                           qMax; /* maximum number of msgs allowed on queue */
          mutex_t   qMutex; /* mutex guarding queue CS */
          SEMA                          qNotEmpty; /* readers block when no msg on queue */
          SEMA                          qNotFull; /* writers block when queue is full */
          QMSG                          *qMsgHead; /* ptr to first msg on queue */
          QMSG                          *qMsgTail; /* ptr to last msg on queue */
} QUEUE;

int     QueGet(QUEUE *, void **);
int     QuePut(QUEUE *, void *);
int     QueCreate(QUEUE *, int );
int     QueDestroy(QUEUE *);
int     QueEmpty(QUEUE *);
int     InsertMsgAtQueueTail(QUEUE *, void *);
QMSG    *RemoveMsgFromQueueHead(QUEUE *);

