#include "server.h"
#include <math.h>

extern u_long GetStream(u_long id);

int sf_read(int fd, char *pkt_buffer, u_32 pkt_size);
int sf_seek(int fd, Audio_filehdr *file_hdr, float start_time, int bytes_per_sample);

int OpenConnection(int s, struct sockaddr_in *cli_addr, int cli_port, int cli_len );
int CloseConnection(int s);
 
//////////////////////////////////////////////////////////////////////////////////////////

mutex_t		rtp_createMutex;

void *
rtcp_sender(void *argid)
{
int             s;
cond_t          cvp;
mutex_t         mp;
int             init_err, wait_err, Err_Msg ;
timestruc_t     to;
 
 
s=atoi((char *)argid);

mutex_init(&mp ,USYNC_THREAD,0);
 
init_err = cond_init(&cvp,USYNC_THREAD,0); // the third argument is ignored
 
if ( init_err == EINVAL || init_err == EFAULT) {
    printf("rtcp_sender(): Error >>cond_init() error occured ...") ;
    return(0);
}
 
 
mutex_init(&Stream[s].rtp_scheduleMutex ,USYNC_THREAD,0);
 
//printf("rtcp_sender(%d): I will start the while loop \n",Stream[s].id);
while( 1 ) {
 
   (void) mutex_lock(&mp);
// here you might want to protect the stream[s].tp with a mutex as
// well as in the RTP schedule
 
  mutex_lock(&Stream[s].rtcp_tMutex);
  to.tv_nsec=Stream[s].tp.tv_usec * 1000;
  to.tv_sec=Stream[s].tp.tv_sec + (long)(to.tv_nsec/1000000000);
  to.tv_nsec=(long)((Stream[s].tp.tv_usec * 1000)%1000000000);
  mutex_unlock(&Stream[s].rtcp_tMutex);

  while (1) {
     wait_err = cond_timedwait(&cvp, &mp, &to);
               // returns 0 after compl.succ.
 
     if ( wait_err == 0 ) {
           break;
     }
     if ( wait_err == ETIME){
       //  printf("etime --timeout\n");
           break;
     }
     if ( wait_err == EINVAL ){
        printf("einval --abstime(sec) >start_time of appl.+50,000,000\n");
      // break;
     }
     if ( wait_err == EFAULT){
          printf("efault --cvp or abstime points to an illegaladdr.\n");
      //  break;
     }
     if ( wait_err == EINTR ){
          printf("eintr --interrupted by a fork() or signal n");
      //  break;
     }
 
  }//end of while-wait
 
  (void) mutex_unlock(&mp);

  printf("Before the RTP Execute\n");
  mutex_lock(&Stream[s].rtp_scheduleMutex);
  Err_Msg = RTPExecute(Stream[s].cid, Stream[s].opaque);
  mutex_unlock(&Stream[s].rtp_scheduleMutex);
  printf("After the RTP Execute\n");
  
  if ( Err_Msg != RTP_OK ){
     printf("rtcp_sender(%d): %s\n",Stream[s].id, RTPStrError());
  }

 
}// end of while
}// end of rtcp_sender

int OpenConnection(s, cli_addr, cli_port,cli_len)
int s;  		//stream's index 
int cli_port;
struct sockaddr_in *cli_addr;
int     cli_len;

{
char  *index, *argid;
int thr_err, Err_Msg;
 

  argid=(char *)calloc(10, sizeof(char));
  if (argid == NULL){
    printf("OpenConnection(%d): Error>> Problem in malloc()\n", Stream[s].id);
    return(RTP_CANT_ALLOC_MEM);
  }
  sprintf(argid,"%d", s );

  index=(char *)calloc(10, sizeof(char));
  if (index == NULL){
    printf("OpenConnection(%d): Error>> Problem in malloc()\n", Stream[s].id);
    return(RTP_CANT_ALLOC_MEM);
  }

  sprintf(index,"%d", s );

  Stream[s].IPaddress = ntohl(cli_addr->sin_addr.s_addr);

  if ( cli_addr == NULL){
        printf("OpenConnection(%d): Error >> in the client address!\n", Stream[s].id);
        return(RTP_BAD_IP_VERSION);
  }
 
 
     Stream[s].marker = 1;
     Stream[s].cname = (char *)calloc(MAX_NAME ,(sizeof(char)));
     sprintf(Stream[s].cname,"%s", "maria@cs.columbia.edu");

     Stream[s].name = (char *)calloc(MAX_NAME ,(sizeof(char)));
     sprintf(Stream[s].name , "%s", "RTP server");
 
    mutex_init(&Stream[s].rtcp_tMutex ,USYNC_THREAD,0);
  
   mutex_lock(&rtp_createMutex);
   Err_Msg = RTPCreate(&(Stream[s].cid));
   mutex_unlock(&rtp_createMutex);


      
   if (Err_Msg != RTP_OK){
       printf("OpenConnection(%d): Error: %s\n",Stream[s].id,RTPStrError());
       return(Err_Msg);
   }

   /*Set client port id*/
   printf("The port number is %d\n", Stream[s].port);
   Err_Msg = RTPSessionSetPort(Stream[s].cid, Stream[s].port);
   if (Err_Msg != RTP_OK){
	printf("OpenConnection(%d): Error: %s\n",Stream[s].id,RTPStrError());
        return(Err_Msg);
   }

      /*set client IP address*/
   Err_Msg = RTPSessionSetAddr(Stream[s].cid, Stream[s].IPaddress);

   // Err_Msg = RTPSessionSetAddr(Stream[s].cid, ntohl(inet_addr("128.59.19.24")));

   if (Err_Msg != RTP_OK){
	printf("OpenConnection(%d): Error: %s\n",Stream[s].id,RTPStrError());
        return(Err_Msg);
   }
 
    /*set server c name*/
    Err_Msg = RTPMemberInfoSetSDES(Stream[s].cid, 0, RTP_MI_CNAME, Stream[s].cname);

    if (Err_Msg != RTP_OK){
	printf("OpenConnection(%d): Error: %s\n",Stream[s].id,RTPStrError());
        return(Err_Msg);
    }
 
    /*set server name*/
    Err_Msg = RTPMemberInfoSetSDES(Stream[s].cid, 0, RTP_MI_NAME, Stream[s].name);
    if (Err_Msg != RTP_OK){
	printf("OpenConnection(%d): Error: %s\n",Stream[s].id,RTPStrError());
        return(Err_Msg);
    }
  /*open RTP session*/
  Err_Msg = RTPOpenConnection(Stream[s].cid);
  if (Err_Msg != RTP_OK){
	printf("OpenConnection(%d): Error: %s\n",Stream[s].id,RTPStrError());
        return(Err_Msg);
   }
 
   RTPSessionSetUserInfo(Stream[s].cid, index);



   thr_err = thr_create(0, 0, rtcp_sender, (void *)argid, THR_BOUND, &threadId[nThread]);

   mutex_lock(&nThreadMutex);
    nThread++;
 
   mutex_unlock(&nThreadMutex);
 
 
   if (thr_err != 0 ){
       printf("OpenConnection(): Error>> Unable to create threads for the new stream\n");
 	return(RTP_CANT_ALLOC_MEM);
    }

    return(RTP_OK);

}//end of RTP_OpenStream()

int sf_read(int data_fd, char *pkt_buffer, u_32 pkt_size )
{
        int eof;
 
        if (read(data_fd, pkt_buffer, pkt_size) <= 0)
                eof = 1;        /*End of file*/
        else
                eof = 0;
 
        return(eof);
}

Readfile_hdr(int fd,  Audio_filehdr  *file_hdr, 
         u_32 *pkt_size, float *time_p, int32 *tsinc, int *bytes_per_sample)
{
int bps;

// Read in header from audio file
if ( read(fd, file_hdr, sizeof(Audio_filehdr)) <= 0) {
   printf("Cannot read header info \n");
  return(0);
}
 
if (file_hdr->sample_rate <= 0 ) {
   printf("Bad audio file sample rate!\n");
  return(0);
}

*pkt_size = 1000;
*bytes_per_sample = Get_BytesPerSample(file_hdr->encoding);
bps = *bytes_per_sample;
*tsinc = (*pkt_size)/bps * file_hdr->channels; 

*time_p = (float)(*pkt_size) /
            (file_hdr->sample_rate * (*bytes_per_sample) * file_hdr->channels);

printf("Time is %f\n", *time_p);
}

int Get_BytesPerSample(u_32 encoding)
{
int bytes_per_sample;

switch ( encoding ) {
case (AUDIO_FILE_ENCODING_MULAW_8 ):
    bytes_per_sample = 1;
    break;
case(AUDIO_FILE_ENCODING_LINEAR_8):
   bytes_per_sample = 1;
    break;
case(AUDIO_FILE_ENCODING_ALAW_8):
    bytes_per_sample = 1;
    break;
case(AUDIO_FILE_ENCODING_LINEAR_16):
    bytes_per_sample = 2;
    break;
default:
        bytes_per_sample = 1;
}
 
return(bytes_per_sample);
}

int Get_pti(u_32 encoding)
{
int pti;

switch(encoding) {
   case ( AUDIO_FILE_ENCODING_MULAW_8):
           pti = 0;
           break;
   case(AUDIO_FILE_ENCODING_ALAW_8):
           pti = 8;
           break;
   case(AUDIO_FILE_ENCODING_LINEAR_16):
           pti = 11;
           break;
   default:
           printf("File format not supported\n");
           return(RTP_BAD_PROFILE);
}

return(pti);
}



int sf_seek(int fd, Audio_filehdr *file_hdr , float start_time, int bytes_per_sample)
{
u_32 bytes, byte_position_start;
 
bytes = bytes_per_sample * file_hdr->channels *
                start_time * file_hdr->sample_rate;
 
byte_position_start = file_hdr->hdr_size + bytes;
 
lseek(fd, byte_position_start, SEEK_SET);
}
 

void RetrieveAndSend(int s, char *file, long start_time, long end_time)
{
float play_time, time_p;
int	numPacket;
int Err_Msg;
int wait_err;
char Packet[MAX_PACKET_SIZE];
int bytes_per_sample;
timestruc_t     to;
struct timeval  orig_play_req, tvend;
int32		tsinc;
int		fd;
Audio_filehdr   *file_hdr;
u_32            pkt_size;      
short int	pti;
double		x;
int		marker;

fd = sf_open( file );
if (fd <= 0 ){
   printf("RetrieveAndSend(%d): Error opening the file %s \n",Stream[s].id, file);
   sf_close(fd);
   return;
}

file_hdr = (Audio_filehdr *)malloc(sizeof(Audio_filehdr));
if (file_hdr == NULL){
	printf("RetrieveAndSend(%d): Error in malloc()\n",Stream[s].id);
	sf_close(fd);
	return;
}

Readfile_hdr( fd, file_hdr, &pkt_size, &time_p, &tsinc, &bytes_per_sample );
pti = Get_pti(file_hdr->encoding );

sf_seek(fd, file_hdr, start_time, bytes_per_sample);
numPacket= 0;    // number of packets (for this Play Req) have been retrieved and send
play_time = (float) start_time;
marker = 1;

gettimeofday(&orig_play_req, (struct timezone *)NULL);

//printf("RetrieveAndSend(%d): Time to start the real Retrieval/Send is (%ld:%ld):\n",Stream[s].id, orig_play_req.tv_sec,orig_play_req.tv_usec);



// WHILE YOU COMPLETE THE RETRIEVAL AND SENT OF THE PACKETS FOR A SPECIFIC REQUEST
while (1) {

   // we are done reading the file
  if ( play_time >  end_time ){
	printf("playtime =%f end_time =%ld\n",play_time,end_time);
      break;
  }

  // RETRIEVE THE DATA FROM THE FILE 

  if (sf_read(fd, Packet, pkt_size)) {
     printf("RetrieveAndSend(%d): end of file!\n", Stream[s].id);
     break;
  }
 
 // ADVANCE THE TIME
  play_time += time_p;
  numPacket++;

 // SET THE NPT TIME OF THE STREAM ACCORDINGLY

  mutex_lock( &Stream[s].nptMutex );
  Stream[s].NPT = (long)(play_time);
  // printf("The time is %ld\n", Stream[s].NPT);
  // CHECK IF THE RETRIEVAL HAS TO BE PAUSED 
  if ( Stream[s].NPT >= Stream[s].PauseTime && Stream[s].PauseSet == 1){
       printf("RetrievalProcess(%d): PAUSE IS ACTIVATED ! --must stop the retrieval NOW!\n",Stream[s].id);
       mutex_unlock(&Stream[s].nptMutex);
       break;
  }
  mutex_unlock(&Stream[s].nptMutex);

  // CHECK IF THE RETRIEVAL HAS TO BE STOPPED BECAUSE OF A TEARDOWN REQ
  mutex_lock( &Stream[s].stateMutex);
  if ( Stream[s].state == TEARDOWN_STATE){
       printf("RetrievalProcess(%d): TEARDOWN REQ RECEIVED! stop the retrieval NOW!\n",Stream[s].id);
       mutex_unlock(&Stream[s].stateMutex);
       break;
  }
  mutex_unlock( &Stream[s].stateMutex);
 
  // SLEEP FOR TIME time_p BEFORE YOU SEND THE PACKET
   
  (void) mutex_lock(&Stream[s].retrievMutex);
 
 
  x = orig_play_req.tv_sec + orig_play_req.tv_usec / 1000000.0 +
    numPacket * time_p;
  to.tv_sec  = (long)(floor(x));
  to.tv_nsec = (long)((x - floor(x)) * 1000000000.0);

 //printf("RetrieveAndSend(%d): Time to send the (%d)-packet (%ld:%ld):\n",Stream[s].id, numPacket, to.tv_sec,to.tv_nsec);
   while (1) {
      wait_err = cond_timedwait(&Stream[s].cvp_retr, &Stream[s].retrievMutex, &to);
                        // returns 0 after compl.succ.
 
      if ( wait_err == 0 ) {
        break;
       }
       if ( wait_err == ETIME){
    //            printf("etime --timeout\n");
                break;
        }
       if ( wait_err == EINVAL ){
                printf("einval --abstime(sec)(timep) >start_time of appl.+50,000,000\n");
 
               // break;
        }
       if ( wait_err == EFAULT){
                printf("efault --cvp or abstime points to an illegaladdr.\n");
        //        break;
       }
       if ( wait_err == EINTR ){
                printf("eintr --interrupted by a fork() or signal n");
        //      break;
        }
 
  }//end of while-wait
(void) mutex_unlock(&Stream[s].retrievMutex);

  // NOW READY TO SEND PACKET OF DATA TO THE CLIENT
  printf("Before the mutex at RTPSend\n");
  mutex_lock(&Stream[s].rtp_scheduleMutex);

  Err_Msg = RTPSend(Stream[s].cid, tsinc, marker, 
		              pti, Packet, pkt_size);
  if ( Err_Msg != RTP_OK ){
     printf("RetrieveAndSend(%d): %s\n",Stream[s].id, RTPStrError());
     mutex_unlock(&Stream[s].rtp_scheduleMutex);
     printf("After the mutex at RTPSend\n");
     // break;
  }
  mutex_unlock(&Stream[s].rtp_scheduleMutex);
     printf("After the mutex at RTPSend\n");

  marker = 0;

  }// end while
 

free(file_hdr);
sf_close(fd);
}


// Close session for this client
int CloseConnection(int s)
{
int Err_Msg;
 
// The following closes both the RTP and RTCP sockets for a multicast
// connection.

mutex_lock(&rtp_createMutex);
Err_Msg = RTPCloseConnection(Stream[s].cid);
mutex_unlock(&rtp_createMutex);


if ( Err_Msg != RTP_OK ){
   printf("CloseConnection(%d): Error>> %s\n",Stream[s].id, RTPStrError());
   return(Err_Msg);
}
else
   return(RTP_OK);

}

void RTPSchedule(context cid, int32 opaque, struct timeval *tp)
{
int s;
char index[10];
 
RTPSessionGetUserInfo(cid, (void **)&index);
if (index == NULL)
	return;

s = atoi(index);

if (s >=0 && s<STREAMS_NUM) {
        mutex_lock(&Stream[s].rtcp_tMutex);
        Stream[s].opaque=opaque;
        Stream[s].tp.tv_sec=tp->tv_sec;
        Stream[s].tp.tv_usec=tp->tv_usec;
	mutex_unlock(&Stream[s].rtcp_tMutex);

    }

   return;

}

int sf_open(char *file_name)
{
        return (open(file_name, O_RDONLY));
}

void sf_close(int data_fd)
{
        close(data_fd);
}

