/*
* RTSP server internal definitions.
*/

/******************************** INCLUDES *****************************/
#include <stdio.h>
#include <thread.h>
#include <synch.h>
#include <sys/time.h>
#include <sys/errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "rtsp_parser.h"
#include "audio.h"

/* --------  DEFINES  -------      */

#define QUE_NO_LIMIT      -1
 
#define THREADS_NUM             1000

#define NUM_WRITERS             1
#define NUM_READERS             1
#define NUMMSGS                 100
#define MSGSIZE                 2000
 
#define ACK_MSG_ERROR           -1



/* ---------  STATE OF A STREAM  ------- */ 

#define END_OF_PLAYBACK    3600
#define MAX_PATH_NAME    100
#define MAX_NAME    100


/* --------- DEFS -------  */

#define SERVER_HOST_ADDR        "128.59.20.77"
#define SERV_UDP_PORT   6000
#define MAXMESG 8192

#define    MAX_MSG_SIZE    200

/* ---------  TYPEDEFS ------ */
 
typedef struct _SEMA
{
        sema_t  sema; /* UI semaphores */
} SEMA;
 
typedef struct  _qmsg   QMSG;
struct _qmsg
{
  void    *pMsg;
  QMSG    *next;
};

typedef struct _queue
{
  int      qMax;      /* maximum number of msgs allowed on queue */
  mutex_t  qMutex;    /* mutex guarding queue CS */
  SEMA     qNotEmpty; /* readers block when no msg on queue */
  SEMA     qNotFull;  /* writers block when queue is full */
  QMSG     *qMsgHead; /* ptr to first msg on queue */
  QMSG     *qMsgTail; /* ptr to last msg on queue */
} QUEUE;

 
 
extern STREAM   Stream[ STREAMS_NUM ];
extern int      NextStreamId;
extern int      nThread;
extern mutex_t  nThreadMutex;
extern thread_t threadId[THREADS_NUM];


mutex_t  evt_scheduleMutex;
mutex_t  rtp_sendMutex;
mutex_t  NfdsMutex;
